/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../config ../occur ../keyboard/hash_handler ../lib/oop".split(" "),function(d,g){function c(){}d("../config");var h=d("../occur").Occur,e=[{name:"occurexit",bindKey:"esc|Ctrl-G",exec:function(a){var b=a.session.$occur;b&&(b.exit(a,{}),a.session.$occur||c.uninstallFrom(a))},readOnly:!0},{name:"occuraccept",bindKey:"enter",exec:function(a){var b=a.session.$occur;b&&(b.exit(a,{translatePosition:!0}),a.session.$occur||c.uninstallFrom(a))},readOnly:!0}],f=d("../keyboard/hash_handler").HashHandler;
d("../lib/oop").inherits(c,f);(function(){this.isOccurHandler=!0;this.attach=function(a){f.call(this,e,a.commands.platform);this.$editor=a};var a=this.handleKeyboard;this.handleKeyboard=function(b,c,d,e){return(b=a.call(this,b,c,d,e))&&b.command?b:void 0}}).call(c.prototype);c.installIn=function(a){var b=new this;a.keyBinding.addKeyboardHandler(b);a.commands.addCommands(e)};c.uninstallFrom=function(a){a.commands.removeCommands(e);var b=a.getKeyboardHandler();b.isOccurHandler&&a.keyBinding.removeKeyboardHandler(b)};
g.occurStartCommand={name:"occur",exec:function(a,b){var d=!!a.session.$occur;(new h).enter(a,b)&&!d&&c.installIn(a)},readOnly:!0}});