/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../token_iterator","../range"],function(h,l){var j=h("../token_iterator").TokenIterator,k=h("../range").Range;l.BracketMatch=function(){this.findMatchingBracket=function(a,b){if(0==a.column)return null;var d=b||this.getLine(a.row).charAt(a.column-1);if(""==d)return null;d=d.match(/([\(\[\{])|([\)\]\}])/);return!d?null:d[1]?this.$findClosingBracket(d[1],a):this.$findOpeningBracket(d[2],a)};this.getBracketRange=function(a){var b=this.getLine(a.row),d=!0,e=b.charAt(a.column-
1),e=e&&e.match(/([\(\[\{])|([\)\]\}])/);e||(e=b.charAt(a.column),a={row:a.row,column:a.column+1},e=e&&e.match(/([\(\[\{])|([\)\]\}])/),d=!1);if(!e)return null;if(e[1]){b=this.$findClosingBracket(e[1],a);if(!b)return null;a=k.fromPoints(a,b);d||(a.end.column++,a.start.column--);a.cursor=a.end}else{b=this.$findOpeningBracket(e[2],a);if(!b)return null;a=k.fromPoints(b,a);d||(a.start.column++,a.end.column--);a.cursor=a.start}return a};this.$brackets={")":"(","(":")","]":"[","[":"]","{":"}","}":"{"};
this.$findOpeningBracket=function(a,b,d){var e=this.$brackets[a],g=1,f=new j(this,b.row,b.column),c=f.getCurrentToken();c||(c=f.stepForward());if(c){d||(d=RegExp("(\\.?"+c.type.replace(".","\\.").replace("rparen",".paren").replace(/\b(?:end)\b/,"(?:start|begin|end)")+")+"));b=b.column-f.getCurrentTokenColumn()-2;for(c=c.value;;){for(;0<=b;){var i=c.charAt(b);if(i==e){if(g-=1,0==g)return{row:f.getCurrentTokenRow(),column:b+f.getCurrentTokenColumn()}}else i==a&&(g+=1);b-=1}do c=f.stepBackward();while(c&&
!d.test(c.type));if(null==c)break;c=c.value;b=c.length-1}return null}};this.$findClosingBracket=function(a,b,d){var e=this.$brackets[a],g=1,f=new j(this,b.row,b.column),c=f.getCurrentToken();c||(c=f.stepForward());if(c){d||(d=RegExp("(\\.?"+c.type.replace(".","\\.").replace("lparen",".paren").replace(/\b(?:start|begin)\b/,"(?:start|begin|end)")+")+"));for(b=b.column-f.getCurrentTokenColumn();;){for(var c=c.value,i=c.length;b<i;){var h=c.charAt(b);if(h==e){if(g-=1,0==g)return{row:f.getCurrentTokenRow(),
column:b+f.getCurrentTokenColumn()}}else h==a&&(g+=1);b+=1}do c=f.stepForward();while(c&&!d.test(c.type));if(null==c)break;b=0}return null}}}});