/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","ace/token_iterator"],function(s,h){s("ace/token_iterator");h.newLines=[{type:"support.php_tag",value:"<?php"},{type:"support.php_tag",value:"<?"},{type:"support.php_tag",value:"?>"},{type:"paren.lparen",value:"{",indent:!0},{type:"paren.rparen",breakBefore:!0,value:"}",indent:!1},{type:"paren.rparen",breakBefore:!0,value:"})",indent:!1,dontBreak:!0},{type:"comment"},{type:"text",value:";"},{type:"text",value:":",context:"php"},{type:"keyword",value:"case",indent:!0,
dontBreak:!0},{type:"keyword",value:"default",indent:!0,dontBreak:!0},{type:"keyword",value:"break",indent:!1,dontBreak:!0},{type:"punctuation.doctype.end",value:">"},{type:"meta.tag.punctuation.end",value:">"},{type:"meta.tag.punctuation.begin",value:"<",blockTag:!0,indent:!0,dontBreak:!0},{type:"meta.tag.punctuation.begin",value:"</",indent:!1,breakBefore:!0,dontBreak:!0},{type:"punctuation.operator",value:";"}];h.spaces=[{type:"xml-pe",prepend:!0},{type:"entity.other.attribute-name",prepend:!0},
{type:"storage.type",value:"var",append:!0},{type:"storage.type",value:"function",append:!0},{type:"keyword.operator",value:"="},{type:"keyword",value:"as",prepend:!0,append:!0},{type:"keyword",value:"function",append:!0},{type:"support.function",next:/[^\(]/,append:!0},{type:"keyword",value:"or",append:!0,prepend:!0},{type:"keyword",value:"and",append:!0,prepend:!0},{type:"keyword",value:"case",append:!0},{type:"keyword.operator",value:"||",append:!0,prepend:!0},{type:"keyword.operator",value:"&&",
append:!0,prepend:!0}];h.singleTags="!doctype area base br hr input img link meta".split(" ");h.transform=function(l,b,d){for(var b=l.getCurrentToken(),c=h.newLines,f=h.spaces,p=h.singleTags,e="",k=0,m=!1,q,g={},r,i={},n=!1,j="";null!==b;)if(console.log(b),b){"support.php_tag"==b.type&&"?>"!=b.value?d="php":"support.php_tag"==b.type&&"?>"==b.value?d="html":"meta.tag.name.style"==b.type&&"css"!=d?d="css":"meta.tag.name.style"==b.type&&"css"==d?d="html":"meta.tag.name.script"==b.type&&"js"!=d?d="js":
"meta.tag.name.script"==b.type&&"js"==d&&(d="html");if((i=l.stepForward())&&0==i.type.indexOf("meta.tag.name"))r=i.value;"support.php_tag"==g.type&&"<?="==g.value&&(m=!0);"meta.tag.name"==b.type&&(b.value=b.value.toLowerCase());"text"==b.type&&(b.value=b.value.trim());if(b.value){var j=b.value,a;for(a in f)if(b.type==f[a].type&&(!f[a].value||b.value==f[a].value)&&i&&(!f[a].next||f[a].next.test(i.value)))f[a].prepend&&(j=" "+b.value),f[a].append&&(j+=" ");0==b.type.indexOf("meta.tag.name")&&(q=b.value);
n=!1;for(a in c)if(b.type==c[a].type&&(!c[a].value||b.value==c[a].value)&&(!c[a].blockTag||-1===p.indexOf(r))&&(!c[a].context||c[a].context===d)){!1===c[a].indent&&k--;if(c[a].breakBefore&&(!c[a].prev||c[a].prev.test(g.value))){e+="\n";n=!0;for(a=0;a<k;a++)e+="\t"}break}if(!1===m)for(a in c)if(g.type==c[a].type&&(!c[a].value||g.value==c[a].value)&&(!c[a].blockTag||-1===p.indexOf(q))&&(!c[a].context||c[a].context===d)){!0===c[a].indent&&k++;if(!c[a].dontBreak&&!n){e+="\n";for(a=0;a<k;a++)e+="\t"}break}e+=
j;"support.php_tag"==g.type&&"?>"==g.value&&(m=!1);g=b;b=i;if(null===b)break}else b=i}else b=l.stepForward();return e}});