/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../line_widgets ../lib/dom ../range".split(" "),function(j,s){var t=j("../line_widgets").LineWidgets,m=j("../lib/dom"),p=j("../range").Range;s.showErrorMarker=function(a,k){var l=a.session;l.widgetManager||(l.widgetManager=new t(l),l.widgetManager.attach(a));var h=a.getCursorPosition(),b=h.row,e=l.widgetManager.getWidgetsAtRow(b).filter(function(a){return"errorMarker"==a.type})[0];e?e.destroy():b-=k;a:{var f=l.getAnnotations().sort(p.comparePoints);if(f.length){var c;
b:{c={row:b,column:-1};for(var g=p.comparePoints,i=0,j=f.length-1;i<=j;){var n=i+j>>1,q=g(c,f[n]);if(0<q)i=n+1;else if(0>q)j=n-1;else{c=n;break b}}c=-(i+1)}0>c&&(c=-c-1);c>=f.length?c=0<k?0:f.length-1:0===c&&0>k&&(c=f.length-1);if((g=f[c])&&k){if(g.row===b){do g=f[c+=k];while(g&&g.row===b);if(!g){b=f.slice();break a}}i=[];b=g.row;do i[0>k?"unshift":"push"](g),g=f[c+=k];while(g&&g.row==b);b=i.length&&i;break a}}b=void 0}if(b)e=b[0],h.column=(e.pos&&"number"!=typeof e.column?e.pos.sc:e.column)||0,h.row=
e.row,e=a.renderer.$gutterLayer.$annotations[h.row];else{if(e)return;e={text:["Looks good!"],className:"ace_ok"}}a.session.unfold(h.row);a.selection.moveToPosition(h);var d={row:h.row,fixedWidth:!0,coverGutter:!0,el:m.createElement("div"),type:"errorMarker"},b=d.el.appendChild(m.createElement("div")),f=d.el.appendChild(m.createElement("div"));f.className="error_widget_arrow "+e.className;h=a.renderer.$cursorLayer.getPixelPosition(h).left;f.style.left=h+a.renderer.gutterWidth-5+"px";d.el.className=
"error_widget_wrapper";b.className="error_widget "+e.className;b.innerHTML=e.text.join("<br>");b.appendChild(m.createElement("div"));var r=function(a,b,c){if(0===b&&("esc"===c||"return"===c))return d.destroy(),{command:"null"}};d.destroy=function(){a.$mouseHandler.isMousePressed||(a.keyBinding.removeKeyboardHandler(r),l.widgetManager.removeLineWidget(d),a.off("changeSelection",d.destroy),a.off("changeSession",d.destroy),a.off("mouseup",d.destroy),a.off("change",d.destroy))};a.keyBinding.addKeyboardHandler(r);
a.on("changeSelection",d.destroy);a.on("changeSession",d.destroy);a.on("mouseup",d.destroy);a.on("change",d.destroy);a.session.widgetManager.addLineWidget(d);d.el.onmousedown=a.focus.bind(a);a.renderer.scrollCursorIntoView(null,0.5,{bottom:d.el.offsetHeight})};m.importCssString("    .error_widget_wrapper {        background: inherit;        color: inherit;        border:none    }    .error_widget {        border-top: solid 2px;        border-bottom: solid 2px;        margin: 5px 0;        padding: 10px 40px;        white-space: pre-wrap;    }    .error_widget.ace_error, .error_widget_arrow.ace_error{        border-color: #ff5a5a    }    .error_widget.ace_warning, .error_widget_arrow.ace_warning{        border-color: #F1D817    }    .error_widget.ace_info, .error_widget_arrow.ace_info{        border-color: #5a5a5a    }    .error_widget.ace_ok, .error_widget_arrow.ace_ok{        border-color: #5aaa5a    }    .error_widget_arrow {        position: absolute;        border: solid 5px;        border-top-color: transparent!important;        border-right-color: transparent!important;        border-left-color: transparent!important;        top: -5px;    }",
"")});