/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../snippets ../autocomplete ../config ../lib/lang ../autocomplete/util ../autocomplete/text_completer ../editor ../config".split(" "),function(d,g){var c=d("../snippets").snippetManager,i=d("../autocomplete").Autocomplete,t=d("../config"),k=d("../lib/lang"),l=d("../autocomplete/util"),h=d("../autocomplete/text_completer"),m={getCompletions:function(a,b,e,c,d){if(b.$mode.completer)return b.$mode.completer.getCompletions(a,b,e,c,d);a=a.session.getState(e.row);b=b.$mode.getCompletions(a,
b,e,c);d(null,b)}},n={getCompletions:function(a,b,e,d,f){var g=c.snippetMap,h=[];c.getActiveScopes(a).forEach(function(a){for(var a=g[a]||[],b=a.length;b--;){var e=a[b],c=e.name||e.tabTrigger;c&&h.push({caption:c,snippet:e.content,meta:e.tabTrigger&&!e.name?e.tabTrigger+"\u21e5 ":"snippet",type:"snippet"})}},this);f(null,h)},getDocTooltip:function(a){"snippet"==a.type&&!a.docHTML&&(a.docHTML=["<b>",k.escapeHTML(a.caption),"</b><hr></hr>",k.escapeHTML(a.snippet)].join(""))}},f=[n,h,m];g.setCompleters=
function(a){f.length=0;a&&f.push.apply(f,a)};g.addCompleter=function(a){f.push(a)};g.textCompleter=h;g.keyWordCompleter=m;g.snippetCompleter=n;var p={name:"expandSnippet",exec:function(a){return c.expandWithTab(a)},bindKey:"Tab"},j=function(a,b){q(b.session.$mode)},q=function(a){var b=a.$id;c.files||(c.files={});r(b);a.modes&&a.modes.forEach(q)},r=function(a){if(a&&!c.files[a]){var b=a.replace("mode","snippets");c.files[a]={};t.loadModule(b,function(b){b&&(c.files[a]=b,!b.snippets&&b.snippetText&&
(b.snippets=c.parseSnippetFile(b.snippetText)),c.register(b.snippets||[],b.scope),b.includeScopes&&(c.snippetMap[b.scope].includeScopes=b.includeScopes,b.includeScopes.forEach(function(a){r("ace/mode/"+a)})))})}},s=function(a){var b=a.editor,c=b.completer&&b.completer.activated;"backspace"===a.command.name?c&&!l.getCompletionPrefix(b)&&b.completer.detach():"insertstring"===a.command.name&&(l.getCompletionPrefix(b)&&!c)&&(b.completer||(b.completer=new i),b.completer.autoInsert=!1,b.completer.showPopup(b))},
h=d("../editor").Editor;d("../config").defineOptions(h.prototype,"editor",{enableBasicAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:f),this.commands.addCommand(i.startCommand)):this.commands.removeCommand(i.startCommand)},value:!1},enableLiveAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:f),this.commands.on("afterExec",s)):this.commands.removeListener("afterExec",s)},value:!1},enableSnippets:{set:function(a){a?(this.commands.addCommand(p),
this.on("changeMode",j),j(null,this)):(this.commands.removeCommand(p),this.off("changeMode",j))},value:!1}})});