/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2013 Matthew Christopher Kastor-Inare III, Atropa Inc. Intl
 * All rights reserved.
 *
 * Contributed to Ajax.org under the BSD license.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./element_generator ./add_editor_menu_options ./get_set_functions ../../ace".split(" "),function(h,s,l){var i=h("./element_generator"),p=h("./add_editor_menu_options").addEditorMenuOptions,q=h("./get_set_functions").getSetFunctions;l.exports.generateSettingsMenu=function(f){function m(b,a,c,d){var e=document.createElement("div");e.setAttribute("contains",c);e.setAttribute("class","ace_optionsMenuEntry");e.setAttribute("style","clear: both;");e.appendChild(i.createLabel(c.replace(/^set/,
"").replace(/([A-Z])/g," $1").trim(),c));Array.isArray(d)?(a=i.createSelection(c,d,a),a.addEventListener("change",function(a){try{f.menuOptions[a.target.id].forEach(function(b){b.textContent!==a.target.textContent&&delete b.selected}),b[a.target.id](a.target.value)}catch(c){throw Error(c);}})):"boolean"===typeof d?(a=i.createCheckbox(c,d,a),a.addEventListener("change",function(a){try{b[a.target.id](!!a.target.checked)}catch(c){throw Error(c);}})):(a=i.createInput(c,d,a),a.addEventListener("change",
function(a){try{if("true"===a.target.value)b[a.target.id](!0);else if("false"===a.target.value)b[a.target.id](!1);else b[a.target.id](a.target.value)}catch(c){throw Error(c);}}));a.style.cssText="float:right;";e.appendChild(a);return e}function l(b,a,c,d){var e=f.menuOptions[b],g=a[d]();"object"==typeof g&&(g=g.$id);e.forEach(function(a){a.value===g&&(a.selected="selected")});return m(a,c,b,e)}var j=[];p(f);q(f).forEach(function(b){var a=b.functionName,c=b.parentObj,b=b.parentName,d,e=a.replace(/^set/,
"get");if(void 0!==f.menuOptions[a])j.push(l(a,c,b,e));else if("function"===typeof c[e])try{d=c[e](),"object"===typeof d&&(d=d.$id),j.push(m(c,b,a,d))}catch(g){}});j.sort(function(b,a){var c=b.getAttribute("contains"),d=a.getAttribute("contains");return c.localeCompare(d)});var k=document.createElement("div");k.setAttribute("id","ace_settingsmenu");j.forEach(function(b){k.appendChild(b)});var n=k.appendChild(document.createElement("div")),r=h("../../ace").version;n.style.padding="1em";n.textContent=
"Ace version "+r;return k}});