/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/keys","../lib/event"],function(g,i){var j=g("../lib/keys"),k=g("../lib/event"),h=function(a){this.$editor=a;this.$data={editor:a};this.$handlers=[];this.setDefaultHandler(a.commands)};(function(){this.setDefaultHandler=function(a){this.removeKeyboardHandler(this.$defaultHandler);this.$defaultHandler=a;this.addKeyboardHandler(a,0)};this.setKeyboardHandler=function(a){var b=this.$handlers;if(b[b.length-1]!=a){for(;b[b.length-1]&&b[b.length-1]!=this.$defaultHandler;)this.removeKeyboardHandler(b[b.length-
1]);this.addKeyboardHandler(a,1)}};this.addKeyboardHandler=function(a,b){if(a){"function"==typeof a&&!a.handleKeyboard&&(a.handleKeyboard=a);var c=this.$handlers.indexOf(a);-1!=c&&this.$handlers.splice(c,1);void 0==b?this.$handlers.push(a):this.$handlers.splice(b,0,a);-1==c&&a.attach&&a.attach(this.$editor)}};this.removeKeyboardHandler=function(a){var b=this.$handlers.indexOf(a);if(-1==b)return!1;this.$handlers.splice(b,1);a.detach&&a.detach(this.$editor);return!0};this.getKeyboardHandler=function(){return this.$handlers[this.$handlers.length-
1]};this.getStatusText=function(){var a=this.$data,b=a.editor;return this.$handlers.map(function(c){return c.getStatusText&&c.getStatusText(b,a)||""}).filter(Boolean).join(" ")};this.$callKeyboardHandlers=function(a,b,c,e){for(var d,f=!1,g=this.$editor.commands,h=this.$handlers.length;h--;)if((d=this.$handlers[h].handleKeyboard(this.$data,a,b,c,e))&&d.command)if((f="null"==d.command?!0:g.exec(d.command,this.$editor,d.args,e))&&(e&&-1!=a&&!0!=d.passEvent&&!0!=d.command.passEvent)&&k.stopEvent(e),f)break;
!f&&-1==a&&(d={command:"insertstring"},f=g.exec("insertstring",this.$editor,b));f&&this.$editor._signal&&this.$editor._signal("keyboardActivity",d);return f};this.onCommandKey=function(a,b,c){var e=j.keyCodeToString(c);this.$callKeyboardHandlers(b,e,c,a)};this.onTextInput=function(a){this.$callKeyboardHandlers(-1,a)}}).call(h.prototype);i.KeyBinding=h});