/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(m,h){function l(b){this.keymapping=this.$buildKeymappingRegex(b)}l.prototype={$buildKeymappingRegex:function(b){for(var a in b)this.$buildBindingsRegex(b[a]);return b},$buildBindingsRegex:function(b){b.forEach(function(a){a.key?a.key=RegExp("^"+a.key+"$"):Array.isArray(a.regex)?("key"in a||(a.key=RegExp("^"+a.regex[1]+"$")),a.regex=RegExp(a.regex.join("")+"$")):a.regex&&(a.regex=RegExp(a.regex+"$"))})},$composeBuffer:function(b,a,c,f){if(null==b.state||
null==b.buffer)b.state="start",b.buffer="";var e=[];a&1&&e.push("ctrl");a&8&&e.push("command");a&2&&e.push("option");a&4&&e.push("shift");c&&e.push(c);c=e.join("-");e=b.buffer+c;2!=a&&(b.buffer=e);b={bufferToUse:e,symbolicName:c};f&&(b.keyIdentifier=f.keyIdentifier);return b},$find:function(b,a,c,f,e,h){var g={};this.keymapping[b.state].some(function(d){var i;if(d.key&&!d.key.test(c)||d.regex&&!(i=d.regex.exec(a))||d.match&&!d.match(a,f,e,c,h))return!1;if(d.disallowMatches)for(var k=0;k<d.disallowMatches.length;k++)if(i[d.disallowMatches[k]])return!1;
if(d.exec){g.command=d.exec;if(d.params){var j;g.args={};d.params.forEach(function(a){j=null!=a.match&&null!=i?i[a.match]||a.defaultValue:a.defaultValue;"number"===a.type&&(j=parseInt(j));g.args[a.name]=j})}b.buffer=""}d.then&&(b.state=d.then,b.buffer="");null==g.command&&(g.command="null");return!0});if(g.command)return g;b.buffer="";return!1},handleKeyboard:function(b,a,c,f,e){-1==a&&(a=0);if(0!=a&&(""==c||c==String.fromCharCode(0)))return null;f=this.$composeBuffer(b,a,c,e);return f=this.$find(b,
f.bufferToUse,f.symbolicName,a,c,f.keyIdentifier)}};h.matchCharacterOnly=function(b,a,c){return 0==a?!0:4==a&&1==c.length?!0:!1};h.StateHandler=l});