/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/event ../lib/useragent ../lib/dom ../lib/lang".split(" "),function(j,E){var e=j("../lib/event"),g=j("../lib/useragent"),F=j("../lib/dom"),q=j("../lib/lang"),M=18>g.isChrome,N=g.isIE;E.TextInput=function(j,c){function i(a){if(!d){d=!0;if(k)c=0,a=a?0:b.value.length-1;else var c=a?2:1,a=2;try{b.setSelectionRange(c,a)}catch(f){}d=!1}}function l(){d||(b.value=h,g.isWebKit&&O.schedule())}function r(){clearTimeout(w);w=setTimeout(function(){m&&(b.style.cssText=m,m="");
null==c.renderer.$keepTextAreaAtCursor&&(c.renderer.$keepTextAreaAtCursor=!0,c.renderer.$moveTextAreaToCursor())},g.isOldIE?200:0)}var b=F.createElement("textarea");b.className="ace_text-input";g.isTouchPad&&b.setAttribute("x-palm-disable-auto-cap",!0);b.setAttribute("wrap","off");b.setAttribute("autocorrect","off");b.setAttribute("autocapitalize","off");b.setAttribute("spellcheck",!1);b.style.opacity="0";g.isOldIE&&(b.style.top="-1000px");j.insertBefore(b,j.firstChild);var h="\u0001\u0001",s=!1,
x=!1,d=!1,m="",t=!0;try{var n=document.activeElement===b}catch(E){}e.addListener(b,"blur",function(a){c.onBlur(a);n=!1});e.addListener(b,"focus",function(a){n=!0;c.onFocus(a);i()});this.focus=function(){if(m)return b.focus();var a=b.style.top;b.style.position="fixed";b.style.top="0px";b.focus();setTimeout(function(){b.style.position="";"0px"==b.style.top&&(b.style.top=a)},0)};this.blur=function(){b.blur()};this.isFocused=function(){return n};var P=q.delayedCall(function(){n&&i(t)}),O=q.delayedCall(function(){d||
(b.value=h,n&&i())});g.isWebKit||c.addEventListener("changeSelection",function(){c.selection.isEmpty()!=t&&(t=!t,P.schedule())});l();if(n)c.onFocus();var G=function(a){return 0===a.selectionStart&&a.selectionEnd===a.value.length};!b.setSelectionRange&&b.createTextRange&&(b.setSelectionRange=function(a,b){var c=this.createTextRange();c.collapse(!0);c.moveStart("character",a);c.moveEnd("character",b);c.select()},G=function(a){try{var b=a.ownerDocument.selection.createRange()}catch(c){}return!b||b.parentElement()!=
a?!1:b.text==a.value});if(g.isOldIE){var y=!1,p=function(a){if(!y){var c=b.value;if(!d&&c&&c!=h){if(a&&c==h[0])return z.schedule();A(c);y=!0;l();y=!1}}},z=q.delayedCall(p);e.addListener(b,"propertychange",p);var Q={13:1,27:1};e.addListener(b,"keyup",function(a){d&&(!b.value||Q[a.keyCode])&&setTimeout(u,0);if(129>(b.value.charCodeAt(0)||0))return z.call();d?B():H()});e.addListener(b,"keydown",function(){z.schedule(50)})}var k=null;this.setInputHandler=function(a){k=a};this.getInputHandler=function(){return k};
var v=!1,A=function(a){k&&(a=k(a),k=null);if(x){i();if(a)c.onPaste(a);x=!1}else if(a==h.charAt(0))v?c.execCommand("del",{source:"ace"}):c.execCommand("backspace",{source:"ace"});else if(a.substring(0,2)==h?a=a.substr(2):a.charAt(0)==h.charAt(0)?a=a.substr(1):a.charAt(a.length-1)==h.charAt(0)&&(a=a.slice(0,-1)),a.charAt(a.length-1)==h.charAt(0)&&(a=a.slice(0,-1)),a)c.onTextInput(a);v&&(v=!1)},C=function(a,b,c){if((a=a.clipboardData||window.clipboardData)&&!M){var e=N||c?"Text":"text/plain";try{return b?
!1!==a.setData(e,b):a.getData(e)}catch(d){if(!c)return C(d,b,!0)}}},I=function(a,d){var f=c.getCopyText();if(!f)return e.preventDefault(a);C(a,f)?(d?c.onCut():c.onCopy(),e.preventDefault(a)):(s=!0,b.value=f,b.select(),setTimeout(function(){s=!1;l();i();d?c.onCut():c.onCopy()}))},J=function(a){I(a,!0)},K=function(a){I(a,!1)},L=function(a){var d=C(a);if("string"==typeof d){if(d)c.onPaste(d,a);g.isIE&&setTimeout(i);e.preventDefault(a)}else b.value="",x=!0};e.addCommandKeyListener(b,c.onCommandKey.bind(c));
e.addListener(b,"select",function(){s?s=!1:G(b)?(c.selectAll(),i()):k&&i(c.selection.isEmpty())});e.addListener(b,"input",function(){d||(A(b.value),l())});e.addListener(b,"cut",J);e.addListener(b,"copy",K);e.addListener(b,"paste",L);(!("oncut"in b)||!("oncopy"in b)||!("onpaste"in b))&&e.addListener(j,"keydown",function(a){if((!g.isMac||a.metaKey)&&a.ctrlKey)switch(a.keyCode){case 67:K(a);break;case 86:L(a);break;case 88:J(a)}});var H=function(){!d&&(c.onCompositionStart&&!c.$readOnly)&&(d={},d.canUndo=
c.session.$undoManager,c.onCompositionStart(),setTimeout(B,0),c.on("mousedown",u),d.canUndo&&!c.selection.isEmpty()&&(c.insert(""),c.session.markUndoGroup(),c.selection.clearSelection()),c.session.markUndoGroup())},B=function(){if(d&&c.onCompositionUpdate&&!c.$readOnly){var a=b.value.replace(/\x01/g,"");d.lastValue!==a&&(c.onCompositionUpdate(a),d.lastValue&&c.undo(),d.canUndo&&(d.lastValue=a),d.lastValue&&(a=c.selection.getRange(),c.insert(d.lastValue),c.session.markUndoGroup(),d.range=c.selection.getRange(),
c.selection.setRange(a),c.selection.clearSelection()))}},u=function(a){if(c.onCompositionEnd&&!c.$readOnly){var e=d;d=!1;var f=setTimeout(function(){f=null;var a=b.value.replace(/\x01/g,"");d||(a==e.lastValue?l():!e.lastValue&&a&&(l(),A(a)))});k=function(a){f&&clearTimeout(f);a=a.replace(/\x01/g,"");if(a==e.lastValue)return"";e.lastValue&&f&&c.undo();return a};c.onCompositionEnd();c.removeListener("mousedown",u);"compositionend"==a.type&&e.range&&c.selection.setRange(e.range)}},D=q.delayedCall(B,
50);e.addListener(b,"compositionstart",H);g.isGecko?e.addListener(b,"text",function(){D.schedule()}):(e.addListener(b,"keyup",function(){D.schedule()}),e.addListener(b,"keydown",function(){D.schedule()}));e.addListener(b,"compositionend",u);this.getElement=function(){return b};this.setReadOnly=function(a){b.readOnly=a};this.onContextMenu=function(a){v=!0;i(c.selection.isEmpty());c._emit("nativecontextmenu",{target:c,domEvent:a});this.moveToMouse(a,!0)};this.moveToMouse=function(a,d){if(d||!g.isOldIE){m||
(m=b.style.cssText);b.style.cssText=(d?"z-index:100000;":"")+"height:"+b.style.height+";"+(g.isIE?"opacity:0.1;":"");var f=c.container.getBoundingClientRect(),i=F.computedStyle(c.container),h=f.top+(parseInt(i.borderTopWidth)||0),j=f.left+(parseInt(f.borderLeftWidth)||0),k=f.bottom-h-b.clientHeight-2,f=function(a){b.style.left=a.clientX-j-2+"px";b.style.top=Math.min(a.clientY-h-2,k)+"px"};f(a);"mousedown"==a.type&&(c.renderer.$keepTextAreaAtCursor&&(c.renderer.$keepTextAreaAtCursor=null),clearTimeout(w),
g.isWin&&!g.isOldIE&&e.capture(c.container,f,r))}};this.onContextMenuClose=r;var w,p=function(a){c.textInput.onContextMenu(a);r()};e.addListener(b,"mouseup",p);e.addListener(b,"mousedown",function(a){a.preventDefault();r()});e.addListener(c.renderer.scroller,"contextmenu",p);e.addListener(b,"contextmenu",p)}});