/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/dom ../lib/lang ../lib/useragent ../lib/event_emitter".split(" "),function(d,g){var h=d("../lib/oop"),e=d("../lib/dom"),f=d("../lib/lang"),i=d("../lib/useragent"),j=d("../lib/event_emitter").EventEmitter,c=0,k=g.FontMetrics=function(a){this.el=e.createElement("div");this.$setMeasureNodeStyles(this.el.style,!0);this.$main=e.createElement("div");this.$setMeasureNodeStyles(this.$main.style);this.$measureNode=e.createElement("div");this.$setMeasureNodeStyles(this.$measureNode.style);
this.el.appendChild(this.$main);this.el.appendChild(this.$measureNode);a.appendChild(this.el);c||this.$testFractionalRect();this.$measureNode.innerHTML=f.stringRepeat("X",c);this.$characterSize={width:0,height:0};this.checkForSizeChanges()};(function(){h.implement(this,j);this.$characterSize={width:0,height:0};this.$testFractionalRect=function(){var a=e.createElement("div");this.$setMeasureNodeStyles(a.style);a.style.width="0.2px";document.documentElement.appendChild(a);var b=a.getBoundingClientRect().width;
c=0<b&&1>b?50:100;a.parentNode.removeChild(a)};this.$setMeasureNodeStyles=function(a,b){a.width=a.height="auto";a.left=a.top="0px";a.visibility="hidden";a.position="absolute";a.whiteSpace="pre";8>i.isIE?a["font-family"]="inherit":a.font="inherit";a.overflow=b?"hidden":"visible"};this.checkForSizeChanges=function(){var a=this.$measureSizes();if(a&&(this.$characterSize.width!==a.width||this.$characterSize.height!==a.height)){this.$measureNode.style.fontWeight="bold";var b=this.$measureSizes();this.$measureNode.style.fontWeight=
"";this.$characterSize=a;this.charSizes=Object.create(null);this.allowBoldFonts=b&&b.width===a.width&&b.height===a.height;this._emit("changeCharacterSize",{data:a})}};this.$pollSizeChanges=function(){if(this.$pollSizeChangesTimer)return this.$pollSizeChangesTimer;var a=this;return this.$pollSizeChangesTimer=setInterval(function(){a.checkForSizeChanges()},500)};this.setPolling=function(a){a?this.$pollSizeChanges():this.$pollSizeChangesTimer&&(clearInterval(this.$pollSizeChangesTimer),this.$pollSizeChangesTimer=
0)};this.$measureSizes=function(){if(50===c){var a=null;try{a=this.$measureNode.getBoundingClientRect()}catch(b){a={width:0,height:0}}a={height:a.height,width:a.width/c}}else a={height:this.$measureNode.clientHeight,width:this.$measureNode.clientWidth/c};return 0===a.width||0===a.height?null:a};this.$measureCharWidth=function(a){this.$main.innerHTML=f.stringRepeat(a,c);return this.$main.getBoundingClientRect().width/c};this.getCharacterWidth=function(a){var b=this.charSizes[a];void 0===b&&(b=this.charSizes[a]=
this.$measureCharWidth(a)/this.$characterSize.width);return b};this.destroy=function(){clearInterval(this.$pollSizeChangesTimer);this.el&&this.el.parentNode&&this.el.parentNode.removeChild(this.el)}}).call(k.prototype)});