/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./oop","./event_emitter"],function(f,i){function e(a){"undefined"!=typeof console&&console.warn&&console.warn.apply(console,arguments)}function j(a,b){var c=Error(a);c.data=b;"object"==typeof console&&console.error&&console.error(c);setTimeout(function(){throw c;})}"no use strict";var g=f("./oop"),k=f("./event_emitter").EventEmitter,l={setOptions:function(a){Object.keys(a).forEach(function(b){this.setOption(b,a[b])},this)},getOptions:function(a){var b={};a?Array.isArray(a)||
(b=a,a=Object.keys(b)):a=Object.keys(this.$options);a.forEach(function(a){b[a]=this.getOption(a)},this);return b},setOption:function(a,b){if(this["$"+a]!==b){var c=this.$options[a];if(!c)return e('misspelled option "'+a+'"');if(c.forwardTo)return this[c.forwardTo]&&this[c.forwardTo].setOption(a,b);c.handlesSet||(this["$"+a]=b);c&&c.set&&c.set.call(this,b)}},getOption:function(a){var b=this.$options[a];return!b?e('misspelled option "'+a+'"'):b.forwardTo?this[b.forwardTo]&&this[b.forwardTo].getOption(a):
b&&b.get?b.get.call(this):this["$"+a]}},h=function(){this.$defaultOptions={}};(function(){g.implement(this,k);this.defineOptions=function(a,b,c){a.$options||(this.$defaultOptions[b]=a.$options={});Object.keys(c).forEach(function(b){var d=c[b];"string"==typeof d&&(d={forwardTo:d});d.name||(d.name=b);a.$options[d.name]=d;"initialValue"in d&&(a["$"+d.name]=d.initialValue)});g.implement(a,l);return this};this.resetOptions=function(a){Object.keys(a.$options).forEach(function(b){var c=a.$options[b];"value"in
c&&a.setOption(b,c.value)})};this.setDefaultValue=function(a,b,c){a=this.$defaultOptions[a]||(this.$defaultOptions[a]={});a[b]&&(a.forwardTo?this.setDefaultValue(a.forwardTo,b,c):a[b].value=c)};this.setDefaultValues=function(a,b){Object.keys(b).forEach(function(c){this.setDefaultValue(a,c,b[c])},this)};this.warn=e;this.reportError=j}).call(h.prototype);i.AppConfig=h});