/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(g,b){b.getDocumentHead=function(a){a||(a=document);return a.head||a.getElementsByTagName("head")[0]||a.documentElement};b.createElement=function(a,c){return document.createElementNS?document.createElementNS(c||"http://www.w3.org/1999/xhtml",a):document.createElement(a)};b.hasCssClass=function(a,c){return-1!==(a.className+"").split(/\s+/g).indexOf(c)};b.addCssClass=function(a,c){b.hasCssClass(a,c)||(a.className+=" "+c)};b.removeCssClass=function(a,c){for(var b=
a.className.split(/\s+/g);;){var d=b.indexOf(c);if(-1==d)break;b.splice(d,1)}a.className=b.join(" ")};b.toggleCssClass=function(a,c){for(var b=a.className.split(/\s+/g),d=!0;;){var f=b.indexOf(c);if(-1==f)break;d=!1;b.splice(f,1)}d&&b.push(c);a.className=b.join(" ");return d};b.setCssClass=function(a,c,e){e?b.addCssClass(a,c):b.removeCssClass(a,c)};b.hasCssString=function(a,c){var b=0,d,c=c||document;if(c.createStyleSheet&&(d=c.styleSheets))for(;b<d.length;){if(d[b++].owningElement.id===a)return!0}else if(d=
c.getElementsByTagName("style"))for(;b<d.length;)if(d[b++].id===a)return!0;return!1};b.importCssString=function(a,c,e){e=e||document;if(c&&b.hasCssString(c,e))return null;var d;c&&(a+="\n/*# sourceURL=ace/css/"+c+" */");e.createStyleSheet?(d=e.createStyleSheet(),d.cssText=a,c&&(d.owningElement.id=c)):(d=b.createElement("style"),d.appendChild(e.createTextNode(a)),c&&(d.id=c),b.getDocumentHead(e).appendChild(d))};b.importCssStylsheet=function(a,c){if(c.createStyleSheet)c.createStyleSheet(a);else{var e=
b.createElement("link");e.rel="stylesheet";e.href=a;b.getDocumentHead(c).appendChild(e)}};b.getInnerWidth=function(a){return parseInt(b.computedStyle(a,"paddingLeft"),10)+parseInt(b.computedStyle(a,"paddingRight"),10)+a.clientWidth};b.getInnerHeight=function(a){return parseInt(b.computedStyle(a,"paddingTop"),10)+parseInt(b.computedStyle(a,"paddingBottom"),10)+a.clientHeight};b.scrollbarWidth=function(a){var c=b.createElement("ace_inner");c.style.width="100%";c.style.minWidth="0px";c.style.height=
"200px";c.style.display="block";var e=b.createElement("ace_outer"),d=e.style;d.position="absolute";d.left="-10000px";d.overflow="hidden";d.width="200px";d.minWidth="0px";d.height="150px";d.display="block";e.appendChild(c);a=a.documentElement;a.appendChild(e);var f=c.offsetWidth;d.overflow="scroll";c=c.offsetWidth;f==c&&(c=e.clientWidth);a.removeChild(e);return f-c};"undefined"==typeof document?b.importCssString=function(){}:(void 0!==window.pageYOffset?(b.getPageScrollTop=function(){return window.pageYOffset},
b.getPageScrollLeft=function(){return window.pageXOffset}):(b.getPageScrollTop=function(){return document.body.scrollTop},b.getPageScrollLeft=function(){return document.body.scrollLeft}),b.computedStyle=window.getComputedStyle?function(a,c){return c?(window.getComputedStyle(a,"")||{})[c]||"":window.getComputedStyle(a,"")||{}}:function(a,c){return c?a.currentStyle[c]:a.currentStyle},b.setInnerHtml=function(a,c){var b=a.cloneNode(!1);b.innerHTML=c;a.parentNode.replaceChild(b,a);return b},"textContent"in
document.documentElement?(b.setInnerText=function(a,b){a.textContent=b},b.getInnerText=function(a){return a.textContent}):(b.setInnerText=function(a,b){a.innerText=b},b.getInnerText=function(a){return a.innerText}),b.getParentWindow=function(a){return a.defaultView||a.parentWindow})});