/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(j,f){var e={},g=function(){this.propagationStopped=!0},h=function(){this.defaultPrevented=!0};e._emit=e._dispatchEvent=function(d,b){this._eventRegistry||(this._eventRegistry={});this._defaultHandlers||(this._defaultHandlers={});var a=this._eventRegistry[d]||[],c=this._defaultHandlers[d];if(a.length||c){if("object"!=typeof b||!b)b={};b.type||(b.type=d);b.stopPropagation||(b.stopPropagation=g);b.preventDefault||(b.preventDefault=h);for(var a=a.slice(),
e=0;e<a.length&&!(a[e](b,this),b.propagationStopped);e++);if(c&&!b.defaultPrevented)return c(b,this)}};e._signal=function(d,b){var a=(this._eventRegistry||{})[d];if(a)for(var a=a.slice(),c=0;c<a.length;c++)a[c](b,this)};e.once=function(d,b){var a=this;b&&this.addEventListener(d,function i(){a.removeEventListener(d,i);b.apply(null,arguments)})};e.setDefaultHandler=function(d,b){var a=this._defaultHandlers;a||(a=this._defaultHandlers={_disabled_:{}});if(a[d]){var c=a[d],e=a._disabled_[d];e||(a._disabled_[d]=
e=[]);e.push(c);c=e.indexOf(b);-1!=c&&e.splice(c,1)}a[d]=b};e.removeDefaultHandler=function(d,b){var a=this._defaultHandlers;if(a){var c=a._disabled_[d];a[d]==b?c&&this.setDefaultHandler(d,c.pop()):c&&(a=c.indexOf(b),-1!=a&&c.splice(a,1))}};e.on=e.addEventListener=function(d,b,a){this._eventRegistry=this._eventRegistry||{};var c=this._eventRegistry[d];c||(c=this._eventRegistry[d]=[]);if(-1==c.indexOf(b))c[a?"unshift":"push"](b);return b};e.off=e.removeListener=e.removeEventListener=function(d,b){this._eventRegistry=
this._eventRegistry||{};var a=this._eventRegistry[d];if(a){var c=a.indexOf(b);-1!==c&&a.splice(c,1)}};e.removeAllListeners=function(d){this._eventRegistry&&(this._eventRegistry[d]=[])};f.EventEmitter=e});