/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("../../test/mockdom"));
define("require exports module ../../multi_select ../../test/assertions ../../range ../../editor ../../edit_session ../../test/mockrenderer ../javascript ../xml".split(" "),function(c,l,f){c("../../multi_select");var d=c("../../test/assertions");c("../../range");var g=c("../../editor").Editor,i=c("../../edit_session").EditSession,h=c("../../test/mockrenderer").MockRenderer,j=c("../javascript").Mode,k=c("../xml").Mode,b,a=function(a,d,c){do b.commands.exec(a,b,c);while(1<d--)};f.exports={"test: cstyle":function(){function c(a){d.equal(b.getValue(),
Array(4).join(a+"\n"))}function e(a,c,e){b.selection.rangeList.ranges.forEach(function(b){d.range(b,a,c,a,c);a+=e||1})}var f=new i(["","","",""],new j);b=new g(new h,f);b.setOption("behavioursEnabled",!0);b.navigateFileStart();a("addCursorBelow",2);a("insertstring",1,"if ");a("insertstring",1,"(");c("if ()");e(0,4);a("insertstring",1,")");c("if ()");e(0,5);a("gotoleft",1);a("insertstring",1,"[");c("if ([])");e(0,5);a("insertstring",1,"]");c("if ([])");e(0,6);a("gotoleft",1);a("backspace",1);c("if ()");
e(0,4);a("gotolineend",1);a("insertstring",1,"{");c("if (){}");e(0,6);a("insertstring",1,"}");c("if (){}");e(0,7);a("gotolinestart",1);a("insertstring",1,"(");c("(if (){}");a("backspace",1);b.setValue("");a("insertstring",1,"{");d.equal(b.getValue(),"{");a("insertstring",1,"\n");d.equal(b.getValue(),"{\n    \n}");b.setValue("");a("insertstring",1,"(");a("insertstring",1,'"');a("insertstring",1,'"');d.equal(b.getValue(),'("")');a("backspace",1);a("insertstring",1,'"');d.equal(b.getValue(),'("")');
b.setValue("('foo')",1);a("gotoleft",1);a("selectleft",1);a("selectMoreBefore",1);a("insertstring",1,"'");d.equal(b.getValue(),"('foo')");a("selectleft",1);a("insertstring",1,'"');d.equal(b.getValue(),'("foo")');a("selectleft",1);a("insertstring",1,'"');d.equal(b.getValue(),'("foo")');b.setValue("",1);a("selectleft",1);a("insertstring",1,'"');d.equal(b.getValue(),'""');a("insertstring",1,"\\");a("insertstring",1,"n");a("insertstring",1,'"');d.equal(b.getValue(),'"\\n"')},"test: xml":function(){b=
new g(new h);b.setValue("<OuterTag>\n    <SelfClosingTag />");b.session.setMode(new k);a("golinedown",1);a("gotolineend",1);a("insertstring",1,"\n");d.equal(b.session.getLine(2),"    ");a("gotolineup",1);a("gotolineend",1);a("insertstring",1,"\n");d.equal(b.session.getLine(2),"    ");b.session.setValue("<OuterTag\n    <xyzrt");a("golinedown",1);a("gotolineend",1);a("selectleft",3);a("insertstring",1,">");d.equal(b.session.getLine(1),"    <xy></xy>")}}});
"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();