/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/lang"],function(l,m){var n=l("../lib/lang"),k=function(){this.$rules={start:[{token:"empty_line",regex:"^$"},{defaultToken:"text"}]}};(function(){this.addRules=function(d,b){if(b)for(a in d){for(var f=d[a],e=0;e<f.length;e++){var c=f[e];if(c.next||c.onMatch)"string"==typeof c.next&&0!==c.next.indexOf(b)&&(c.next=b+c.next),c.nextState&&0!==c.nextState.indexOf(b)&&(c.nextState=b+c.nextState)}this.$rules[b+a]=f}else for(var a in d)this.$rules[a]=d[a]};this.getRules=
function(){return this.$rules};this.embedRules=function(d,b,f,e,c){d="function"==typeof d?(new d).getRules():d;if(e)for(var a=0;a<e.length;a++)e[a]=b+e[a];else for(a in e=[],d)e.push(b+a);this.addRules(d,b);if(f){c=Array.prototype[c?"push":"unshift"];for(a=0;a<e.length;a++)c.apply(this.$rules[e[a]],n.deepCopy(f))}this.$embeds||(this.$embeds=[]);this.$embeds.push(b)};this.getEmbeds=function(){return this.$embeds};var k=function(d,b){("start"!=d||b.length)&&b.unshift(this.nextState,d);return this.nextState},
l=function(d,b){b.shift();return b.shift()||"start"};this.normalizeRules=function(){function d(e){e=f[e];e.processed=!0;for(var c=0;c<e.length;c++){var a=e[c],i=null;Array.isArray(a)&&(i=a,a={});!a.regex&&a.start&&(a.regex=a.start,a.next||(a.next=[]),a.next.push({defaultToken:a.token},{token:a.token+".end",regex:a.end||a.start,next:"pop"}),a.token+=".start",a.push=!0);var h=a.next||a.push;if(h&&Array.isArray(h)){var g=a.stateName;g||(g=a.token,"string"!=typeof g&&(g=g[0]||""),f[g]&&(g+=b++));f[g]=
h;a.next=g;d(g)}else"pop"==h&&(a.next=l);a.push&&(a.nextState=a.next||a.push,a.next=k,delete a.push);if(a.rules)for(var j in a.rules)f[j]?f[j].push&&f[j].push.apply(f[j],a.rules[j]):f[j]=a.rules[j];(h="string"==typeof a?a:"string"==typeof a.include?a.include:"")&&(i=f[h]);i&&(i=[c,1].concat(i),a.noEscape&&(i=i.filter(function(a){return!a.next})),e.splice.apply(e,i),c--);a.keywordMap&&(a.token=this.createKeywordMapper(a.keywordMap,a.defaultToken||"text",a.caseInsensitive),delete a.defaultToken)}}var b=
0,f=this.$rules;Object.keys(f).forEach(d,this)};this.createKeywordMapper=function(d,b,f,e){var c=Object.create(null);Object.keys(d).forEach(function(a){var b=d[a];f&&(b=b.toLowerCase());for(var b=b.split(e||"|"),h=b.length;h--;)c[b[h]]=a});Object.getPrototypeOf(c)&&(c.__proto__=null);this.$keywordList=Object.keys(c);d=null;return f?function(a){return c[a.toLowerCase()]||b}:function(a){return c[a]||b}};this.getKeywords=function(){return this.$keywords}}).call(k.prototype);m.TextHighlightRules=k});