/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/dom ../lib/oop ../lib/event ../tooltip".split(" "),function(g,n){function l(b){m.call(this,b)}var p=g("../lib/dom"),q=g("../lib/oop"),r=g("../lib/event"),m=g("../tooltip").Tooltip;q.inherits(l,m);(function(){this.setPosition=function(b,a){var c=window.innerWidth||document.documentElement.clientWidth,g=window.innerHeight||document.documentElement.clientHeight,e=this.getWidth(),d=this.getHeight(),b=b+15,a=a+15;b+e>c&&(b-=b+e-c);a+d>g&&(a-=20+d);m.prototype.setPosition.call(this,
b,a)}}).call(l.prototype);n.GutterHandler=function(b){function a(){d&&(d=clearTimeout(d));i&&(e.hide(),i=null,c._signal("hideGutterTooltip",e),c.removeEventListener("mousewheel",a))}var c=b.editor,g=c.renderer.$gutterLayer,e=new l(c.container);b.editor.setDefaultHandler("guttermousedown",function(a){if(c.isFocused()&&0==a.getButton()&&"foldWidgets"!=g.getRegion(a)){var d=a.getDocumentPosition().row,e=c.session.selection;if(a.getShiftKey())e.selectTo(d,0);else{if(2==a.domEvent.detail)return c.selectAll(),
a.preventDefault();b.$clickSelection=c.selection.getLineRange(d)}b.setState("selectByLines");b.captureMouse(a);return a.preventDefault()}});var d,h,i;b.editor.setDefaultHandler("guttermousemove",function(f){if(p.hasCssClass(f.domEvent.target||f.domEvent.srcElement,"ace_fold-widget"))return a();i&&b.$tooltipFollowsMouse&&e.setPosition(f.x,f.y);h=f;d||(d=setTimeout(function(){d=null;if(h&&!b.isMousePressed)a:{var j=h.getDocumentPosition().row,k=g.$annotations[j];if(k){var f=c.session.getLength();if(j==
f&&(j=c.renderer.pixelToScreenCoordinates(0,h.y).row,f=h.$pos,j>c.session.documentToScreenRow(f.row,f.column))){a();break a}i!=k&&(i=k.text.join("<br/>"),e.setHtml(i),e.show(),c._signal("showGutterTooltip",e),c.on("mousewheel",a),b.$tooltipFollowsMouse?e.setPosition(h.x,h.y):(k=h.domEvent.target.getBoundingClientRect(),j=e.getElement().style,j.left=k.right+"px",j.top=k.bottom+"px"))}else a()}else a()},50))});r.addListener(c.renderer.$gutter,"mouseout",function(){h=null;i&&!d&&(d=setTimeout(function(){d=
null;a()},50))});c.on("changeSession",a)}});