/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/event","../lib/useragent"],function(m,q){function n(b,f){return b.row==f.row&&b.column==f.column}var A=m("../lib/event"),y=m("../lib/useragent");q.onMouseDown=function(b){var f=b.domEvent,i=f.altKey,j=f.shiftKey,r=f.ctrlKey,k=b.getAccelKey(),d=b.getButton();r&&y.isMac&&(d=f.button);if(b.editor.inMultiSelectMode&&2==d)b.editor.textInput.onContextMenu(b.domEvent);else if(!r&&!i&&!k)0===d&&b.editor.inMultiSelectMode&&b.editor.exitMultiSelectMode();else if(0===
d){var a=b.editor,c=a.selection,d=a.inMultiSelectMode,s=b.getDocumentPosition(),t=c.getCursor(),t=b.inSelection()||c.isEmpty()&&n(s,t),u=b.x,v=b.y,m=function(a){u=a.clientX;v=a.clientY},z=a.session,w=a.renderer.pixelToScreenCoordinates(u,v),p=w,h;if(a.$mouseHandler.$enableJumpToDef)r&&i||k&&i?h=j?"block":"add":i&&a.$blockSelectEnabled&&(h="block");else if(k&&!i){if(h="add",!d&&j)return}else i&&a.$blockSelectEnabled&&(h="block");h&&(y.isMac&&f.ctrlKey)&&a.$mouseHandler.cancelContextMenu();if("add"==
h){if(d||!t){if(!d){var g=c.toOrientedRange();a.addSelectionMarker(g)}var x=c.rangeList.rangeAtPoint(s);a.$blockScrolling++;a.inVirtualSelectionMode=!0;j&&(x=null,g=c.ranges[0]||g,a.removeSelectionMarker(g));a.once("mouseup",function(){var b=c.toOrientedRange();x&&b.isEmpty()&&n(x.cursor,b.cursor)?c.substractPoint(b.cursor):(j?c.substractPoint(g.cursor):g&&(a.removeSelectionMarker(g),c.addRange(g)),c.addRange(b));a.$blockScrolling--;a.inVirtualSelectionMode=!1})}}else if("block"==h){b.stop();a.inVirtualSelectionMode=
!0;var l,e=[];a.$blockScrolling++;d&&!k?c.toSingleRange():!d&&k&&(l=c.toOrientedRange(),a.addSelectionMarker(l));j?w=z.documentToScreenPosition(c.lead):c.moveToPosition(s);a.$blockScrolling--;p={row:-1,column:-1};A.capture(a.container,m,function(){clearInterval(q);a.removeSelectionMarkers(e);e.length||(e=[c.toOrientedRange()]);a.$blockScrolling++;l&&(a.removeSelectionMarker(l),c.toSingleRange(l));for(var b=0;b<e.length;b++)c.addRange(e[b]);a.inVirtualSelectionMode=!1;a.$mouseHandler.$clickSelection=
null;a.$blockScrolling--});var q=setInterval(function(){var b=a.renderer.pixelToScreenCoordinates(u,v),d=z.screenToDocumentPosition(b.row,b.column);if(!n(p,b)||!n(d,c.lead))p=b,a.$blockScrolling++,a.selection.moveToPosition(d),a.renderer.scrollCursorIntoView(),a.removeSelectionMarkers(e),e=c.rectangularRangeBlock(p,w),a.$mouseHandler.$clickSelection&&(1==e.length&&e[0].isEmpty())&&(e[0]=a.$mouseHandler.$clickSelection.clone()),e.forEach(a.addSelectionMarker,a),a.updateSelectionMarkers(),a.$blockScrolling--},
20);return b.preventDefault()}}}});