/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./range ./lib/event_emitter ./lib/oop".split(" "),function(g,i){var f=g("./range").Range,j=g("./lib/event_emitter").EventEmitter,k=g("./lib/oop"),h=function(b,c,a,d,e,f){var g=this;this.length=c;this.session=b;this.doc=b.getDocument();this.mainClass=e;this.othersClass=f;this.$onUpdate=this.onUpdate.bind(this);this.doc.on("change",this.$onUpdate);this.$others=d;this.$onCursorChange=function(){setTimeout(function(){g.onCursorChange()})};this.$pos=a;this.$undoStackDepth=
(b.getUndoManager().$undoStack||b.getUndoManager().$undostack||{length:-1}).length;this.setup();b.selection.on("changeCursor",this.$onCursorChange)};(function(){k.implement(this,j);this.setup=function(){var b=this,c=this.doc,a=this.session;this.selectionBefore=a.selection.toJSON();a.selection.inMultiSelectMode&&a.selection.toSingleRange();var d=this.pos=c.createAnchor(this.$pos.row,this.$pos.column);d.$insertRight=!0;d.detach();d.markerId=a.addMarker(new f(d.row,d.column,d.row,d.column+this.length),
this.mainClass,null,!1);this.others=[];this.$others.forEach(function(a){a=c.createAnchor(a.row,a.column);a.$insertRight=!0;a.detach();b.others.push(a)});a.setUndoSelect(!1)};this.showOtherMarkers=function(){if(!this.othersActive){var b=this.session,c=this;this.othersActive=!0;this.others.forEach(function(a){a.markerId=b.addMarker(new f(a.row,a.column,a.row,a.column+c.length),c.othersClass,null,!1)})}};this.hideOtherMarkers=function(){if(this.othersActive){this.othersActive=!1;for(var b=0;b<this.others.length;b++)this.session.removeMarker(this.others[b].markerId)}};
this.onUpdate=function(b){if(this.$updating)return this.updateAnchors(b);if(b.start.row===b.end.row&&b.start.row===this.pos.row){this.$updating=!0;var c="insert"===b.action?b.end.column-b.start.column:b.start.column-b.end.column,a=b.start.column>=this.pos.column&&b.start.column<=this.pos.column+this.length+1,d=b.start.column-this.pos.column;this.updateAnchors(b);a&&(this.length+=c);if(a&&!this.session.$fromUndo)if("insert"===b.action)for(a=this.others.length-1;0<=a;a--){var e=this.others[a],e={row:e.row,
column:e.column+d};this.doc.insertMergedLines(e,b.lines)}else if("remove"===b.action)for(a=this.others.length-1;0<=a;a--)e=this.others[a],e={row:e.row,column:e.column+d},this.doc.remove(new f(e.row,e.column,e.row,e.column-c));this.$updating=!1;this.updateMarkers()}};this.updateAnchors=function(b){this.pos.onChange(b);for(var c=this.others.length;c--;)this.others[c].onChange(b);this.updateMarkers()};this.updateMarkers=function(){if(!this.$updating){var b=this,c=this.session,a=function(a,d){c.removeMarker(a.markerId);
a.markerId=c.addMarker(new f(a.row,a.column,a.row,a.column+b.length),d,null,!1)};a(this.pos,this.mainClass);for(var d=this.others.length;d--;)a(this.others[d],this.othersClass)}};this.onCursorChange=function(b){if(!this.$updating&&this.session){var c=this.session.selection.getCursor();c.row===this.pos.row&&c.column>=this.pos.column&&c.column<=this.pos.column+this.length?(this.showOtherMarkers(),this._emit("cursorEnter",b)):(this.hideOtherMarkers(),this._emit("cursorLeave",b))}};this.detach=function(){this.session.removeMarker(this.pos&&
this.pos.markerId);this.hideOtherMarkers();this.doc.removeEventListener("change",this.$onUpdate);this.session.selection.removeEventListener("changeCursor",this.$onCursorChange);this.session.setUndoSelect(!0);this.session=null};this.cancel=function(){if(-1!==this.$undoStackDepth){for(var b=this.session.getUndoManager(),c=(b.$undoStack||b.$undostack).length-this.$undoStackDepth,a=0;a<c;a++)b.undo(!0);this.selectionBefore&&this.session.selection.fromJSON(this.selectionBefore)}}}).call(h.prototype);i.PlaceHolder=
h});