/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./range"],function(j,k){var h=j("./range").Range.comparePoints,i=function(){this.ranges=[]};(function(){this.comparePoints=h;this.pointIndex=function(a,c,b){for(var e=this.ranges,b=b||0;b<e.length;b++){var f=e[b],g=h(a,f.end);if(!(0<g)){a=h(a,f.start);if(0===g)return c&&0!==a?-b-2:b;if(0<a||0===a&&!c)return b;break}}return-b-1};this.add=function(a){var c=!a.isEmpty(),b=this.pointIndex(a.start,c);0>b&&(b=-b-1);c=this.pointIndex(a.end,c,b);0>c?c=-c-1:c++;return this.ranges.splice(b,
c-b,a)};this.addList=function(a){for(var c=[],b=a.length;b--;)c.push.apply(c,this.add(a[b]));return c};this.substractPoint=function(a){a=this.pointIndex(a);if(0<=a)return this.ranges.splice(a,1)};this.merge=function(){for(var a=[],c=this.ranges,c=c.sort(function(a,b){return h(a.start,b.start)}),b=c[0],e,f=1;f<c.length;f++){e=b;var b=c[f],g=h(e.end,b.start);!(0>g)&&!(0==g&&!e.isEmpty()&&!b.isEmpty())&&(0>h(e.end,b.end)&&(e.end.row=b.end.row,e.end.column=b.end.column),c.splice(f,1),a.push(b),b=e,f--)}this.ranges=
c;return a};this.contains=function(a,c){return 0<=this.pointIndex({row:a,column:c})};this.containsPoint=function(a){return 0<=this.pointIndex(a)};this.rangeAtPoint=function(a){a=this.pointIndex(a);if(0<=a)return this.ranges[a]};this.clipRows=function(a,c){var b=this.ranges;if(b[0].start.row>c||b[b.length-1].start.row<a)return[];var e=this.pointIndex({row:a,column:0});0>e&&(e=-e-1);var f=this.pointIndex({row:c,column:0},e);0>f&&(f=-f-1);for(var g=[];e<f;e++)g.push(b[e]);return g};this.removeAll=function(){return this.ranges.splice(0,
this.ranges.length)};this.attach=function(a){this.session&&this.detach();this.session=a;this.onChange=this.$onChange.bind(this);this.session.on("change",this.onChange)};this.detach=function(){this.session&&(this.session.removeListener("change",this.onChange),this.session=null)};this.$onChange=function(a){if("insert"==a.action)var c=a.start,b=a.end;else b=a.start,c=a.end;for(var a=c.row,e=b.row-a,b=-c.column+b.column,f=this.ranges,g=0,h=f.length;g<h;g++){var d=f[g];if(!(d.end.row<a)){if(d.start.row>
a)break;d.start.row==a&&d.start.column>=c.column&&!(d.start.column==c.column&&this.$insertRight)&&(d.start.column+=b,d.start.row+=e);d.end.row==a&&d.end.column>=c.column&&!(d.end.column==c.column&&this.$insertRight)&&(d.end.column==c.column&&(0<b&&g<h-1)&&(d.end.column>d.start.column&&d.end.column==f[g+1].start.column)&&(d.end.column-=b),d.end.column+=b,d.end.row+=e)}}if(0!=e&&g<h)for(;g<h;g++)d=f[g],d.start.row+=e,d.end.row+=e}}).call(i.prototype);k.RangeList=i});