/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./range ./range_list ./edit_session ./test/assertions".split(" "),function(f,i,g){function h(a){var b=[];a.ranges.forEach(function(a){b.push(a.start.row,a.start.column,a.end.row,a.end.column)});return b}var c=f("./range").Range,e=f("./range_list").RangeList;f("./edit_session");var b=f("./test/assertions");g.exports={name:"ACE range_list.js","test: rangeList pointIndex":function(){var a=new e;a.ranges=[new c(1,2,3,4),new c(4,2,5,4),new c(8,8,9,9)];b.equal(a.pointIndex({row:0,
column:1}),-1);b.equal(a.pointIndex({row:1,column:2}),0);b.equal(a.pointIndex({row:1,column:3}),0);b.equal(a.pointIndex({row:3,column:4}),0);b.equal(a.pointIndex({row:4,column:1}),-2);b.equal(a.pointIndex({row:5,column:1}),1);b.equal(a.pointIndex({row:8,column:9}),2);b.equal(a.pointIndex({row:18,column:9}),-4)},"test: rangeList pointIndex excludeEdges":function(){var a=new e;a.ranges=[new c(1,2,3,4),new c(4,2,5,4),new c(8,8,9,9),new c(10,10,10,10)];b.equal(a.pointIndex({row:0,column:1},!0),-1);b.equal(a.pointIndex({row:1,
column:2},!0),-1);b.equal(a.pointIndex({row:1,column:3},!0),0);b.equal(a.pointIndex({row:3,column:4},!0),-2);b.equal(a.pointIndex({row:4,column:1},!0),-2);b.equal(a.pointIndex({row:5,column:1},!0),1);b.equal(a.pointIndex({row:8,column:9},!0),2);b.equal(a.pointIndex({row:10,column:10},!0),3);b.equal(a.pointIndex({row:18,column:9},!0),-5)},"test: rangeList add":function(){var a=new e;a.addList([new c(9,0,9,1),new c(1,2,3,4),new c(8,8,9,9),new c(4,2,5,4),new c(3,20,3,24),new c(6,6,7,7)]);b.equal(a.ranges.length,
5);a.add(new c(1,2,3,5));b.range(a.ranges[0],1,2,3,5);b.equal(a.ranges.length,5);a.add(new c(7,7,7,7));b.range(a.ranges[3],7,7,7,7);a.add(new c(7,8,7,8));b.range(a.ranges[4],7,8,7,8)},"test: rangeList add empty":function(){var a=new e;a.addList([new c(7,10,7,10),new c(9,10,9,10),new c(8,10,8,10)]);b.equal(a.ranges.length,3);a.add(new c(9,10,9,10));b.equal(""+h(a),"7,10,7,10,8,10,8,10,9,10,9,10")},"test: rangeList merge":function(){var a=new e;a.addList([new c(1,2,3,4),new c(4,2,5,4),new c(6,6,7,7),
new c(8,8,9,9)]);var d=[];b.equal(a.ranges.length,4);a.ranges[1].end.row=7;d=a.merge();b.equal(d.length,1);b.range(a.ranges[1],4,2,7,7);b.equal(a.ranges.length,3);a.ranges[0].end.row=10;d=a.merge();b.range(a.ranges[0],1,2,10,4);b.equal(d.length,2);b.equal(a.ranges.length,1);a.ranges.push(new c(10,10,10,10));a.ranges.push(new c(10,10,10,10));a.merge();b.equal(a.ranges.length,2)},"test: rangeList remove":function(){var a=new e,d=[new c(1,2,3,4),new c(4,2,5,4),new c(6,6,7,7),new c(8,8,9,9)];a.addList(d);
b.equal(a.ranges.length,4);a.substractPoint({row:1,column:2});b.equal(a.ranges.length,3);a.substractPoint({row:6,column:7});b.equal(a.ranges.length,2)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();