/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/lang ./lib/event_emitter ./range".split(" "),function(g,j){var k=g("./lib/oop"),h=g("./lib/lang"),l=g("./lib/event_emitter").EventEmitter,f=g("./range").Range,i=function(a){this.session=a;this.doc=a.getDocument();this.clearSelection();this.lead=this.selectionLead=this.doc.createAnchor(0,0);this.anchor=this.selectionAnchor=this.doc.createAnchor(0,0);var b=this;this.lead.on("change",function(a){b._emit("changeCursor");b.$isEmpty||b._emit("changeSelection");
!b.$keepDesiredColumnOnChange&&a.old.column!=a.value.column&&(b.$desiredColumn=null)});this.selectionAnchor.on("change",function(){b.$isEmpty||b._emit("changeSelection")})};(function(){k.implement(this,l);this.isEmpty=function(){return this.$isEmpty||this.anchor.row==this.lead.row&&this.anchor.column==this.lead.column};this.isMultiLine=function(){return this.isEmpty()?!1:this.getRange().isMultiLine()};this.getCursor=function(){return this.lead.getPosition()};this.setSelectionAnchor=function(a,b){this.anchor.setPosition(a,
b);this.$isEmpty&&(this.$isEmpty=!1,this._emit("changeSelection"))};this.getSelectionAnchor=function(){return this.$isEmpty?this.getSelectionLead():this.anchor.getPosition()};this.getSelectionLead=function(){return this.lead.getPosition()};this.shiftSelection=function(a){if(this.$isEmpty)this.moveCursorTo(this.lead.row,this.lead.column+a);else{var b=this.getSelectionAnchor(),c=this.getSelectionLead(),d=this.isBackwards();(!d||0!==b.column)&&this.setSelectionAnchor(b.row,b.column+a);(d||0!==c.column)&&
this.$moveSelection(function(){this.moveCursorTo(c.row,c.column+a)})}};this.isBackwards=function(){var a=this.anchor,b=this.lead;return a.row>b.row||a.row==b.row&&a.column>b.column};this.getRange=function(){var a=this.anchor,b=this.lead;return this.isEmpty()?f.fromPoints(b,b):this.isBackwards()?f.fromPoints(b,a):f.fromPoints(a,b)};this.clearSelection=function(){this.$isEmpty||(this.$isEmpty=!0,this._emit("changeSelection"))};this.selectAll=function(){var a=this.doc.getLength()-1;this.setSelectionAnchor(0,
0);this.moveCursorTo(a,this.doc.getLine(a).length)};this.setRange=this.setSelectionRange=function(a,b){b?(this.setSelectionAnchor(a.end.row,a.end.column),this.selectTo(a.start.row,a.start.column)):(this.setSelectionAnchor(a.start.row,a.start.column),this.selectTo(a.end.row,a.end.column));this.getRange().isEmpty()&&(this.$isEmpty=!0);this.$desiredColumn=null};this.$moveSelection=function(a){var b=this.lead;this.$isEmpty&&this.setSelectionAnchor(b.row,b.column);a.call(this)};this.selectTo=function(a,
b){this.$moveSelection(function(){this.moveCursorTo(a,b)})};this.selectToPosition=function(a){this.$moveSelection(function(){this.moveCursorToPosition(a)})};this.moveTo=function(a,b){this.clearSelection();this.moveCursorTo(a,b)};this.moveToPosition=function(a){this.clearSelection();this.moveCursorToPosition(a)};this.selectUp=function(){this.$moveSelection(this.moveCursorUp)};this.selectDown=function(){this.$moveSelection(this.moveCursorDown)};this.selectRight=function(){this.$moveSelection(this.moveCursorRight)};
this.selectLeft=function(){this.$moveSelection(this.moveCursorLeft)};this.selectLineStart=function(){this.$moveSelection(this.moveCursorLineStart)};this.selectLineEnd=function(){this.$moveSelection(this.moveCursorLineEnd)};this.selectFileEnd=function(){this.$moveSelection(this.moveCursorFileEnd)};this.selectFileStart=function(){this.$moveSelection(this.moveCursorFileStart)};this.selectWordRight=function(){this.$moveSelection(this.moveCursorWordRight)};this.selectWordLeft=function(){this.$moveSelection(this.moveCursorWordLeft)};
this.getWordRange=function(a,b){if("undefined"==typeof b)var c=a||this.lead,a=c.row,b=c.column;return this.session.getWordRange(a,b)};this.selectWord=function(){this.setSelectionRange(this.getWordRange())};this.selectAWord=function(){var a=this.getCursor(),a=this.session.getAWordRange(a.row,a.column);this.setSelectionRange(a)};this.getLineRange=function(a,b){var c="number"==typeof a?a:this.lead.row,d;(d=this.session.getFoldLine(c))?(c=d.start.row,d=d.end.row):d=c;return!0===b?new f(c,0,d,this.session.getLine(d).length):
new f(c,0,d+1,0)};this.selectLine=function(){this.setSelectionRange(this.getLineRange())};this.moveCursorUp=function(){this.moveCursorBy(-1,0)};this.moveCursorDown=function(){this.moveCursorBy(1,0)};this.moveCursorLeft=function(){var a=this.lead.getPosition(),b;(b=this.session.getFoldAt(a.row,a.column,-1))?this.moveCursorTo(b.start.row,b.start.column):0===a.column?0<a.row&&this.moveCursorTo(a.row-1,this.doc.getLine(a.row-1).length):(b=this.session.getTabSize(),this.session.isTabStop(a)&&this.doc.getLine(a.row).slice(a.column-
b,a.column).split(" ").length-1==b?this.moveCursorBy(0,-b):this.moveCursorBy(0,-1))};this.moveCursorRight=function(){var a=this.lead.getPosition();if(a=this.session.getFoldAt(a.row,a.column,1))this.moveCursorTo(a.end.row,a.end.column);else if(this.lead.column==this.doc.getLine(this.lead.row).length)this.lead.row<this.doc.getLength()-1&&this.moveCursorTo(this.lead.row+1,0);else{var b=this.session.getTabSize(),a=this.lead;this.session.isTabStop(a)&&this.doc.getLine(a.row).slice(a.column,a.column+b).split(" ").length-
1==b?this.moveCursorBy(0,b):this.moveCursorBy(0,1)}};this.moveCursorLineStart=function(){var a=this.lead.row,b=this.lead.column,c=this.session.documentToScreenRow(a,b),c=this.session.screenToDocumentPosition(c,0),a=this.session.getDisplayLine(a,null,c.row,c.column).match(/^\s*/);a[0].length!=b&&!this.session.$useEmacsStyleLineStart&&(c.column+=a[0].length);this.moveCursorToPosition(c)};this.moveCursorLineEnd=function(){var a=this.lead,a=this.session.getDocumentLastRowColumnPosition(a.row,a.column);
if(this.lead.column==a.column){var b=this.session.getLine(a.row);a.column==b.length&&(b=b.search(/\s+$/),0<b&&(a.column=b))}this.moveCursorTo(a.row,a.column)};this.moveCursorFileEnd=function(){var a=this.doc.getLength()-1,b=this.doc.getLine(a).length;this.moveCursorTo(a,b)};this.moveCursorFileStart=function(){this.moveCursorTo(0,0)};this.moveCursorLongWordRight=function(){var a=this.lead.row,b=this.lead.column,c=this.doc.getLine(a),d=c.substring(b);this.session.nonTokenRe.lastIndex=0;this.session.tokenRe.lastIndex=
0;var e=this.session.getFoldAt(a,b,1);e?this.moveCursorTo(e.end.row,e.end.column):(this.session.nonTokenRe.exec(d)&&(b+=this.session.nonTokenRe.lastIndex,this.session.nonTokenRe.lastIndex=0,d=c.substring(b)),b>=c.length?(this.moveCursorTo(a,c.length),this.moveCursorRight(),a<this.doc.getLength()-1&&this.moveCursorWordRight()):(this.session.tokenRe.exec(d)&&(b+=this.session.tokenRe.lastIndex,this.session.tokenRe.lastIndex=0),this.moveCursorTo(a,b)))};this.moveCursorLongWordLeft=function(){var a=this.lead.row,
b=this.lead.column,c;(c=this.session.getFoldAt(a,b,-1))?this.moveCursorTo(c.start.row,c.start.column):(c=this.session.getFoldStringAt(a,b,-1),null==c&&(c=this.doc.getLine(a).substring(0,b)),c=h.stringReverse(c),this.session.nonTokenRe.lastIndex=0,this.session.tokenRe.lastIndex=0,this.session.nonTokenRe.exec(c)&&(b-=this.session.nonTokenRe.lastIndex,c=c.slice(this.session.nonTokenRe.lastIndex),this.session.nonTokenRe.lastIndex=0),0>=b?(this.moveCursorTo(a,0),this.moveCursorLeft(),0<a&&this.moveCursorWordLeft()):
(this.session.tokenRe.exec(c)&&(b-=this.session.tokenRe.lastIndex,this.session.tokenRe.lastIndex=0),this.moveCursorTo(a,b)))};this.$shortWordEndIndex=function(a){var b=0,c,d=/\s/,e=this.session.tokenRe;e.lastIndex=0;if(this.session.tokenRe.exec(a))b=this.session.tokenRe.lastIndex;else{for(;(c=a[b])&&d.test(c);)b++;if(1>b)for(e.lastIndex=0;(c=a[b])&&!e.test(c);)if(e.lastIndex=0,b++,d.test(c))if(2<b){b--;break}else{for(;(c=a[b])&&d.test(c);)b++;if(2<b)break}}e.lastIndex=0;return b};this.moveCursorShortWordRight=
function(){var a=this.lead.row,b=this.lead.column,c=this.doc.getLine(a),d=c.substring(b),e=this.session.getFoldAt(a,b,1);if(e)return this.moveCursorTo(e.end.row,e.end.column);if(b==c.length){b=this.doc.getLength();do a++,d=this.doc.getLine(a);while(a<b&&/^\s*$/.test(d));/^\s+/.test(d)||(d="");b=0}d=this.$shortWordEndIndex(d);this.moveCursorTo(a,b+d)};this.moveCursorShortWordLeft=function(){var a=this.lead.row,b=this.lead.column,c;if(c=this.session.getFoldAt(a,b,-1))return this.moveCursorTo(c.start.row,
c.start.column);c=this.session.getLine(a).substring(0,b);if(0===b){do a--,c=this.doc.getLine(a);while(0<a&&/^\s*$/.test(c));b=c.length;/\s+$/.test(c)||(c="")}c=h.stringReverse(c);c=this.$shortWordEndIndex(c);return this.moveCursorTo(a,b-c)};this.moveCursorWordRight=function(){this.session.$selectLongWords?this.moveCursorLongWordRight():this.moveCursorShortWordRight()};this.moveCursorWordLeft=function(){this.session.$selectLongWords?this.moveCursorLongWordLeft():this.moveCursorShortWordLeft()};this.moveCursorBy=
function(a,b){var c=this.session.documentToScreenPosition(this.lead.row,this.lead.column);0===b&&(this.$desiredColumn?c.column=this.$desiredColumn:this.$desiredColumn=c.column);c=this.session.screenToDocumentPosition(c.row+a,c.column);0!==a&&0===b&&c.row===this.lead.row&&c.column===this.lead.column&&this.session.lineWidgets&&this.session.lineWidgets[c.row]&&(0<c.row||0<a)&&c.row++;this.moveCursorTo(c.row,c.column+b,0===b)};this.moveCursorToPosition=function(a){this.moveCursorTo(a.row,a.column)};this.moveCursorTo=
function(a,b,c){var d=this.session.getFoldAt(a,b,1);d&&(a=d.start.row,b=d.start.column);this.$keepDesiredColumnOnChange=!0;this.lead.setPosition(a,b);this.$keepDesiredColumnOnChange=!1;c||(this.$desiredColumn=null)};this.moveCursorToScreen=function(a,b,c){a=this.session.screenToDocumentPosition(a,b);this.moveCursorTo(a.row,a.column,c)};this.detach=function(){this.lead.detach();this.anchor.detach();this.session=this.doc=null};this.fromOrientedRange=function(a){this.setSelectionRange(a,a.cursor==a.start);
this.$desiredColumn=a.desiredColumn||this.$desiredColumn};this.toOrientedRange=function(a){var b=this.getRange();a?(a.start.column=b.start.column,a.start.row=b.start.row,a.end.column=b.end.column,a.end.row=b.end.row):a=b;a.cursor=this.isBackwards()?a.start:a.end;a.desiredColumn=this.$desiredColumn;return a};this.getRangeOfMovements=function(a){var b=this.getCursor();try{a(this);var c=this.getCursor();return f.fromPoints(b,c)}catch(d){return f.fromPoints(b,b)}finally{this.moveCursorToPosition(b)}};
this.toJSON=function(){if(this.rangeCount)var a=this.ranges.map(function(a){var c=a.clone();c.isBackwards=a.cursor==a.start;return c});else a=this.getRange(),a.isBackwards=this.isBackwards();return a};this.fromJSON=function(a){if(void 0==a.start){if(this.rangeList){this.toSingleRange(a[0]);for(var b=a.length;b--;){var c=f.fromPoints(a[b].start,a[b].end);a[b].isBackwards&&(c.cursor=c.start);this.addRange(c,!0)}return}a=a[0]}this.rangeList&&this.toSingleRange(a);this.setSelectionRange(a,a.isBackwards)};
this.isEqual=function(a){if((a.length||this.rangeCount)&&a.length!=this.rangeCount)return!1;if(!a.length||!this.ranges)return this.getRange().isEqual(a);for(var b=this.ranges.length;b--;)if(!this.ranges[b].isEqual(a[b]))return!1;return!0}}).call(i.prototype);j.Selection=i});