/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./tokenizer"],function(s,u){var l=s("./tokenizer").Tokenizer,e=function(e){l.call(this,e);this.getLineTokens=function(e,i){function t(){l.push(i+"@"+g)}if(i&&"string"!=typeof i)var j=i.slice(0),i=j[0];else j=[];var b=i||"start",m=this.states[b],q=this.matchMappings[b],n=this.regExps[b];n.lastIndex=0;var r,h=[],g=0,l=[],a={type:null,value:"",state:b};t();l=[];t();for(var s=1E5;r=n.exec(e);){var f=q.defaultToken,d=null,k=r[0],p=n.lastIndex;if(p-k.length>g){var c=
e.substring(g,p-k.length);a.type==f?a.value+=c:(a.type&&h.push(a),a={type:f,value:c})}for(c=0;c<r.length-2;c++)if(void 0!==r[c+1]){if(!s--)throw"infinite"+m[q[c]]+b;d=m[q[c]];f=d.onMatch?d.onMatch(k,b,j):d.token;d.next&&(b="string"==typeof d.next?d.next:d.next(b,j),m=this.states[b],m||(window.console&&console.error&&console.error(b,"doesn't exist"),b="start",m=this.states[b]),q=this.matchMappings[b],g=p,n=this.regExps[b],n.lastIndex=p,t());break}if(k)if("string"==typeof f)(!d||!1!==d.merge)&&a.type===
f?a.value+=k:(a.type&&h.push(a),a={type:f,value:k});else{a.type&&h.push(a);a={type:null,value:""};for(c=0;c<f.length;c++)h.push(f[c])}if(g==e.length)break;g=p;if(1E5<h.length){a.value+=e.substr(g);b="start";break}}a.type&&h.push(a);return{tokens:h,state:j.length?j:b}}};e.prototype=l.prototype;u.Tokenizer=e});