/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(i,d){var b=function(){this.reset()};(function(){function b(a){return{action:a.action,start:a.start,end:a.end,lines:1==a.lines.length?null:a.lines,text:1==a.lines.length?a.lines[0]:null}}function d(a){return{action:a.action,start:a.start,end:a.end,lines:a.lines||[a.text]}}function g(a,c){for(var h=Array(a.length),b=0;b<a.length;b++){for(var e=a[b],d={group:e.group,deltas:Array(e.length)},f=0;f<e.deltas.length;f++)d.deltas[f]=c(e.deltas[f]);h[b]=d}return h}
this.execute=function(a){var c=a.args[0];this.$doc=a.args[1];a.merge&&this.hasUndo()&&(this.dirtyCounter--,c=this.$undoStack.pop().concat(c));this.$undoStack.push(c);this.$redoStack=[];0>this.dirtyCounter&&(this.dirtyCounter=NaN);this.dirtyCounter++};this.undo=function(a){var c=this.$undoStack.pop(),b=null;c&&(b=this.$doc.undoChanges(c,a),this.$redoStack.push(c),this.dirtyCounter--);return b};this.redo=function(a){var c=this.$redoStack.pop(),b=null;c&&(b=this.$doc.redoChanges(this.$deserializeDeltas(c),
a),this.$undoStack.push(c),this.dirtyCounter++);return b};this.reset=function(){this.$undoStack=[];this.$redoStack=[];this.dirtyCounter=0};this.hasUndo=function(){return 0<this.$undoStack.length};this.hasRedo=function(){return 0<this.$redoStack.length};this.markClean=function(){this.dirtyCounter=0};this.isClean=function(){return 0===this.dirtyCounter};this.$serializeDeltas=function(a){return g(a,b)};this.$deserializeDeltas=function(a){return g(a,d)}}).call(b.prototype);d.UndoManager=b});