/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./edit_session ./edit_session ./virtual_renderer ./test/assertions".split(" "),function(d,k,f){var g=d("./edit_session").Editor,h=d("./edit_session").EditSession,i=d("./virtual_renderer").VirtualRenderer,j=d("./test/assertions"),c=null;f.exports={setUp:function(){b&&b.destroy();var a=document.createElement("div");a.style.left="20px";a.style.top="30px";a.style.width="300px";a.style.height="100px";document.body.appendChild(a);var b=new i(a),b=new g(b);b.on("destroy",function(){document.body.removeChild(a)})},
tearDown:function(){c&&c.destroy();c=null},"test: screen2text the column should be rounded to the next character edge":function(a){function b(a,b,c,f){j.position(e.screenToTextCoordinates(a+d.left,b+d.top),c,f)}if(!c)return a();var e=c.renderer;e.setPadding(0);e.setSession(new h("1234"));var d=e.scroller.getBoundingClientRect();e.characterWidth=10;e.lineHeight=15;b(4,0,0,0);b(5,0,0,1);b(9,0,0,1);b(10,0,0,1);b(14,0,0,1);b(15,0,0,2);a()},"test scrollmargin + autosize":function(a){if(!c)return a();c.setOptions({maxLines:100,
useWrapMode:!0});c.renderer.setScrollMargin(10,10);c.setValue("\n\n");c.setValue("\n\n\n\n");c.renderer.once("afterRender",function(){setTimeout(function(){a()},0)})}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();