/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/net ../lib/event_emitter ../config".split(" "),function(b,k){var p=b("../lib/oop"),l=b("../lib/net"),m=b("../lib/event_emitter").EventEmitter,j=b("../config"),g=function(a,d,h,c){this.$sendDeltaQueue=this.$sendDeltaQueue.bind(this);this.changeListener=this.changeListener.bind(this);this.onMessage=this.onMessage.bind(this);b.nameToUrl&&!b.toUrl&&(b.toUrl=b.nameToUrl);if(j.get("packaged")||!b.toUrl)c=c||j.moduleUrl(d,"worker");else{var i=this.$normalizePath,
c=c||i(b.toUrl("ace/worker/worker.js",null,"_")),e={};a.forEach(function(a){e[a]=i(b.toUrl(a,null,"_").replace(/(\.js)?(\?.*)?$/,""))})}try{this.$worker=new Worker(c)}catch(f){if(f instanceof window.DOMException)c=this.$workerBlob(c),a=window.URL||window.webkitURL,c=a.createObjectURL(c),this.$worker=new Worker(c),a.revokeObjectURL(c);else throw f;}this.$worker.postMessage({init:!0,tlns:e,module:d,classname:h});this.callbackId=1;this.callbacks={};this.$worker.onmessage=this.onMessage};(function(){p.implement(this,
m);this.onMessage=function(a){a=a.data;switch(a.type){case "event":this._signal(a.name,{data:a.data});break;case "call":var d=this.callbacks[a.id];d&&(d(a.data),delete this.callbacks[a.id]);break;case "error":this.reportError(a.data);break;case "log":window.console&&console.log&&console.log.apply(console,a.data)}};this.reportError=function(a){window.console&&console.error&&console.error(a)};this.$normalizePath=function(a){return l.qualifyURL(a)};this.terminate=function(){this._signal("terminate",
{});this.deltaQueue=null;this.$worker.terminate();this.$worker=null;this.$doc&&this.$doc.off("change",this.changeListener);this.$doc=null};this.send=function(a,d){this.$worker.postMessage({command:a,args:d})};this.call=function(a,d,b){if(b){var c=this.callbackId++;this.callbacks[c]=b;d.push(c)}this.send(a,d)};this.emit=function(a,d){try{this.$worker.postMessage({event:a,data:{data:d.data}})}catch(b){console.error(b.stack)}};this.attachToDocument=function(a){this.$doc&&this.terminate();this.$doc=a;
this.call("setValue",[a.getValue()]);a.on("change",this.changeListener)};this.changeListener=function(a){this.deltaQueue||(this.deltaQueue=[],setTimeout(this.$sendDeltaQueue,0));"insert"==a.action?this.deltaQueue.push(a.start,a.lines):this.deltaQueue.push(a.start,a.end)};this.$sendDeltaQueue=function(){var a=this.deltaQueue;a&&(this.deltaQueue=null,50<a.length&&a.length>this.$doc.getLength()>>1?this.call("setValue",[this.$doc.getValue()]):this.emit("change",{data:a}))};this.$workerBlob=function(a){a=
"importScripts('"+l.qualifyURL(a)+"');";try{return new Blob([a],{type:"application/javascript"})}catch(b){var h=new (window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder);h.append(a);return h.getBlob("application/javascript")}}}).call(g.prototype);var n=function(a,b,h){this.$sendDeltaQueue=this.$sendDeltaQueue.bind(this);this.changeListener=this.changeListener.bind(this);this.callbackId=1;this.callbacks={};this.messageBuffer=[];var c=null,i=!1,e=Object.create(m),f=this;this.$worker=
{};this.$worker.terminate=function(){};this.$worker.postMessage=function(a){f.messageBuffer.push(a);c&&(i?setTimeout(g):g())};this.setEmitSync=function(a){i=a};var g=function(){var a=f.messageBuffer.shift();a.command?c[a.command].apply(c,a.args):a.event&&e._signal(a.event,a.data)};e.postMessage=function(a){f.onMessage({data:a})};e.callback=function(a,b){this.postMessage({type:"call",id:b,data:a})};e.emit=function(a,b){this.postMessage({type:"event",name:a,data:b})};j.loadModule(["worker",b],function(a){for(c=
new a[h](e);f.messageBuffer.length;)g()})};n.prototype=g.prototype;k.UIWorkerClient=n;k.WorkerClient=g});