/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

require("amd-loader");
define("require exports module ../test/assertions ./worker depA depB depA depB depB".split(" "),function(e,h,f){var d=e("../test/assertions"),a=e("./worker");f.exports={setUp:function(){a.define("depA",[],function(a,g,c){c.exports="dependency A"});a.define("depB",[],function(a,g,c){c.exports="dependency B"})},"test: define() with no dependencies, and CommonJS-compatability require()-calls":function(){a.require.id="test1";a.define(function(a,c,b){c=a("depA");a=a("depB");d.equal("dependency A",c);d.equal("dependency B",
a);b.exports="test 1"});var b=a.require("test1");d.equal("test 1",b)},"test: define() with dependencies":function(){a.require.id="test2";a.define(["depA","depB"],function(a,c){d.equal("dependency A",a);d.equal("dependency B",c);return"test 2"});var b=a.require("test2");d.equal("test 2",b)},"test: define() used require, exports and module as a dependency":function(){a.require.id="test3";a.define(["require","exports","module","depA","depB"],function(a,c,b){c=a("depA");a=a("depB");d.equal("dependency A",
c);d.equal("dependency B",a);b.exports="test 3"});var b=a.require("test3");d.equal("test 3",b)},"test: define() with a mix of require and actual dependecies":function(){a.require.id="test4";a.define(["depA","require"],function(a,c){var b=c("depB");d.equal("dependency A",a);d.equal("dependency B",b);return"test 4"});var b=a.require("test4");d.equal("test 4",b)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();