/**
		 * The core for user creation popups. 
		 * Responsible for success/cancel handlers and for license check.
		 * You can add a footer and content.
		 */

/**
		 * Check if license is present to create a regular user
		 */

// check if license is available to create a regular user

// enable the create user button if license is available

/**
		 * returns if there is a license
		 */

define(["jquery","underscore","component/modal/Modal","./UserCreationAndInviteMemberErrorUtil","utils/webi18n!UserCreationStrings"],function(c,d,e,f,g){var b=function(){this._hasLicenseToCreateUser=!1;this._onCreateCallbacks=[];this._onCancelCallbacks=[];this._errorUtil=new f;this._createClickHandler=d.bind(function(a){d.each(this._onCreateCallbacks,d.bind(function(b){b(a)},this));this._popup.close()},this);this._cancelClickHandler=d.bind(function(){d.each(this._onCancelCallbacks,d.bind(function(a){a()},
this));this._popup.close()},this)};b.prototype.constructPopup=function(){this._popupContent=c("<div>");this._popupContent.append(this._errorUtil.errorSection,this._content.getContent(this._errorUtil));var a={customClass:"create_newuser_modalpopup"};a.onClose=d.bind(function(){this._popup.destroy()},this);this._popup=new e(this._popupContent,a);this._popup.setTitle(g.t("CREATE_AND_INVITE_NEW_USER"));this._popup.setFooter(this._footer.getContent(this._errorUtil))};b.prototype.setContent=function(a){this._content=
a};b.prototype.setFooter=function(a){a.setUserCreationAPI(Object.create(this,{cancel:{value:this._cancelClickHandler},success:{value:this._createClickHandler}}));this._footer=a};b.prototype.show=function(a){this.reset();this._checkLicense();this._content.beforeOpen(a);this._popup.open()};b.prototype._checkLicense=function(){var a=c.ajax({url:"CreateNewUserLicenseCheck.jsp",method:"POST",dataType:"xml"});c.when(a).then(function(a){(a=c(a).children().get(0))&&"can_create_user"===a.tagName?"true"===
c(a).text()?(this._hasLicenseToCreateUser=!0,this._footer.enable()):this._errorUtil.showWarningMessage("LIC_VIOLATION_REGULAR_USERCREATION","alert-danger",this._warningMessageDiv):"error"===c(a).prop("tagName").toLowerCase()&&(a=c("> message",a).text(),this._errorUtil.showErrorMessage(a,!0,this._errorMessageDiv))}.bind(this),function(){this._errorUtil.showErrorMessage("UNKNOWNEXCEPTION_TAG",!1,this._errorDiv)}.bind(this))};b.prototype.onSubmit=function(a){this._onCreateCallbacks.push(a)};b.prototype.onCancel=
function(a){this._onCancelCallbacks.push(a)};b.prototype.getUserDetails=function(){return this._content.getUserDetails()};b.prototype.hasLicense=function(){return this._hasLicenseToCreateUser};b.prototype.reset=function(){this._errorUtil.clearSSOErrorSections();this._errorUtil.clearErrorMessage();this._content.reset()};b.prototype.validateFields=function(){return this._content.validateFields(this._errorUtil)};b.builder=function(){var a=new b;return{setFooter:function(b){a.setFooter(b);return this},
setContent:function(b){a.setContent(b);return this},construct:function(){a.constructPopup();return a}}};return b});