/**
     * Constructor of DocTableXFactory class. Never use "new DocTableXFactory()" - use the instance
     * created at the end of this class/file.
     * 
     * @param {Boolean} isPCMEnabled - True if the PCM license is active on this system, false otherwise.
     */

define(["doctablex/DocTableXUtils","doctablex/DocTableX","doctablex/DocTableXView","require","lib/PromisePolyfill"],function(c,g,e,f){var d=function(a){this.isPCMEnabled=!1;void 0===a?window.webcenterConfig&&window.webcenterConfig.isPCMEnabled&&(this.isPCMEnabled=!!window.webcenterConfig.isPCMEnabled):this.isPCMEnabled=!!a;this.initialization=new Promise(function(a,b){this.isPCMEnabled?f(["doctablex/TextContentTableX","doctablex/TextContentTableXView"],function(b,c){b.call(g.prototype);c.call(e.prototype);
a(b)}.bind(this),b):a()}.bind(this));return this};d.prototype.createDocTableX=function(a){return this.initialization.then(function(d){var b=null;try{var b=new g(a),e=null!=c.getRenderItem(a.renderOptions.columns,"MasterText")||null!=c.getRenderItem(a.renderOptions.columns,"TranslationText")||null!=c.getRenderItem(a.renderOptions.columns,"TextLanguages");this.isPCMEnabled&&e&&d.__initMixin.call(b,a)}catch(f){c.error("Initialization of DocTableX in DocTableXFactory.createDocTableX() failed with exception: "+
f),b&&b.dataLoadingFailed&&b.dataLoadingFailed()}return b}.bind(this))};return new d});