/**
     * Constructor of DocumentRowFactory class. Never use "new DocumentRowFactory()" - use the instance
     * created at the end of this class/file.
     * 
     * @param {Boolean} isPCMEnabled - True if the PCM license is active on this system, false otherwise.
     */

define("doctablex/DocTableXUtils doctablex/StaticDocumentRow doctablex/StaticDocumentRowView doctablex/DocumentRow doctablex/DocumentRowBrowse doctablex/DocumentRowFile doctablex/DocumentRowExternalFile doctablex/DocumentRowSearch doctablex/DocumentRowSearchView doctablex/DocumentRowNew doctablex/DocumentRowNewView doctablex/DocumentRowLink doctablex/DocumentRowLinkView doctablex/DocumentRowCopy require lib/PromisePolyfill".split(" "),function(r,f,s,g,t,u,v,h,w,i,x,j,y,z,A){var d=function(b){this.isPCMEnabled=
!1;void 0===b?window.webcenterConfig&&(this.isPCMEnabled=!!window.webcenterConfig.isPCMEnabled):this.isPCMEnabled=!!b;this.initialization=new Promise(function(b,a){this.isPCMEnabled?A("doctablex/TextContentRow doctablex/TextContentRowView doctablex/AddedTextContentRow doctablex/TextContentRowSearch doctablex/TextContentRowSearchView doctablex/TextContentRowNew doctablex/TextContentRowNewView doctablex/TextContentRowLink doctablex/TextContentRowLinkView".split(" "),function(a,c,e,d,l,m,n,p,q){a.call(f.prototype);
e.call(g.prototype);d.call(h.prototype);m.call(i.prototype);p.call(j.prototype);c.call(s.prototype);n.call(x.prototype);l.call(w.prototype);q.call(y.prototype);b({TextContentRow:a,TextContentRowView:c,AddedTextContentRow:e,TextContentRowSearch:d,TextContentRowSearchView:l,TextContentRowNew:m,TextContentRowNewView:n,TextContentRowLink:p,TextContentRowLinkView:q})}.bind(this),a):b()}.bind(this));return this};d.prototype.createDocumentRow=function(b,d){return this.initialization.then(function(a){var k=
new b(d);if(this.isPCMEnabled){var c=[];b==f?c=[a.TextContentRow]:b==g?c=[a.TextContentRow,a.AddedTextContentRow]:b==t?c=[a.TextContentRow,a.AddedTextContentRow]:b==u?c=[a.TextContentRow,a.AddedTextContentRow]:b==h?c=[a.TextContentRow,a.AddedTextContentRow,a.TextContentRowSearch]:b==i?c=[a.TextContentRow,a.AddedTextContentRow,a.TextContentRowNew]:b==j?c=[a.TextContentRow,a.AddedTextContentRow,a.TextContentRowLink]:b==z?c=[a.TextContentRow,a.AddedTextContentRow]:b==v?c=[]:r.error("Class '"+b+"' is not supported in PCM context!");
for(a=0;a<c.length;a++){var e=c[a];e.__initMixin&&e.__initMixin.call(k,d)}}return k}.bind(this))};d.prototype.createStaticDocumentRow=function(b){return this.createDocumentRow(f,b)};return new d});