/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ace/lib/oop ace/lib/event ace/tooltip ./smartnameextensionutils ./smartnameanchorcontrol".split(" "),function(f,k){function h(a){a.smartnameTooltip||(i.call(this,a.container),a.smartnameTooltip=this,this.editor=a,this.update=this.update.bind(this),this.onMouseMove=this.onMouseMove.bind(this),this.onMouseOut=this.onMouseOut.bind(this),g.addListener(a.renderer.scroller,"mousemove",this.onMouseMove),g.addListener(a.renderer.content,"mouseout",this.onMouseOut),g.addListener(a,
"change",function(a){var d=a.data;"undefined"===typeof d&&(d=a);"changeActiveSmartName"===d.action&&this.lastHoverSmartName&&this.update()}.bind(this)))}var l=f("ace/lib/oop"),g=f("ace/lib/event"),i=f("ace/tooltip").Tooltip,m=f("./smartnameextensionutils"),j=f("./smartnameanchorcontrol");l.inherits(h,i);(function(){this.update=function(){this.$timer=null;var a=this.editor.renderer;if(1E3<this.lastT-(a.timeStamp||0))a.rect=null,a.timeStamp=this.lastT,this.maxHeight=window.innerHeight,this.maxWidth=
window.innerWidth;var b=a.rect||(a.rect=a.scroller.getBoundingClientRect()),d=Math.floor((this.y+a.scrollTop-b.top)/a.lineHeight),a=Math.round((this.x+a.scrollLeft-b.left-a.$padding)/a.characterWidth),c=this.editor.session,e=c.screenToDocumentPosition(d,a),a=d=!1;c.getLine(e.row).charAt(e.column)===m.SMARTNAMECHAR?(b=j.getSmartNameInfoAt(c.getDocument(),e.row,e.column),c=j.getActiveSmartNamePosition(c.getDocument()),c=null!==c&&c.row===e.row&&c.column===e.column,b===this.lastHoverSmartName&&c===this.lastSmartNameActive?
(d=!1,a=this.isOpen):(e=$(this.getElement()),e.empty(),this.lastHoverSmartName=b,this.lastSmartNameActive=c,this.editor.smartnameTooltipFunction&&(d=a=this.editor.smartnameTooltipFunction(b.getFullName(),c,e)))):(this.lastHoverSmartName=null,d=a=!1);a?(d&&(this.width=this.getWidth(),this.height=this.getHeight()),this.show(null,this.x,this.y)):this.hide()};this.onMouseMove=function(a){this.x=a.clientX;this.y=a.clientY;this.isOpen&&(this.lastT=a.timeStamp,this.setPosition(this.x,this.y));this.$timer||
(this.$timer=setTimeout(this.update,100))};this.onMouseOut=function(a){if(!a||!a.currentTarget.contains(a.relatedTarget))this.hide(),this.$timer=clearTimeout(this.$timer),this.lastHoverSmartName=null};this.setPosition=function(a,b){a+10+this.width>this.maxWidth&&(a=window.innerWidth-this.width-10);if(b>0.75*window.innerHeight||b+20+this.height>this.maxHeight)b=b-this.height-30;i.prototype.setPosition.call(this,a+10,b+20)};this.destroy=function(){this.onMouseOut();g.removeListener(this.editor.renderer.scroller,
"mousemove",this.onMouseMove);g.removeListener(this.editor.renderer.content,"mouseout",this.onMouseOut);delete this.editor.smartnameTooltip}}).call(h.prototype);k.SmartNameTooltip=h});