/* =============================================================
 * bootstrap3-typeahead.js v3.1.0
 * https://github.com/bassjobsen/Bootstrap-3-Typeahead
 * =============================================================
 * Original written by @mdo and @fat
 * =============================================================
 * Copyright 2014 Bass Jobsen @bassjobsen
 *
 * Licensed under the Apache License, Version 2.0 (the 'License');
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an 'AS IS' BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ============================================================ */

(function(b,c){"undefined"!==typeof module&&module.exports?module.exports=c(require("jquery")):"function"===typeof define&&define.amd?define(["jquery"],function(b){return c(b)}):c(b.jQuery)})(this,function(b){var c=function(a,e){this.$element=b(a);this.options=b.extend({},b.fn.typeahead.defaults,e);this.matcher=this.options.matcher||this.matcher;this.sorter=this.options.sorter||this.sorter;this.select=this.options.select||this.select;this.autoSelect="boolean"==typeof this.options.autoSelect?this.options.autoSelect:
!0;this.highlighter=this.options.highlighter||this.highlighter;this.render=this.options.render||this.render;this.updater=this.options.updater||this.updater;this.displayText=this.options.displayText||this.displayText;this.source=this.options.source;this.delay=this.options.delay;this.$menu=b(this.options.menu);this.$appendTo=this.options.appendTo?b(this.options.appendTo):null;this.shown=!1;this.listen();this.showHintOnFocus="boolean"==typeof this.options.showHintOnFocus?this.options.showHintOnFocus:
!1;this.afterSelect=this.options.afterSelect;this.addItem=!1};c.prototype={constructor:c,select:function(){var a=this.$menu.find(".active").data("value");this.$element.data("active",a);if(this.autoSelect||a)a=this.updater(a),this.$element.val(this.displayText(a)||a).change(),this.afterSelect(a);return this.hide()},updater:function(a){return a},setSource:function(a){this.source=a},show:function(){var a=b.extend({},this.$element.position(),{height:this.$element[0].offsetHeight}),e;e="function"==typeof this.options.scrollHeight?
this.options.scrollHeight.call():this.options.scrollHeight;(this.$appendTo?this.$menu.appendTo(this.$appendTo):this.$menu.insertAfter(this.$element)).css({top:a.top+a.height+e,left:a.left}).show();this.shown=!0;return this},hide:function(){this.$menu.hide();this.shown=!1;return this},lookup:function(a){this.query="undefined"!=typeof a&&null!==a?a:this.$element.val()||"";if(this.query.length<this.options.minLength)return this.shown?this.hide():this;a=b.proxy(function(){b.isFunction(this.source)?this.source(this.query,
b.proxy(this.process,this)):this.source&&this.process(this.source)},this);clearTimeout(this.lookupWorker);this.lookupWorker=setTimeout(a,this.delay)},process:function(a){var e=this,a=b.grep(a,function(a){return e.matcher(a)}),a=this.sorter(a);if(!a.length&&!this.options.addItem)return this.shown?this.hide():this;0<a.length?this.$element.data("active",a[0]):this.$element.data("active",null);this.options.addItem&&a.push(this.options.addItem);return"all"==this.options.items?this.render(a).show():this.render(a.slice(0,
this.options.items)).show()},matcher:function(a){return~this.displayText(a).toLowerCase().indexOf(this.query.toLowerCase())},sorter:function(a){for(var b=[],g=[],d=[],f;f=a.shift();){var h=this.displayText(f);h.toLowerCase().indexOf(this.query.toLowerCase())?~h.indexOf(this.query)?g.push(f):d.push(f):b.push(f)}return b.concat(g,d)},highlighter:function(a){var e=b("<div></div>"),g=this.query,d=a.toLowerCase().indexOf(g.toLowerCase()),f,h,c;f=g.length;if(0===f)return e.text(a).html();for(;-1<d;)h=a.substr(0,
d),c=a.substr(d,f),a=a.substr(d+f),c=b("<strong></strong>").text(c),e.append(document.createTextNode(h)).append(c),d=a.toLowerCase().indexOf(g.toLowerCase());return e.append(document.createTextNode(a)).html()},render:function(a){var e=this,c=this,d=!1,a=b(a).map(function(a,h){var i=c.displayText(h),a=b(e.options.item).data("value",h);a.find("a").html(e.highlighter(i));i==c.$element.val()&&(a.addClass("active"),c.$element.data("active",h),d=!0);return a[0]});this.autoSelect&&!d&&(a.first().addClass("active"),
this.$element.data("active",a.first().data("value")));this.$menu.html(a);return this},displayText:function(a){return a.name||a},next:function(){var a=this.$menu.find(".active").removeClass("active").next();a.length||(a=b(this.$menu.find("li")[0]));a.addClass("active")},prev:function(){var a=this.$menu.find(".active").removeClass("active").prev();a.length||(a=this.$menu.find("li").last());a.addClass("active")},listen:function(){this.$element.on("focus",b.proxy(this.focus,this)).on("blur",b.proxy(this.blur,
this)).on("keypress",b.proxy(this.keypress,this)).on("keyup",b.proxy(this.keyup,this));if(this.eventSupported("keydown"))this.$element.on("keydown",b.proxy(this.keydown,this));this.$menu.on("click",b.proxy(this.click,this)).on("mouseenter","li",b.proxy(this.mouseenter,this)).on("mouseleave","li",b.proxy(this.mouseleave,this))},destroy:function(){this.$element.data("typeahead",null);this.$element.data("active",null);this.$element.off("focus").off("blur").off("keypress").off("keyup");this.eventSupported("keydown")&&
this.$element.off("keydown");this.$menu.remove()},eventSupported:function(a){var b=a in this.$element;b||(this.$element.setAttribute(a,"return;"),b="function"===typeof this.$element[a]);return b},move:function(a){if(this.shown)switch(a.keyCode){case 9:case 13:case 27:a.preventDefault();break;case 38:if(a.shiftKey)break;a.preventDefault();this.prev();break;case 40:if(a.shiftKey)break;a.preventDefault();this.next()}},keydown:function(a){this.suppressKeyPressRepeat=~b.inArray(a.keyCode,[40,38,9,13,27]);
!this.shown&&40==a.keyCode?this.lookup():this.move(a)},keypress:function(a){this.suppressKeyPressRepeat||this.move(a)},keyup:function(a){switch(a.keyCode){case 40:case 38:case 16:case 17:case 18:break;case 9:case 13:if(!this.shown)return;this.select();break;case 27:if(!this.shown)return;this.hide();break;default:this.lookup()}a.preventDefault()},focus:function(){this.focused||(this.focused=!0,this.options.showHintOnFocus&&this.lookup(""))},blur:function(){this.focused=!1;!this.mousedover&&this.shown&&
this.hide()},click:function(a){a.preventDefault();this.select();this.$element.focus()},mouseenter:function(a){this.mousedover=!0;this.$menu.find(".active").removeClass("active");b(a.currentTarget).addClass("active")},mouseleave:function(){this.mousedover=!1;!this.focused&&this.shown&&this.hide()}};var j=b.fn.typeahead;b.fn.typeahead=function(a){var e=arguments;return"string"==typeof a&&"getActive"==a?this.data("active"):this.each(function(){var g=b(this),d=g.data("typeahead"),f="object"==typeof a&&
a;d||g.data("typeahead",d=new c(this,f));if("string"==typeof a)if(1<e.length)d[a].apply(d,Array.prototype.slice.call(e,1));else d[a]()})};b.fn.typeahead.defaults={source:[],items:8,menu:'<ul class="typeahead dropdown-menu" role="listbox"></ul>',item:'<li><a href="#" role="option"></a></li>',minLength:1,scrollHeight:0,autoSelect:!0,afterSelect:b.noop,addItem:!1,delay:0};b.fn.typeahead.Constructor=c;b.fn.typeahead.noConflict=function(){b.fn.typeahead=j;return this};b(document).on("focus.typeahead.data-api",
'[data-provide="typeahead"]',function(){var a=b(this);a.data("typeahead")||a.typeahead(a.data())})});