/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(g,c){c.getDocumentHead=function(a){a||(a=document);return a.head||a.getElementsByTagName("head")[0]||a.documentElement};c.createElement=function(a,b){return document.createElementNS?document.createElementNS(b||"http://www.w3.org/1999/xhtml",a):document.createElement(a)};c.hasCssClass=function(a,b){return-1!==(a.className||"").split(/\s+/g).indexOf(b)};c.addCssClass=function(a,b){c.hasCssClass(a,b)||(a.className+=" "+b)};c.removeCssClass=function(a,b){for(var e=
a.className.split(/\s+/g);;){var c=e.indexOf(b);if(-1==c)break;e.splice(c,1)}a.className=e.join(" ")};c.toggleCssClass=function(a,b){for(var c=a.className.split(/\s+/g),d=!0;;){var f=c.indexOf(b);if(-1==f)break;d=!1;c.splice(f,1)}d&&c.push(b);a.className=c.join(" ");return d};c.setCssClass=function(a,b,e){e?c.addCssClass(a,b):c.removeCssClass(a,b)};c.hasCssString=function(a,b){var c=0,d,b=b||document;if(b.createStyleSheet&&(d=b.styleSheets))for(;c<d.length;){if(d[c++].owningElement.id===a)return!0}else if(d=
b.getElementsByTagName("style"))for(;c<d.length;)if(d[c++].id===a)return!0;return!1};c.importCssString=function(a,b,e){e=e||document;if(b&&c.hasCssString(b,e))return null;var d;e.createStyleSheet?(d=e.createStyleSheet(),d.cssText=a,b&&(d.owningElement.id=b)):(d=e.createElementNS?e.createElementNS("http://www.w3.org/1999/xhtml","style"):e.createElement("style"),d.appendChild(e.createTextNode(a)),b&&(d.id=b),c.getDocumentHead(e).appendChild(d))};c.importCssStylsheet=function(a,b){if(b.createStyleSheet)b.createStyleSheet(a);
else{var e=c.createElement("link");e.rel="stylesheet";e.href=a;c.getDocumentHead(b).appendChild(e)}};c.getInnerWidth=function(a){return parseInt(c.computedStyle(a,"paddingLeft"),10)+parseInt(c.computedStyle(a,"paddingRight"),10)+a.clientWidth};c.getInnerHeight=function(a){return parseInt(c.computedStyle(a,"paddingTop"),10)+parseInt(c.computedStyle(a,"paddingBottom"),10)+a.clientHeight};"undefined"!=typeof document&&(void 0!==window.pageYOffset?(c.getPageScrollTop=function(){return window.pageYOffset},
c.getPageScrollLeft=function(){return window.pageXOffset}):(c.getPageScrollTop=function(){return document.body.scrollTop},c.getPageScrollLeft=function(){return document.body.scrollLeft}),c.computedStyle=window.getComputedStyle?function(a,b){return b?(window.getComputedStyle(a,"")||{})[b]||"":window.getComputedStyle(a,"")||{}}:function(a,b){return b?a.currentStyle[b]:a.currentStyle},c.scrollbarWidth=function(a){var b=c.createElement("ace_inner");b.style.width="100%";b.style.minWidth="0px";b.style.height=
"200px";b.style.display="block";var e=c.createElement("ace_outer"),d=e.style;d.position="absolute";d.left="-10000px";d.overflow="hidden";d.width="200px";d.minWidth="0px";d.height="150px";d.display="block";e.appendChild(b);a=a.documentElement;a.appendChild(e);var f=b.offsetWidth;d.overflow="scroll";b=b.offsetWidth;f==b&&(b=e.clientWidth);a.removeChild(e);return f-b},c.setInnerHtml=function(a,b){var c=a.cloneNode(!1);c.innerHTML=b;a.parentNode.replaceChild(c,a);return c},"textContent"in document.documentElement?
(c.setInnerText=function(a,b){a.textContent=b},c.getInnerText=function(a){return a.textContent}):(c.setInnerText=function(a,b){a.innerText=b},c.getInnerText=function(a){return a.innerText}),c.getParentWindow=function(a){return a.defaultView||a.parentWindow})});