/******************************************************************************
 * jquery.i18n.properties
 *
 * Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and
 * MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses.
 *
 * @version     1.2.2
 * @url         https://github.com/jquery-i18n-properties/jquery-i18n-properties
 * @inspiration Localisation assistance for jQuery (http://keith-wood.name/localisation.html)
 *              by Keith Wood (kbwood{at}iinet.com.au) June 2007
 *
 *****************************************************************************/

!function(h){function q(b){b.async&&(b.filesLoaded+=1,b.filesLoaded===b.totalFiles&&b.callback&&b.callback())}function m(b,a){h.ajax({url:b,async:a.async,cache:a.cache,dataType:"text",success:function(b){s(b,a.mode);q(a)},error:function(){console.log("Failed to download or parse "+b);q(a)}})}function s(b,a){for(var e="",c=b.split(/\n/),d=/(\{\d+})/g,r=/\{(\d+)}/g,i=/(\\u.{4})/gi,k=0;k<c.length;k++)if(c[k]=c[k].replace(/^\s\s*/,"").replace(/\s\s*$/,""),0<c[k].length&&"#"!=c[k].match("^#")){var g=c[k].split("=");
if(0<g.length){for(var f=decodeURI(g[0]).replace(/^\s\s*/,"").replace(/\s\s*$/,""),j=1==g.length?"":g[1];"\\"==j.match(/\\$/);)j=j.substring(0,j.length-1),j+=c[++k].replace(/\s\s*$/,"");for(var l=2;l<g.length;l++)j+="="+g[l];if(j=j.replace(/^\s\s*/,"").replace(/\s\s*$/,""),"map"==a||"both"==a){if(g=j.match(i))for(l=0;l<g.length;l++)j=j.replace(g[l],t(g[l]));h.i18n.map[f]=j}if("vars"==a||"both"==a)if(j=j.replace(/"/g,'\\"'),u(f),d.test(j)){for(var g=j.split(d),l=!0,p="",m=[],n=0;n<g.length;n++)!d.test(g[n])||
0!=m.length&&-1!=m.indexOf(g[n])||(l||(p+=","),p+=g[n].replace(r,"v$1"),m.push(g[n]),l=!1);e+=f+"=function("+p+"){";f='"'+j.replace(r,'"+v$1+"')+'"';e+="return "+f+";};"}else e+=f+'="'+j+'";'}}eval(e)}function u(b){if(/\./.test(b))for(var a="",b=b.split(/\./),e=0;e<b.length;e++)0<e&&(a+="."),a+=b[e],eval("typeof "+a+' == "undefined"')&&eval(a+"={};")}function t(b){var a=[],b=parseInt(b.substr(2),16);0<=b&&b<Math.pow(2,16)&&a.push(b);for(var b="",e=0;e<a.length;++e)b+=String.fromCharCode(a[e]);return b}
h.i18n={};h.i18n.map={};h.i18n.properties=function(b){b=h.extend({name:"Messages",language:"",path:"",mode:"vars",cache:!1,encoding:"UTF-8",async:!1,checkAvailableLanguages:!1,callback:null},b);b.language=this.normaliseLanguageCode(b.language);var a=function(a){b.totalFiles=0;b.filesLoaded=0;var c=b.name&&b.name.constructor==Array?b.name:[b.name];if(b.async)for(var d=0,f=c.length;f>d;d++){b.totalFiles+=1;var i=b.language.substring(0,2);if(0!=a.length&&-1==h.inArray(i,a)||(b.totalFiles+=1),5<=b.language.length)i=
b.language.substring(0,5),0!=a.length&&-1==h.inArray(i,a)||(b.totalFiles+=1)}d=0;for(f=c.length;f>d;d++)if(m(b.path+c[d]+".properties",b),i=b.language.substring(0,2),0!=a.length&&-1==h.inArray(i,a)||m(b.path+c[d]+"_"+i+".properties",b),5<=b.language.length)i=b.language.substring(0,5),0!=a.length&&-1==h.inArray(i,a)||m(b.path+c[d]+"_"+i+".properties",b);b.callback&&!b.async&&b.callback()};b.checkAvailableLanguages?h.ajax({url:b.path+"languages.json",async:b.async,cache:!1,success:function(b){a(b.languages||
[])}}):a([])};h.i18n.prop=function(b){var a=h.i18n.map[b];if(null==a)return"["+b+"]";var e;2==arguments.length&&h.isArray(arguments[1])&&(e=arguments[1]);var c;if("string"==typeof a){for(c=0;-1!=(c=a.indexOf("\\",c));)a="t"==a.charAt(c+1)?a.substring(0,c)+"\t"+a.substring(c++ +2):"r"==a.charAt(c+1)?a.substring(0,c)+"\r"+a.substring(c++ +2):"n"==a.charAt(c+1)?a.substring(0,c)+"\n"+a.substring(c++ +2):"f"==a.charAt(c+1)?a.substring(0,c)+"\f"+a.substring(c++ +2):"\\"==a.charAt(c+1)?a.substring(0,c)+
"\\"+a.substring(c++ +2):a.substring(0,c)+a.substring(c+1);var d,f,i=[];for(c=0;c<a.length;)if("'"==a.charAt(c))if(c==a.length-1)a=a.substring(0,c);else if("'"==a.charAt(c+1))a=a.substring(0,c)+a.substring(++c);else{for(d=c+2;-1!=(d=a.indexOf("'",d));){if(d==a.length-1||"'"!=a.charAt(d+1)){a=a.substring(0,c)+a.substring(c+1,d)+a.substring(d+1);c=d-1;break}a=a.substring(0,d)+a.substring(++d)}-1==d&&(a=a.substring(0,c)+a.substring(c+1))}else"{"==a.charAt(c)?(d=a.indexOf("}",c+1),-1==d)?c++:(f=parseInt(a.substring(c+
1,d)),!isNaN(f)&&0<=f)?(c=a.substring(0,c),""!=c&&i.push(c),i.push(f),c=0,a=a.substring(d+1)):c=d+1:c++;""!=a&&i.push(a);a=i;h.i18n.map[b]=i}if(0==a.length)return"";if(1==a.length&&"string"==typeof a[0])return a[0];d="";for(c=0;c<a.length;c++)d+="string"==typeof a[c]?a[c]:e&&a[c]<e.length?e[a[c]]:!e&&a[c]+1<arguments.length?arguments[a[c]+1]:"{"+a[c]+"}";return d};h.i18n.normaliseLanguageCode=function(b){return(!b||2>b.length)&&(b=navigator.languages?navigator.languages[0]:navigator.language||navigator.userLanguage||
"en"),b=b.toLowerCase(),b=b.replace(/-/,"_"),3<b.length&&(b=b.substring(0,3)+b.substring(3).toUpperCase()),b};var f;f||(f=function(b,a,e){if("[object RegExp]"!==Object.prototype.toString.call(a))return"undefined"==typeof f._nativeSplit?b.split(a,e):f._nativeSplit.call(b,a,e);var c,d,h,i,k=[],g=0,m=(a.ignoreCase?"i":"")+(a.multiline?"m":"")+(a.sticky?"y":""),a=RegExp(a.source,m+"g");if(b+="",f._compliantExecNpcg||(c=RegExp("^"+a.source+"$(?!\\s)",m)),void 0===e||0>+e)e=1/0;else if(e=Math.floor(+e),
!e)return[];for(;(d=a.exec(b))&&(h=d.index+d[0].length,!(h>g&&(k.push(b.slice(g,d.index)),!f._compliantExecNpcg&&1<d.length&&d[0].replace(c,function(){for(var a=1;a<arguments.length-2;a++)void 0===arguments[a]&&(d[a]=void 0)}),1<d.length&&d.index<b.length&&Array.prototype.push.apply(k,d.slice(1)),i=d[0].length,g=h,k.length>=e)));)a.lastIndex===d.index&&a.lastIndex++;return g===b.length?!i&&a.test("")||k.push(""):k.push(b.slice(g)),k.length>e?k.slice(0,e):k},f._compliantExecNpcg=void 0===/()??/.exec("")[1],
f._nativeSplit=String.prototype.split);String.prototype.split=function(b,a){return f(this,b,a)}}(jQuery);