/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define(["underscore","backbone"],function(){return{radians:function(a){return a*Math.PI/180},degrees:function(a){return 180*a/Math.PI},clamp:function(a,d,b){return Math.min(Math.max(a,d),b)},isPowerOfTwo:function(a){return 0==(a&a-1)},nextHighestPowerOfTwo:function(a){--a;for(var d=1;32>d;d<<=1)a|=a>>d;return a+1},CreateConvexHullFromPointlist:function(a){var d=a.length,b,e,c,f,h;e=0;for(b=1;b<d;b++)if(a[b].y<a[e].y||a[b].y==a[e].y&&a[b].x>a[e].x)e=b;a[d]=a[e];for(c=f=0;c<d;c++){b=a[c];a[c]=a[e];
a[e]=b;e=d;h=f;f=2*Math.PI;for(b=c+1;b<=d;b++){var g=Math.atan2(a[b].y-a[c].y,a[b].x-a[c].x);0>g&&(g+=2*Math.PI);g>h&&g<f&&(e=b,f=g)}if(e==d)return c+1}},ConvexHullCenter:function(a,d){for(var b=new THREE.Vector2(0,0),e=0;e<d;e++)b.add(a[e]);b.divideScalar(d);return b},ConvexHullContainsPoint:function(a,d,b){for(var e=!1,c=0,f=d-1;c<d;f=c++)a[c].y>b.y!=a[f].y>b.y&&b.x<(a[f].x-a[c].x)*(b.y-a[c].y)/(a[f].y-a[c].y)+a[c].x&&(e=!e);return e},CheckLineIntersection:function(a,d,b,e,c,f,h,g){var l,i,j,m,
k={x:null,y:null,onLine1:!1,onLine2:!1};l=(g-f)*(b-a)-(h-c)*(e-d);if(0==l)return k;i=d-f;j=a-c;m=(b-a)*i-(e-d)*j;i=((h-c)*i-(g-f)*j)/l;j=m/l;k.x=a+i*(b-a);k.y=d+i*(e-d);0<i&&1>i&&(k.onLine1=!0);0<j&&1>j&&(k.onLine2=!0);return k},SemiStraightLineConvexHullIntersection:function(a,d,b,e){for(var c,f,h=0;h<d;h++){var g=new THREE.Vector2(b.x+e.x,b.y+e.y);c=this.CheckLineIntersection(a[h].x,a[h].y,a[(h+1)%d].x,a[(h+1)%d].y,b.x,b.y,g.x,g.y);c.onLine1&&(void 0===f?f=new THREE.Vector2(c.x,c.y):(c=new THREE.Vector2(c.x,
c.y),g.distanceToSquared(f)>g.distanceToSquared(c)&&(f=c)))}return f}}});