/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/VertexShaderQuad","WV3Dmod/shaders/ShaderUtils"],function(c,a,b){return{uniforms:{canvas_size:{type:"v2",value:null},CXRT:{type:"t",value:null},OpaqueRT:{type:"t",value:null},EnableMask:{type:"i",value:0},EnableRefOpacity:{type:"i",value:0},EnableInvRefOpacity:{type:"i",value:0},reflection_opacity:{type:"f",value:0},reflection_fade:{type:"i",value:0},reflection_fade_size:{type:"f",value:0},reflection_fade_position:{type:"f",value:0}},vertexShader:a.vertexShader,
fragmentShader:["uniform vec2 canvas_size;\nuniform sampler2D CXRT;\nuniform sampler2D OpaqueRT;\nuniform bool EnableMask;\nuniform bool EnableRefOpacity;\nuniform bool EnableInvRefOpacity;\nuniform float reflection_opacity;\nuniform bool reflection_fade;\nuniform float reflection_fade_size;\nuniform float reflection_fade_position;\nvoid main()\n{\nvec2 loc = vec2(gl_FragCoord.x/canvas_size.x, gl_FragCoord.y/canvas_size.y);\nfloat tex_opaquert = texture2D(OpaqueRT, loc).r;\nif (EnableMask && (tex_opaquert == 0.)) discard;\nfloat refopacity = reflection_opacity;\nif(EnableRefOpacity)\n{",
b.get("ReflectionFadeChunck"),"}\nelse\n{\nrefopacity = 1.;\n}\ngl_FragColor = texture2D(CXRT, loc) * refopacity + (EnableInvRefOpacity? vec4(1.) * (1. - refopacity) : vec4(0.));\n}"].join("\n")}});