/**
 * @author DOGO
 *
 * Trivial peak detection by summing signed gradient values from "horizontal"
 * neighbors, from "vertical" neighbors, and from diagonals
 *
 * @module WebViewer3D
 * @copyright   2016 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/ShaderUtils","WV3Dmod/shaders/VertexShaderQuad"],function(a,b,c){return{uniforms:{depth_texture:{type:"t",value:null},canvas_size:{type:"v2",value:new a.Vector2(512,512)},color:{type:"v3",value:new a.Vector3(0,0,0)},offsetRepeat:{type:"v4",value:new a.Vector4(0,0,1,1)},backTexture:{type:"i",value:0},flipNormals:{type:"i",value:0}},vertexShader:c.vertexShader,fragmentShader:["uniform sampler2D depth_texture;\nuniform vec3 color;\nuniform vec2 canvas_size;\nvec2 texel;\nvec2 vUv;",
b.get("EncodeDepthChunck"),b.get("DecodeDepthChunck"),"void main(void)\n{\nmat3 I;\nvUv = gl_FragCoord.xy;\ntexel = vec2(1.0 / canvas_size.x, 1.0 / canvas_size.y);\nI[0][0] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2(-1.0,-1.0))));\nI[1][0] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 0.0,-1.0))));\nI[2][0] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 1.0,-1.0))));\nI[0][1] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2(-1.0, 0.0))));\nI[1][1] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 0.0, 0.0))));\nI[2][1] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 1.0, 0.0))));\nI[0][2] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2(-1.0, 1.0))));\nI[1][2] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 0.0, 1.0))));\nI[2][2] = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 1.0, 1.0))));\nfloat h_val = I[0][0] + 2.*I[1][0] + I[2][0] + I[0][2] + 2.*I[1][2] + I[2][2] - 8.*I[1][1];\nfloat v_val = I[0][0] + 2.*I[0][1] + I[0][2] + I[2][0] + 2.*I[2][1] + I[2][2] - 8.*I[1][1];\nfloat d1_val = 2.*I[0][0] + I[1][0] + I[0][1] + 2.*I[2][2] + I[1][2] + I[2][1] - 8.*I[1][1];\nfloat d2_val = I[1][0] + 2.*I[2][0] + I[2][1] + I[0][1] + 2.*I[0][2] + I[1][2] - 8.*I[1][1];\nif (abs(h_val) > 0.003 || abs(v_val) > 0.003 || abs(d1_val) > 0.003 ||abs(d2_val) > 0.003 ) gl_FragColor = vec4(color, 1.);\nelse discard;\n} "].join("\n")}});