/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define(["underscore","backbone","WV3Dlib/three"],function(n,p,k){return{radians:function(b){return b*Math.PI/180},degrees:function(b){return 180*b/Math.PI},clamp:function(b,f,a){return Math.min(Math.max(b,f),a)},isPowerOfTwo:function(b){return 0==(b&b-1)},nextHighestPowerOfTwo:function(b){--b;for(var f=1;32>f;f<<=1)b|=b>>f;return b+1},CreateConvexHullFromPointlist:function(b){var f=b.length,a,d,e,c,h;d=0;for(a=1;a<f;a++)if(b[a].y<b[d].y||b[a].y==b[d].y&&b[a].x>b[d].x)d=a;b[f]=b[d];for(e=c=0;e<f;e++){a=
b[e];b[e]=b[d];b[d]=a;d=f;h=c;c=2*Math.PI;for(a=e+1;a<=f;a++){var g=Math.atan2(b[a].y-b[e].y,b[a].x-b[e].x);0>g&&(g+=2*Math.PI);g>h&&g<c&&(d=a,c=g)}if(d==f)return e+1}},ConvexHullCenter:function(b,f){for(var a=new k.Vector2(0,0),d=0;d<f;d++)a.add(b[d]);a.divideScalar(f);return a},ConvexHullContainsPoint:function(b,f,a){for(var d=!1,e=0,c=f-1;e<f;c=e++)b[e].y>a.y!=b[c].y>a.y&&a.x<(b[c].x-b[e].x)*(a.y-b[e].y)/(b[c].y-b[e].y)+b[e].x&&(d=!d);return d},CheckLineIntersection:function(b,f,a,d,e,c,h,g){var i,
j,l,k,m={x:null,y:null,onLine1:!1,onLine2:!1};i=(g-c)*(a-b)-(h-e)*(d-f);if(0==i)return m;j=f-c;l=b-e;k=(a-b)*j-(d-f)*l;j=((h-e)*j-(g-c)*l)/i;l=k/i;m.x=b+j*(a-b);m.y=f+j*(d-f);0<j&&1>j&&(m.onLine1=!0);0<l&&1>l&&(m.onLine2=!0);return m},SemiStraightLineConvexHullIntersection:function(b,f,a,d){for(var e,c,h=0;h<f;h++){var g=new k.Vector2(a.x+d.x,a.y+d.y);e=this.CheckLineIntersection(b[h].x,b[h].y,b[(h+1)%f].x,b[(h+1)%f].y,a.x,a.y,g.x,g.y);e.onLine1&&(void 0===c?c=new k.Vector2(e.x,e.y):(e=new k.Vector2(e.x,
e.y),g.distanceToSquared(c)>g.distanceToSquared(e)&&(c=e)))}return c},SmartEaseInEaseOutInterpolation:function(b,f,a,d){var e=f-b,c,h;c=Math.min(1E3,0.1*d);h=Math.min(1E3,0.9*d);var g=d-c-h,d=e/(0.5*(c+h)+g),e=0.5*c*d,d=0.5*h*d,i=0;a<c||a>c+g?a<c?(a/=c,c=a*a*a,a=2*(c-0.5*c*a),i=(1-a)*b+a*(b+e)):(a=1-(a-(c+g))/h,c=a*a*a,a=2*(c-0.5*c*a),i=a*(f-d)+(1-a)*f):(a=(a-c)/g,i=(1-a)*(b+e)+a*(f-d));return i}}});