/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define(["underscore","backbone","WV3Dmod/HttpRequestManager","WV3Dmod/LogMessage"],function(l,j,k,e){return j.Model.extend({initialize:function(a,d,c){e.Log("Creating WV3DAssetLoader Object");this.set("_httprequestmanager",new k(a,d,c))},SetResource:function(a){this.set("_jsondata",a)},IsURL:function(a){return this.get("_httprequestmanager").IsURL(a)},GetFileName:function(a){return this.get("_httprequestmanager").GetFileName(a)},GetAssetName:function(a){return this.get("_httprequestmanager").GetAssetName(a)},
LoadURL:function(a,d){this.get("_httprequestmanager").LoadURL(a,d)},Printresourceinfo:function(){e.Log("AssetLoader Printresourceinfo function");for(var a="",d=this.get("_jsondata"),c=0,b=Object.keys(d),f=b.length;c<f;++c)var h=b[c],a=a+h+": "+d[h]+" / ";e.Log(a)},Getresourcelocation:function(a){if(a.hasOwnProperty("AssetType"))switch(a.AssetType){case "Scene":return"Reference";default:return"NoLocation"}else if(a.hasOwnProperty("AssetRef"))return"NoLocation"},Getrootnode:function(){e.Log("AssetLoader GetRootnode function");
return this.get("_jsondata")},Getrootnoderefname:function(){e.Log("AssetLoader GetRootnode function");return this.get("_jsondata").TopLevelAsset.AssetRef},GetAssetFromName:function(a,d,c){for(var b=[],f=0,e=Object.keys(a),g=e.length;f<g;++f){var i=e[f];"object"==typeof a[i]?b=b.concat(this.GetAssetFromName(a[i],d,c)):i==d&&a[d]==c&&b.push(a)}return b},GetRefChildrenFromName:function(a,d){var c=[];if(a.hasOwnProperty("Children")&&null!==a.Children&&""!==a.Children){if(null===a.Children)return c;0==
a.Children.length&&e.Log("No Children found for this node");c=c.concat(a.Children)}else if(a.hasOwnProperty("AssetRef")&&null!==a.AssetRef){var b=[];if(this.IsURL(a.AssetRef)){if(this.get("_httprequestmanager").IsRelativeURL(a.AssetRef)){var f=this.get("_httprequestmanager").GetRealURLWithAppendedRef(a.AssetRef,d);a.AssetRef=f}}else b=b.concat(this.get("_jsondata").Assets[a.AssetRef]);0==b.length?e.Log("No Reference found with AssetId: "+a.AssetRef):(1<b.length&&e.Log("Warning: AssetId in json structure is supposed to be unique: only one item returned for AssetId: "+
a.AssetRef),c.push(b[0]))}else for(var b=0,f=Object.keys(a),h=f.length;b<h;++b){var g=f[b];if(a[g]&&(a[g].hasOwnProperty("Children")||a[g].hasOwnProperty("AssetRef")||a[g].hasOwnProperty("Assets")))c=c.concat(a[g])}return c}})});