/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define(["underscore","backbone","WV3Dlib/three"],function(p,n,k){return new (n.Model.extend({radians:function(a){return a*Math.PI/180},degrees:function(a){return 180*a/Math.PI},clamp:function(a,d,b){return Math.min(Math.max(a,d),b)},isPowerOfTwo:function(a){return 0==(a&a-1)},nextHighestPowerOfTwo:function(a){--a;for(var d=1;32>d;d<<=1)a|=a>>d;return a+1},CreateConvexHullFromPointlist:function(a){var d=a.length,b,f,e,c,g;f=0;for(b=1;b<d;b++)if(a[b].y<a[f].y||a[b].y==a[f].y&&a[b].x>a[f].x)f=b;a[d]=
a[f];for(e=c=0;e<d;e++){b=a[e];a[e]=a[f];a[f]=b;f=d;g=c;c=2*Math.PI;for(b=e+1;b<=d;b++){var h=Math.atan2(a[b].y-a[e].y,a[b].x-a[e].x);0>h&&(h+=2*Math.PI);h>g&&h<c&&(f=b,c=h)}if(f==d)return e+1}},ConvexHullCenter:function(a,d){for(var b=new k.Vector2(0,0),f=0;f<d;f++)b.add(a[f]);b.divideScalar(d);return b},ConvexHullContainsPoint:function(a,d,b){for(var f=!1,e=0,c=d-1;e<d;c=e++)a[e].y>b.y!=a[c].y>b.y&&b.x<(a[c].x-a[e].x)*(b.y-a[e].y)/(a[c].y-a[e].y)+a[e].x&&(f=!f);return f},CheckLineIntersection:function(a,
d,b,f,e,c,g,h){var i,j,l,k,m={x:null,y:null,onLine1:!1,onLine2:!1};i=(h-c)*(b-a)-(g-e)*(f-d);if(0==i)return m;j=d-c;l=a-e;k=(b-a)*j-(f-d)*l;j=((g-e)*j-(h-c)*l)/i;l=k/i;m.x=a+j*(b-a);m.y=d+j*(f-d);0<j&&1>j&&(m.onLine1=!0);0<l&&1>l&&(m.onLine2=!0);return m},SemiStraightLineConvexHullIntersection:function(a,d,b,f){for(var e,c,g=0;g<d;g++){var h=new k.Vector2(b.x+f.x,b.y+f.y);e=this.CheckLineIntersection(a[g].x,a[g].y,a[(g+1)%d].x,a[(g+1)%d].y,b.x,b.y,h.x,h.y);e.onLine1&&(void 0===c?c=new k.Vector2(e.x,
e.y):(e=new k.Vector2(e.x,e.y),h.distanceToSquared(c)>h.distanceToSquared(e)&&(c=e)))}return c},SmartEaseInEaseOutInterpolation:function(a,d,b,f){var e=d-a,c,g;c=Math.min(1E3,0.1*f);g=Math.min(1E3,0.9*f);var h=f-c-g,f=e/(0.5*(c+g)+h),e=0.5*c*f,f=0.5*g*f,i=0;b<c||b>c+h?b<c?(b/=c,c=b*b*b,b=2*(c-0.5*c*b),i=(1-b)*a+b*(a+e)):(b=1-(b-(c+h))/g,c=b*b*b,b=2*(c-0.5*c*b),i=b*(d-f)+(1-b)*d):(b=(b-c)/h,i=(1-b)*(a+e)+b*(d-f));return i},IntersectCellSegment:function(a,d){var b=Math.min(d.startU,d.endU),f=Math.max(d.startU,
d.endU);f>a.right&&(f=a.right);b<a.left&&(b=a.left);if(b>f)return!1;var e=d.startV,c=d.endV,g=d.endU-d.startU;1E-7<Math.abs(g)&&(c=(d.endV-d.startV)/g,g=d.startV-c*d.startU,e=c*b+g,c=c*f+g);e>c&&(e=[c,c=e][0]);c>a.top&&(c=a.top);e<a.bottom&&(e=a.bottom);return e>c?!1:!0}}))});