/**
 * @author SVN & DOGO (Original by RAVO)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/VertexShaderNPM","WV3Dmod/shaders/ShaderUtils"],function(b,c,a){return{uniforms:b.UniformsUtils.merge([c.uniforms,{diffuseColor:{type:"c",value:new b.Color(16777215)},opacity:{type:"f",value:null},diffuseTexture:{type:"t",value:null},isFloorReflection:{type:"i",value:0},irradianceCubeMap:{type:"t",value:null},envMapRotQuat:{type:"v4",value:new b.Vector4(0,0,0,1)},shadowsShadingContrast:{type:"f",value:0.3},canvas_size:{type:"v2",value:new b.Vector2(1,1)},DX1RT:{type:"t",
value:null},DX2RT:{type:"t",value:null},NBRTSRC:{type:"i",value:0}}]),vertexShader:c.vertexShader,fragmentShader:["varying vec2 texcoordVaryingScaled;\nvarying vec3 vNormal;\nvarying vec4 vPosition;\nvarying vec4 vWorldPosition;\nuniform vec3 diffuseColor;\nuniform float opacity;\nuniform sampler2D diffuseTexture;\nuniform bool isFloorReflection;\nuniform samplerCube irradianceCubeMap;\nuniform vec4 envMapRotQuat;\nuniform float shadowsShadingContrast;",a.get("DeclareDepthSamplersChunck"),a.get("EncodeDepthChunck"),
a.get("DecodeDepthChunck"),a.get("EnvironmentRotationChunck"),"void main()\n{",a.get("SelectPeelChunck"),"#ifdef USE_MAP\nvec4 diffColour = texture2D(diffuseTexture, texcoordVaryingScaled) * vec4(diffuseColor,1.0);\ndiffColour.a = opacity;\n#else\nvec4 diffColour = vec4(diffuseColor,opacity);\n#endif\nvec3 pN = normalize(vNormal);\n#ifdef USE_IRRMAP\nif(isFloorReflection) pN.y = -pN.y;\npN = rotate_vec_from_quat(envMapRotQuat, pN);\nvec4 irradiance = textureCube(irradianceCubeMap, pN);\n#else\nvec4 irradiance = diffColour;\n#endif\nfloat shadowFactor;\nif(shadowsShadingContrast > 0.3)\nshadowFactor = 1.0 + ((shadowsShadingContrast - 0.3) / 0.7);\nelse \nshadowFactor = shadowsShadingContrast / 0.3;\ngl_FragColor = clamp(shadowFactor * irradiance + (1.0 - shadowFactor), 0.0, 1.0) * diffColour.a;\ngl_FragColor.a = diffColour.a ;\n}"].join("\n")}});