/**
 * @author SVN
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/VertexShaderPM","WV3Dmod/shaders/ShaderUtils"],function(b,c,a){return{uniforms:b.UniformsUtils.merge([c.uniforms,{diffuseColor:{type:"c",value:new b.Color(16777215)},opacity:{type:"f",value:null},diffuseTexture:{type:"t",value:null},annotationsTexture:{type:"t",value:null},annotationsAspectRatio:{type:"v2",value:new b.Vector2(1,1)},annotationsThickness:{type:"f",value:1},annotationsColor:{type:"v3",value:new b.Vector3(1,0,0)},isFloorReflection:{type:"i",value:0},
canvas_size:{type:"v2",value:new b.Vector2(0,0)},DX1RT:{type:"t",value:null},DX2RT:{type:"t",value:null},NBRTSRC:{type:"i",value:0}}]),vertexShader:c.vertexShader,fragmentShader:["varying vec2 texcoordVaryingScaled;\nvarying vec2 texcoordVarying;\nvarying vec4 vWorldPosition;\nuniform vec3 diffuseColor;\nuniform float opacity;\nuniform sampler2D diffuseTexture;\n#if ANNOTATION_NUMBER\nuniform sampler2D annotationsTexture;\nuniform vec2 annotationsAspectRatio;\nuniform float annotationsThickness;\nuniform vec3 annotationsColor;\n#endif\nuniform bool isFloorReflection;",
a.get("DeclareDepthSamplersChunck"),a.get("EncodeDepthChunck"),a.get("DecodeDepthChunck"),a.get("SegmentDistance"),"void main()\n{",a.get("SelectPeelChunck"),"vec4 reflResult;",a.get("AnnotationDrawing"),"#if ANNOTATION_NUMBER\nif(!annotated){\n#endif\nvec4 diffColour;\n#ifdef USE_MAP\ndiffColour = texture2D(diffuseTexture, texcoordVaryingScaled);\n#ifdef IS_NPM\ndiffColour.a = opacity;\n#else\n#ifdef REMAPPED_DIFFUSE_ALPHA_CHANNEL\ndiffColour.a = clamp((diffColour.a - 127./255.) * 255. / 127., 0.,1.);\n#endif\n#endif\n#else \ndiffColour = vec4(diffuseColor,opacity);\n#endif\ngl_FragColor.rgb = diffColour.rgb * ( 1.0 - diffColour.a );\ngl_FragColor.a = 1.0;\n#if ANNOTATION_NUMBER\n} else gl_FragColor=vec4(0.,0.,0.,1.);\n#endif\n}"].join("\n")}});