/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2014-2016 Patrick Gansterer <paroga@paroga.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

(function(v,s){var x=5.9604644775390625E-8,t=4294967296,w=9007199254740992,u={encode:function(l){function i(a){for(var b=j.byteLength,d=e+a;b<d;)b<<=1;if(b!==j.byteLength){d=p;j=new ArrayBuffer(b);p=new DataView(j);for(var b=e+3>>2,c=0;c<b;++c)p.setUint32(c<<2,d.getUint32(c<<2))}m=a;return p}function k(){e+=m}function g(a){k(i(1).setUint8(e,a))}function h(a){for(var b=i(a.length),d=0;d<a.length;++d)b.setUint8(e+d,a[d]);k()}function n(a,b){if(24>b)g(a<<5|b);else if(256>b)g(a<<5|24),g(b);else if(65536>
b)g(a<<5|25),k(i(2).setUint16(e,b));else if(4294967296>b)g(a<<5|26),k(i(4).setUint32(e,b));else{g(a<<5|27);var d=b%t,c=(b-d)/t,f=i(8);f.setUint32(e,c);f.setUint32(e+4,d);k()}}function q(a){var b;if(!1===a)return g(244);if(!0===a)return g(245);if(null===a)return g(246);if(a===s)return g(247);switch(typeof a){case "number":if(Math.floor(a)===a){if(0<=a&&a<=w)return n(0,a);if(-w<=a&&0>a)return n(1,-(a+1))}g(251);k(i(8).setFloat64(e,a));break;case "string":var d=[];for(b=0;b<a.length;++b){var c=a.charCodeAt(b);
128>c?d.push(c):(2048>c?d.push(192|c>>6):(55296>c?d.push(224|c>>12):(c=(c&1023)<<10,c|=a.charCodeAt(++b)&1023,c+=65536,d.push(240|c>>18),d.push(128|c>>12&63)),d.push(128|c>>6&63)),d.push(128|c&63))}n(3,d.length);return h(d);default:if(Array.isArray(a)){d=a.length;n(4,d);for(b=0;b<d;++b)q(a[b])}else if(a instanceof Uint8Array)n(2,a.length),h(a);else{c=Object.keys(a);d=c.length;n(5,d);for(b=0;b<d;++b){var f=c[b];q(f);q(a[f])}}}}var j=new ArrayBuffer(256),p=new DataView(j),m,e=0;q(l);if("slice"in j)return j.slice(0,
e);for(var l=new ArrayBuffer(e),f=new DataView(l),r=0;r<e;++r)f.setUint8(r,p.getUint8(r));return l},decode:function(l,i,k){function g(a,b){f+=a;return b}function h(){return g(1,e.getUint8(f))}function n(){if(255!==e.getUint8(f))return!1;f+=1;return!0}function q(a){if(24>a)return a;if(24===a)return h();if(25===a)return g(2,e.getUint16(f));if(26===a)return g(4,e.getUint32(f));if(27===a)return g(4,e.getUint32(f))*t+g(4,e.getUint32(f));if(31===a)return-1;throw"Invalid length encoding";}function j(a){var b=
h();if(255===b)return-1;var d=q(b&31);if(0>d||b>>5!==a)throw"Invalid indefinite length element";return d}function p(a,b){for(var d=0;d<b;++d){var c=h();c&128&&(224>c?(c=(c&31)<<6|h()&63,b-=1):240>c?(c=(c&15)<<12|(h()&63)<<6|h()&63,b-=2):(c=(c&15)<<18|(h()&63)<<12|(h()&63)<<6|h()&63,b-=3));65536>c?a.push(c):(c-=65536,a.push(55296|c>>10),a.push(56320|c&1023))}}function m(){var a=h(),b=a>>5,a=a&31;if(7===b)switch(a){case 25:a:{var a=new ArrayBuffer(4),a=new DataView(a),d=g(2,e.getUint16(f)),b=d&32768,
c=d&31744,d=d&1023;if(31744===c)c=261120;else if(0!==c)c+=114688;else if(0!==d){a=(b?-1:1)*d*x;break a}a.setUint32(0,b<<16|c<<13|d<<13);a=a.getFloat32(0)}return a;case 26:return g(4,e.getFloat32(f));case 27:return g(8,e.getFloat64(f))}a=q(a);if(0>a&&(2>b||6<b))throw"Invalid length";switch(b){case 0:return a;case 1:return-1-a;case 2:if(0>a){c=[];for(d=0;0<=(a=j(b));)d+=a,c.push(g(a,new Uint8Array(l,f,a)));a=new Uint8Array(d);for(b=d=0;b<c.length;++b)a.set(c[b],d),d+=c[b].length;return a}return g(a,
new Uint8Array(l,f,a));case 3:c=[];if(0>a)for(;0<=(a=j(b));)p(c,a);else p(c,a);return String.fromCharCode.apply(null,c);case 4:if(0>a)for(c=[];!n();)c.push(m());else{c=Array(a);for(b=0;b<a;++b)c[b]=m()}return c;case 5:c={};for(b=0;b<a||0>a&&!n();++b)d=m(),c[d]=m();return c;case 6:return i(m(),a);case 7:switch(a){case 20:return!1;case 21:return!0;case 22:return null;case 23:return s;default:return k(a)}}}var e=new DataView(l),f=0;"function"!==typeof i&&(i=function(a){return a});"function"!==typeof k&&
(k=function(){return s});var r=m();if(f!==l.byteLength)throw"Remaining bytes";return r}};"function"===typeof define&&define.amd?define([],u):"undefined"!==typeof module&&module.exports?module.exports=u:v.CBOR||(v.CBOR=u)})(this);