import Parameter from "./Parameter";
/**
 * Use this parameter for simple string parameters
 *
 * Don't use Parameter directly
 *
 * @augments Parameter
 * @param {String} name             - name of the parameter
 * @param {String} userfriendlyname - display name of the parameter
 */
var StringParameter = function(name, context, userfriendlyname) {
	Parameter.call(this, name, context, "dashboard/core/parameters/StringParameter", userfriendlyname);
};

StringParameter.prototype = Object.create(Parameter.prototype);
StringParameter.prototype.constructor = StringParameter;

export default StringParameter;
