import _ from "underscore";

export default {
	SUCCESS: {
		value: 0,
		name: "SUCCESS"
	},
	INFO: {
		value: 1,
		name: "INFO"
	},
	WARN: {
		value: 2,
		name: "WARN"
	},
	ERROR: {
		value: 3,
		name: "ERROR"
	},

	getTypeFromString: function(stringType) {
		return _.findWhere(this, {
			name: stringType.toUpperCase()
		});
	}
};
