import React from "react";
import createIcon from "../utils/createIcon";

const WcrCamera = props => (
	<svg viewBox="0 0 32 32" width="1em" height="1em" {...props}>
		<circle cx={16} cy={20} r={7} />
		<path d="M21 2H11L8 8H0v24h32V8h-8l-3-6zm-5 28c-5.523 0-10-4.477-10-10s4.477-10 10-10 10 4.477 10 10-4.477 10-10 10zm14-18h-6v-2h6v2z" />
	</svg>
);

export default createIcon(WcrCamera);
