export default /**
 * @exports DataConstants
 */
{
	documentPageType: {
		CAD: 0,
		GRAPHICS: 1,
		PAGELIST: 2,
		SVG: 3,
		THREED: 4,
		VIDEO: 5
	},
	imageType: {
		OTHER: 0,
		GRAPHICS: 1
	},
	// list of user preferences that always should be character sequences
	charsequencePreferences: ["LAYOUT_STATE", "LAYOUT_PREFERENCE", "ANNOTATION_FILTER"],
	LINKEDDOCUMENTTYPES: {
		THREEDVIEW: {
			name: "3DView",
			icon: "icon icon-WCR_3D"
		},
		CADOVERLAY: {
			name: "CADOverlay",
			icon: "icon icon-WCR_CAD-Inside-cont"
		},
		GRAPHIC: {
			name: "Graphic",
			icon: "icon icon-WCR_Images"
		}
	}
};
