import I18n from "@esko/i18n/I18n";
import DefaultBundleResolver from "@esko/web-viewer/i18n/DefaultBundleResolver";
/**
 * Default I18n Provider, adds extra language bundles needed for the viewer
 *
 */
var DefaultI18n = function(locale, timestamp) {
	I18n.call(this, locale, "ESKO-HTML5-VIEWER", timestamp);

	// Register default "viewer" bundle
	this.addBundle("viewer", new DefaultBundleResolver());
	this.addBundle("messagewidget", new DefaultBundleResolver());
};

DefaultI18n.prototype = Object.create(I18n.prototype);
DefaultI18n.prototype.constructor = DefaultI18n;

export default DefaultI18n;
