import ViewportLayerModel from "@esko/web-viewer/viewport/model/ViewportLayerModel";
var View3DLayerModel = function(f, IID, view3DModule) {
	ViewportLayerModel.call(this, f, IID);

	this._module = view3DModule;
};

View3DLayerModel.prototype = Object.create(ViewportLayerModel.prototype);
View3DLayerModel.prototype.constructor = View3DLayerModel;

View3DLayerModel.prototype.getType = function() {
	return "View3D";
};

View3DLayerModel.prototype.getModule = function() {
	return this._module;
};

export default View3DLayerModel;
