/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./lib/oop","./lib/event_emitter"],function(d,g){var i=d("./lib/oop"),j=d("./lib/event_emitter").EventEmitter,k=g.Anchor=function(e,a,c){this.$onChange=this.onChange.bind(this);this.attach(e);"undefined"==typeof c?this.setPosition(a.row,a.column):this.setPosition(a,c)};(function(){function e(a,c,b){b=b?a.column<=c.column:a.column<c.column;return a.row<c.row||a.row==c.row&&b}i.implement(this,j);this.getPosition=function(){return this.$clipPositionToDocument(this.row,
this.column)};this.getDocument=function(){return this.document};this.$insertRight=!1;this.onChange=function(a){var c,b;if(!(a.start.row==a.end.row&&a.start.row!=this.row)&&!(a.start.row>this.row)){b={row:this.row,column:this.column};c=this.$insertRight;var h="insert"==a.action,d=(h?1:-1)*(a.end.row-a.start.row),g=(h?1:-1)*(a.end.column-a.start.column),f=a.start,a=h?f:a.end;e(b,f,c)?(c=b.row,b=b.column):e(a,b,!c)?(c=b.row+d,b=b.column+(b.row==a.row?g:0)):(c=f.row,b=f.column);this.setPosition(c,b,!0)}};
this.setPosition=function(a,c,b){a=b?{row:a,column:c}:this.$clipPositionToDocument(a,c);this.row==a.row&&this.column==a.column||(c={row:this.row,column:this.column},this.row=a.row,this.column=a.column,this._signal("change",{old:c,value:a}))};this.detach=function(){this.document.removeEventListener("change",this.$onChange)};this.attach=function(a){this.document=a||this.document;this.document.on("change",this.$onChange)};this.$clipPositionToDocument=function(a,c){var b={};a>=this.document.getLength()?
(b.row=Math.max(0,this.document.getLength()-1),b.column=this.document.getLine(b.row).length):0>a?(b.row=0,b.column=0):(b.row=a,b.column=Math.min(this.document.getLine(b.row).length,Math.max(0,c)));0>c&&(b.column=0);return b}}).call(k.prototype)});