/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./lib/oop","./lib/event_emitter"],function(c,h){var i=c("./lib/oop"),j=c("./lib/event_emitter").EventEmitter,e=function(a){this.running=!1;this.lines=[];this.states=[];this.currentLine=0;this.tokenizer=a;var b=this;this.$worker=function(){if(b.running){for(var a=new Date,d=b.currentLine,f=-1,g=b.doc,c=d;b.lines[d];)d++;var g=g.getLength(),e=0;for(b.running=!1;d<g;){b.$tokenizeRow(d);f=d;do d++;while(b.lines[d]);e++;if(0===e%5&&20<new Date-a){b.running=setTimeout(b.$worker,
20);break}}b.currentLine=d;c<=f&&b.fireUpdateEvent(c,f)}}};(function(){i.implement(this,j);this.setTokenizer=function(a){this.tokenizer=a;this.lines=[];this.states=[];this.start(0)};this.setDocument=function(a){this.doc=a;this.lines=[];this.states=[];this.stop()};this.fireUpdateEvent=function(a,b){this._signal("update",{data:{first:a,last:b}})};this.start=function(a){this.currentLine=Math.min(a||0,this.currentLine,this.doc.getLength());this.lines.splice(this.currentLine,this.lines.length);this.states.splice(this.currentLine,
this.states.length);this.stop();this.running=setTimeout(this.$worker,700)};this.scheduleStart=function(){this.running||(this.running=setTimeout(this.$worker,700))};this.$updateOnChange=function(a){var b=a.start.row,c=a.end.row-b;0===c?this.lines[b]=null:"remove"==a.action?(this.lines.splice(b,c+1,null),this.states.splice(b,c+1,null)):(a=Array(c+1),a.unshift(b,1),this.lines.splice.apply(this.lines,a),this.states.splice.apply(this.states,a));this.currentLine=Math.min(b,this.currentLine,this.doc.getLength());
this.stop()};this.stop=function(){this.running&&clearTimeout(this.running);this.running=!1};this.getTokens=function(a){return this.lines[a]||this.$tokenizeRow(a)};this.getState=function(a){this.currentLine==a&&this.$tokenizeRow(a);return this.states[a]||"start"};this.$tokenizeRow=function(a){var b=this.doc.getLine(a),b=this.tokenizer.getLineTokens(b,this.states[a-1],a);this.states[a]+""!==b.state+""?(this.states[a]=b.state,this.lines[a+1]=null,this.currentLine>a+1&&(this.currentLine=a+1)):this.currentLine==
a&&(this.currentLine=a+1);return this.lines[a]=b.tokens}}).call(e.prototype);h.BackgroundTokenizer=e});