/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/lang ./lib/oop ./lib/net ./lib/app_config".split(" "),function(g,c,p){function q(a){return a.replace(/-(.)/g,function(a,b){return b.toUpperCase()})}"no use strict";var i=g("./lib/lang");g("./lib/oop");var r=g("./lib/net"),s=g("./lib/app_config").AppConfig;p.exports=c=new s;var j=function(){return this||"undefined"!=typeof window&&window}(),e={packaged:!1,workerPath:null,modePath:null,themePath:null,basePath:"",suffix:".js",$moduleUrls:{}};c.get=function(a){if(!e.hasOwnProperty(a))throw Error("Unknown config key: "+
a);return e[a]};c.set=function(a,d){if(!e.hasOwnProperty(a))throw Error("Unknown config key: "+a);e[a]=d};c.all=function(){return i.copyObject(e)};c.moduleUrl=function(a,d){if(e.$moduleUrls[a])return e.$moduleUrls[a];var b=a.split("/"),d=d||b[b.length-2]||"",c="snippets"==d?"/":"-",f=b[b.length-1];"worker"==d&&"-"==c&&(f=f.replace(RegExp("^"+d+"[\\-_]|[\\-_]"+d+"$","g"),""));if((!f||f==d)&&1<b.length)f=b[b.length-2];b=e[d+"Path"];null==b?b=e.basePath:"/"==c&&(d=c="");b&&"/"!=b.slice(-1)&&(b+="/");
return b+d+c+f+this.get("suffix")};c.setModuleUrl=function(a,c){return e.$moduleUrls[a]=c};c.$loading={};c.loadModule=function(a,d){var b,e;Array.isArray(a)&&(e=a[0],a=a[1]);try{b=g(a)}catch(f){}if(b&&!c.$loading[a])return d&&d(b);c.$loading[a]||(c.$loading[a]=[]);c.$loading[a].push(d);if(!(1<c.$loading[a].length)){b=function(){g([a],function(b){c._emit("load.module",{name:a,module:b});var d=c.$loading[a];c.$loading[a]=null;d.forEach(function(a){a&&a(b)})})};if(!c.get("packaged"))return b();r.loadScript(c.moduleUrl(a,
e),b)}};c.init=function(a){if(j&&j.document){e.packaged=a||g.packaged||p.packaged||j.define&&define.packaged;for(var a={},d="",b=document.currentScript||document._currentScript,b=(b&&b.ownerDocument||document).getElementsByTagName("script"),k=0;k<b.length;k++){var f=b[k],h=f.src||f.getAttribute("src");if(h){for(var f=f.attributes,l=0,i=f.length;l<i;l++){var m=f[l];0===m.name.indexOf("data-ace-")&&(a[q(m.name.replace(/^data-ace-/,""))]=m.value)}(h=h.match(/^(.*)\/ace(\-\w+)?\.js(\?|$)/))&&(d=h[1])}}d&&
(a.base=a.base||d,a.packaged=!0);a.basePath=a.base;a.workerPath=a.workerPath||a.base;a.modePath=a.modePath||a.base;a.themePath=a.themePath||a.base;delete a.base;for(var n in a)"undefined"!==typeof a[n]&&c.set(n,a[n])}}});