/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define(["require","exports","module","./config","./test/assertions"],function(d,f,e){var c=d("./config"),b=d("./test/assertions");e.exports={"test: path resolution":function(){c.set("packaged","true");var a=c.moduleUrl("kr_theme","theme");b.equal(a,"theme-kr_theme.js");c.set("basePath","a/b");a=c.moduleUrl("m/theme","theme");b.equal(a,"a/b/theme-m.js");a=c.moduleUrl("m/theme","ext");b.equal(a,"a/b/ext-theme.js");c.set("workerPath","c/");a=c.moduleUrl("foo/1","worker");b.equal(a,"c/worker-1.js");c.setModuleUrl("foo/1",
"a/b1.js");a=c.moduleUrl("foo/1","theme");b.equal(a,"a/b1.js");a=c.moduleUrl("snippets/js");b.equal(a,"a/b/snippets/js.js");c.setModuleUrl("snippets/js","_.js");a=c.moduleUrl("snippets/js");b.equal(a,"_.js");a=c.moduleUrl("ace/ext/textarea");b.equal(a,"a/b/ext-textarea.js");b.equal()},"test: define options":function(){var a={};c.defineOptions(a,"test_object",{opt1:{set:function(a){this.x=a},value:7},initialValue:{set:function(a){this.x=a},initialValue:8},opt2:{get:function(){return this.x}},forwarded:"model"});
a.model={};c.defineOptions(a.model,"model",{forwarded:{value:1}});c.resetOptions(a);c.resetOptions(a.model);b.equal(a.getOption("opt1"),7);b.equal(a.getOption("opt2"),7);a.setOption("opt1",8);b.equal(a.getOption("opt1"),8);b.equal(a.getOption("opt2"),8);b.equal(a.getOption("forwarded"),1);b.equal(a.getOption("new"),void 0);a.setOption("new",0);b.equal(a.getOption("new"),void 0);b.equal(a.getOption("initialValue"),8);a.setOption("initialValue",7);b.equal(a.getOption("opt2"),7);c.setDefaultValues("test_object",
{opt1:1,forwarded:2});c.resetOptions(a);b.equal(a.getOption("opt1"),1);b.equal(a.getOption("forwarded"),2)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();