/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../range ../range_list ../lib/oop".split(" "),function(c,j){function h(a,b){a.row-=b.row;0==a.row&&(a.column-=b.column)}function i(a,b){0==a.row&&(a.column+=b.column);a.row+=b.row}c("../range");var k=c("../range_list").RangeList,l=c("../lib/oop"),g=j.Fold=function(a,b){this.foldLine=null;this.placeholder=b;this.range=a;this.start=a.start;this.end=a.end;this.sameRow=a.start.row==a.end.row;this.subFolds=this.ranges=[]};l.inherits(g,k);(function(){this.toString=function(){return'"'+
this.placeholder+'" '+this.range.toString()};this.setFoldLine=function(a){this.foldLine=a;this.subFolds.forEach(function(b){b.setFoldLine(a)})};this.clone=function(){var a=this.range.clone(),b=new g(a,this.placeholder);this.subFolds.forEach(function(a){b.subFolds.push(a.clone())});b.collapseChildren=this.collapseChildren;return b};this.addSubFold=function(a){if(!this.range.isEqual(a)){if(!this.range.containsRange(a))throw Error("A fold can't intersect already existing fold"+a.range+this.range);var b=
this.start;h(a.start,b);h(a.end,b);for(var e=a.start.row,c=a.start.column,b=0,d=-1;b<this.subFolds.length&&!(d=this.subFolds[b].range.compare(e,c),1!=d);b++);e=this.subFolds[b];if(0==d)return e.addSubFold(a);for(var e=a.range.end.row,c=a.range.end.column,f=b,d=-1;f<this.subFolds.length&&!(d=this.subFolds[f].range.compare(e,c),1!=d);f++);if(0==d)throw Error("A fold can't intersect already existing fold"+a.range+this.range);this.subFolds.splice(b,f-b,a);a.setFoldLine(this.foldLine);return a}};this.restoreRange=
function(a){var b=this.start;i(a.start,b);i(a.end,b)}}).call(g.prototype)});