/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../edit_session ../layer/text ../requirejs/text!./static.css ../config ../lib/dom".split(" "),function(k,m,n){var p=k("../edit_session").EditSession,m=k("../layer/text").Text,t=k("../requirejs/text!./static.css"),q=k("../config"),r=k("../lib/dom"),s=function(){this.config={}};s.prototype=m.prototype;var i=function(e,a,g){var b=e.className.match(/lang-(\w+)/),b=a.mode||b&&"ace/mode/"+b[1];if(!b)return!1;var l=a.theme||"ace/theme/textmate",d="",h=[];if(e.firstElementChild)for(var c=
0,j=0;j<e.childNodes.length;j++){var f=e.childNodes[j];3==f.nodeType?(c+=f.data.length,d+=f.data):h.push(c,f)}else d=r.getInnerText(e),a.trim&&(d=d.trim());i.render(d,b,l,a.firstLineNumber,!a.showGutter,function(a){r.importCssString(a.css,"ace_highlight");e.innerHTML=a.html;for(var d=e.firstChild.firstChild,b=0;b<h.length;b+=2){var c=a.session.doc.indexToPosition(h[b]),f=h[b+1];(c=d.children[c.row])&&c.appendChild(f)}g&&g()})};i.render=function(e,a,g,b,l,d){function h(){var c=i.renderSync(e,a,g,b,
l);return d?d(c):c}var c=1,j=p.prototype.$modes;"string"==typeof g&&(c++,q.loadModule(["theme",g],function(a){g=a;--c||h()}));var f;a&&("object"===typeof a&&!a.getTokenizer)&&(f=a,a=f.path);"string"==typeof a&&(c++,q.loadModule(["mode",a],function(b){if(!j[a]||f)j[a]=new b.Mode(f);a=j[a];--c||h()}));return--c||h()};i.renderSync=function(e,a,g,b,i){var b=parseInt(b||1,10),d=new p("");d.setUseWorker(!1);d.setMode(a);a=new s;a.setSession(d);d.setValue(e);for(var e=[],h=d.getLength(),c=0;c<h;c++)e.push("<div class='ace_line'>"),
i||e.push("<span class='ace_gutter ace_gutter-cell' unselectable='on'></span>"),a.$renderLine(e,c,!0,!1),e.push("\n</div>");b="<div class='"+g.cssClass+"'><div class='ace_static_highlight"+(i?"":" ace_show_gutter")+"' style='counter-reset:ace_line "+(b-1)+"'>"+e.join("")+"</div></div>";a.destroy();return{css:t+g.cssText,html:b,session:d}};n.exports=i;n.exports.highlight=i});