/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/lang"],function(r,c){var p=r("../lib/lang");c.$detectIndentation=function(a){for(var b=[],g=[],c=0,h=0,j=Math.min(a.length,1E3),e=0;e<j;e++){var f=a[e];if(/^\s*[^*+\-\s]/.test(f)){if("\t"==f[0])c++,h=-Number.MAX_VALUE;else{var d=f.match(/^ */)[0].length;if(d&&"\t"!=f[d]){var i=d-h;0<i&&(!(h%i)&&!(d%i))&&(g[i]=(g[i]||0)+1);b[d]=(b[d]||0)+1}h=d}for(;e<j&&"\\"==f[f.length-1];)f=a[e++]}}a=g.reduce(function(a,b){return a+b},0);f=j=h=0;for(e=1;12>e;e++){d=0;
for(i=e;i<b.length;i+=e)d+=b[i]||0;1==e?(f=d,d=b[1]?0.9:0.8,b.length||(d=0)):d/=f;g[e]&&(d+=g[e]/a);d>h&&(h=d,j=e)}if(h&&1.4<h)var m=j;if(c>f+1){if(1==m||f<c/4||1.8>h)m=void 0;return{ch:"\t",length:m}}if(f>c+1)return{ch:" ",length:m}};c.detectIndentation=function(a){var b=a.getLines(0,1E3),b=c.$detectIndentation(b)||{};b.ch&&a.setUseSoftTabs(" "==b.ch);b.length&&a.setTabSize(b.length);return b};c.trimTrailingSpace=function(a,b){for(var g=a.getDocument(),c=g.getAllLines(),h=b?-1:0,j=0,e=c.length;j<
e;j++){var f=c[j],d=f.search(/\s+$/);d>h&&g.removeInLine(j,d,f.length)}};c.convertIndentation=function(a,b,c){var q=a.getTabString()[0],h=a.getTabSize();c||(c=h);b||(b=q);for(var q="\t"==b?b:p.stringRepeat(b,c),j=a.doc,e=j.getAllLines(),f={},d={},i=0,m=e.length;i<m;i++){var n=e[i].match(/^\s*/)[0];if(n){var l=a.$getStringScreenWidth(n)[0],k=Math.floor(l/h),l=l%h,k=f[k]||(f[k]=p.stringRepeat(q,k)),k=k+(d[l]||(d[l]=p.stringRepeat(" ",l)));k!=n&&(j.removeInLine(i,0,n.length),j.insertInLine({row:i,column:0},
k))}}a.setTabSize(c);a.setUseSoftTabs(" "==b)};c.$parseStringArg=function(a){var b={};/t/.test(a)?b.ch="\t":/s/.test(a)&&(b.ch=" ");if(a=a.match(/\d+/))b.length=parseInt(a[0],10);return b};c.$parseArg=function(a){return!a?{}:"string"==typeof a?c.$parseStringArg(a):"string"==typeof a.text?c.$parseStringArg(a.text):a};c.commands=[{name:"detectIndentation",exec:function(a){c.detectIndentation(a.session)}},{name:"trimTrailingSpace",exec:function(a){c.trimTrailingSpace(a.session)}},{name:"convertIndentation",
exec:function(a,b){var g=c.$parseArg(b);c.convertIndentation(a.session,g.ch,g.length)}},{name:"setIndentation",exec:function(a,b){var g=c.$parseArg(b);g.length&&a.session.setTabSize(g.length);g.ch&&a.session.setUseSoftTabs(" "==g.ch)}}]});