/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../range","../lib/dom"],function(j,p){var q=j("../range").Range,r=j("../lib/dom"),n=function(b){this.element=r.createElement("div");this.element.className="ace_layer ace_marker-layer";b.appendChild(this.element)};(function(){this.$padding=0;this.setPadding=function(b){this.$padding=b};this.setSession=function(b){this.session=b};this.setMarkers=function(b){this.markers=b};this.update=function(b){if(b=b||this.config){this.config=b;var a=[],g;for(g in this.markers){var c=
this.markers[g];if(c.range){var d=c.range.clipRows(b.firstRow,b.lastRow);if(!d.isEmpty())if(d=d.toScreenRange(this.session),c.renderer){var h=this.$getTop(d.start.row,b);c.renderer(a,d,this.$padding+d.start.column*b.characterWidth,h,b)}else"fullLine"==c.type?this.drawFullLineMarker(a,d,c.clazz,b):"screenLine"==c.type?this.drawScreenLineMarker(a,d,c.clazz,b):d.isMultiLine()?"text"==c.type?this.drawTextMarker(a,d,c.clazz,b):this.drawMultiLineMarker(a,d,c.clazz,b):this.drawSingleLineMarker(a,d,c.clazz+
" ace_start ace_br15",b)}else c.update(a,this,this.session,b)}this.element.innerHTML=a.join("")}};this.$getTop=function(b,a){return(b-a.firstRowScreen)*a.lineHeight};this.drawTextMarker=function(b,a,g,c,d){for(var h=this.session,f=a.start.row,i=a.end.row,e=f,j=0,k=0,m=h.getScreenLastRowColumn(e),l=new q(e,a.start.column,e,k);e<=i;e++)l.start.row=l.end.row=e,l.start.column=e==f?a.start.column:h.getRowWrapIndent(e),l.end.column=m,j=k,k=m,m=e+1<i?h.getScreenLastRowColumn(e+1):e==i?0:a.end.column,this.drawSingleLineMarker(b,
l,g+(e==f?" ace_start":"")+" ace_br"+((e==f||e==f+1&&a.start.column?1:0)|(j<k?2:0)|(k>m?4:0)|(e==i?8:0)),c,e==i?0:1,d)};this.drawMultiLineMarker=function(b,a,g,c,d){var h=this.$padding,f=c.lineHeight,i=this.$getTop(a.start.row,c),e=h+a.start.column*c.characterWidth,d=d||"";b.push("<div class='",g," ace_br1 ace_start' style='","height:",f,"px;","right:0;","top:",i,"px;","left:",e,"px;",d,"'></div>");i=this.$getTop(a.end.row,c);b.push("<div class='",g," ace_br12' style='","height:",f,"px;","width:",
a.end.column*c.characterWidth,"px;","top:",i,"px;","left:",h,"px;",d,"'></div>");f=(a.end.row-a.start.row-1)*c.lineHeight;0>=f||(i=this.$getTop(a.start.row+1,c),a=(a.start.column?1:0)|(a.end.column?0:8),b.push("<div class='",g,a?" ace_br"+a:"","' style='","height:",f,"px;","right:0;","top:",i,"px;","left:",h,"px;",d,"'></div>"))};this.drawSingleLineMarker=function(b,a,g,c,d,h){var f=c.lineHeight,d=(a.end.column+(d||0)-a.start.column)*c.characterWidth,i=this.$getTop(a.start.row,c);b.push("<div class='",
g,"' style='","height:",f,"px;","width:",d,"px;","top:",i,"px;","left:",this.$padding+a.start.column*c.characterWidth,"px;",h||"","'></div>")};this.drawFullLineMarker=function(b,a,g,c,d){var h=this.$getTop(a.start.row,c),f=c.lineHeight;a.start.row!=a.end.row&&(f+=this.$getTop(a.end.row,c)-h);b.push("<div class='",g,"' style='","height:",f,"px;","top:",h,"px;","left:0;right:0;",d||"","'></div>")};this.drawScreenLineMarker=function(b,a,g,c,d){a=this.$getTop(a.start.row,c);b.push("<div class='",g,"' style='",
"height:",c.lineHeight,"px;","top:",a,"px;","left:0;right:0;",d||"","'></div>")}}).call(n.prototype);p.Marker=n});