/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./keys","./useragent"],function(l,b){function n(a,d,c){var b=p(d);if(!h.isMac&&f){if(d.getModifierState&&(d.getModifierState("OS")||d.getModifierState("Win")))b|=8;if(f.altGr)if(3!=(3&b))f.altGr=0;else return;if(18===c||17===c){var i="location"in d?d.location:d.keyLocation;17===c&&1===i?1==f[c]&&(q=d.timeStamp):18===c&&(3===b&&2===i)&&50>d.timeStamp-q&&(f.altGr=!0)}}c in k.MODIFIER_KEYS&&(c=-1);b&8&&(91<=c&&93>=c)&&(c=-1);if(!b&&13===c&&(i="location"in d?d.location:
d.keyLocation,3===i&&(a(d,b,-c),d.defaultPrevented)))return;if(h.isChromeOS&&b&8){a(d,b,c);if(d.defaultPrevented)return;b&=-9}return!b&&!(c in k.FUNCTION_KEYS)&&!(c in k.PRINTABLE_KEYS)?!1:a(d,b,c)}function r(){f=Object.create(null)}var k=l("./keys"),h=l("./useragent"),f=null,q=0;b.addListener=function(a,b,c){if(a.addEventListener)return a.addEventListener(b,c,!1);if(a.attachEvent){var e=function(){c.call(a,window.event)};c._wrapper=e;a.attachEvent("on"+b,e)}};b.removeListener=function(a,b,c){if(a.removeEventListener)return a.removeEventListener(b,
c,!1);a.detachEvent&&a.detachEvent("on"+b,c._wrapper||c)};b.stopEvent=function(a){b.stopPropagation(a);b.preventDefault(a);return!1};b.stopPropagation=function(a){a.stopPropagation?a.stopPropagation():a.cancelBubble=!0};b.preventDefault=function(a){a.preventDefault?a.preventDefault():a.returnValue=!1};b.getButton=function(a){return"dblclick"==a.type?0:"contextmenu"==a.type||h.isMac&&a.ctrlKey&&!a.altKey&&!a.shiftKey?2:a.preventDefault?a.button:{1:0,2:2,4:1}[a.button]};b.capture=function(a,d,c){function e(a){d&&
d(a);c&&c(a);b.removeListener(document,"mousemove",d,!0);b.removeListener(document,"mouseup",e,!0);b.removeListener(document,"dragstart",e,!0)}b.addListener(document,"mousemove",d,!0);b.addListener(document,"mouseup",e,!0);b.addListener(document,"dragstart",e,!0);return e};b.addTouchMoveListener=function(a,d){if("ontouchmove"in a){var c,e;b.addListener(a,"touchstart",function(a){a=a.changedTouches[0];c=a.clientX;e=a.clientY});b.addListener(a,"touchmove",function(a){var b=a.changedTouches[0];a.wheelX=
-(b.clientX-c)/1;a.wheelY=-(b.clientY-e)/1;c=b.clientX;e=b.clientY;d(a)})}};b.addMouseWheelListener=function(a,d){"onmousewheel"in a?b.addListener(a,"mousewheel",function(a){void 0!==a.wheelDeltaX?(a.wheelX=-a.wheelDeltaX/8,a.wheelY=-a.wheelDeltaY/8):(a.wheelX=0,a.wheelY=-a.wheelDelta/8);d(a)}):"onwheel"in a?b.addListener(a,"wheel",function(a){switch(a.deltaMode){case a.DOM_DELTA_PIXEL:a.wheelX=0.35*a.deltaX||0;a.wheelY=0.35*a.deltaY||0;break;case a.DOM_DELTA_LINE:case a.DOM_DELTA_PAGE:a.wheelX=5*
(a.deltaX||0),a.wheelY=5*(a.deltaY||0)}d(a)}):b.addListener(a,"DOMMouseScroll",function(a){a.axis&&a.axis==a.HORIZONTAL_AXIS?(a.wheelX=5*(a.detail||0),a.wheelY=0):(a.wheelX=0,a.wheelY=5*(a.detail||0));d(a)})};b.addMultiMouseDownListener=function(a,d,c,e){function i(a){0!==b.getButton(a)?g=0:1<a.detail?(g++,4<g&&(g=1)):g=1;if(h.isIE){var m=5<Math.abs(a.clientX-f)||5<Math.abs(a.clientY-k);if(!j||m)g=1;j&&clearTimeout(j);j=setTimeout(function(){j=null},d[g-1]||600);1==g&&(f=a.clientX,k=a.clientY)}a._clicks=
g;c[e]("mousedown",a);if(4<g)g=0;else if(1<g)return c[e](l[g],a)}function m(a){g=2;j&&clearTimeout(j);j=setTimeout(function(){j=null},d[g-1]||600);c[e]("mousedown",a);c[e](l[g],a)}var g=0,f,k,j,l={2:"dblclick",3:"tripleclick",4:"quadclick"};Array.isArray(a)||(a=[a]);a.forEach(function(a){b.addListener(a,"mousedown",i);h.isOldIE&&b.addListener(a,"dblclick",m)})};var p=h.isMac&&h.isOpera&&!("KeyboardEvent"in window)?function(a){return 0|(a.metaKey?1:0)|(a.altKey?2:0)|(a.shiftKey?4:0)|(a.ctrlKey?8:0)}:
function(a){return 0|(a.ctrlKey?1:0)|(a.altKey?2:0)|(a.shiftKey?4:0)|(a.metaKey?8:0)};b.getModifierString=function(a){return k.KEY_MODS[p(a)]};b.addCommandKeyListener=function(a,d){var c=b.addListener;if(h.isOldGecko||h.isOpera&&!("KeyboardEvent"in window)){var e=null;c(a,"keydown",function(a){e=a.keyCode});c(a,"keypress",function(a){return n(d,a,e)})}else{var i=null;c(a,"keydown",function(a){f[a.keyCode]=(f[a.keyCode]||0)+1;var b=n(d,a,a.keyCode);i=a.defaultPrevented;return b});c(a,"keypress",function(a){if(i&&
(a.ctrlKey||a.altKey||a.shiftKey||a.metaKey))b.stopEvent(a),i=null});c(a,"keyup",function(a){f[a.keyCode]=null});f||(r(),c(window,"focus",r))}};"object"==typeof window&&(window.postMessage&&!h.isOldIE)&&(b.nextTick=function(a,d){d=d||window;b.addListener(d,"message",function e(f){"zero-timeout-message-1"==f.data&&(b.stopPropagation(f),b.removeListener(d,"message",e),a())});d.postMessage("zero-timeout-message-1","*")});b.nextFrame="object"==typeof window&&(window.requestAnimationFrame||window.mozRequestAnimationFrame||
window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame);b.nextFrame=b.nextFrame?b.nextFrame.bind(window):function(a){setTimeout(a,17)}});