/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(i,d){d.last=function(e){return e[e.length-1]};d.stringReverse=function(e){return e.split("").reverse().join("")};d.stringRepeat=function(e,b){for(var a="";0<b;)if(b&1&&(a+=e),b>>=1)e+=e;return a};var g=/^\s\s*/,h=/\s\s*$/;d.stringTrimLeft=function(e){return e.replace(g,"")};d.stringTrimRight=function(e){return e.replace(h,"")};d.copyObject=function(e){var b={},a;for(a in e)b[a]=e[a];return b};d.copyArray=function(e){for(var b=[],a=0,c=e.length;a<c;a++)b[a]=
e[a]&&"object"==typeof e[a]?this.copyObject(e[a]):e[a];return b};d.deepCopy=function b(a){if("object"!==typeof a||!a)return a;var c;if(Array.isArray(a)){c=[];for(var f=0;f<a.length;f++)c[f]=b(a[f]);return c}if("[object Object]"!==Object.prototype.toString.call(a))return a;c={};for(f in a)c[f]=b(a[f]);return c};d.arrayToMap=function(b){for(var a={},c=0;c<b.length;c++)a[b[c]]=1;return a};d.createMap=function(b){var a=Object.create(null),c;for(c in b)a[c]=b[c];return a};d.arrayRemove=function(b,a){for(var c=
0;c<=b.length;c++)a===b[c]&&b.splice(c,1)};d.escapeRegExp=function(b){return b.replace(/([.*+?^${}()|[\]\/\\])/g,"\\$1")};d.escapeHTML=function(b){return b.replace(/&/g,"&#38;").replace(/"/g,"&#34;").replace(/'/g,"&#39;").replace(/</g,"&#60;")};d.getMatchOffsets=function(b,a){var c=[];b.replace(a,function(a){c.push({offset:arguments[arguments.length-2],length:a.length})});return c};d.deferredCall=function(b){var a=null,c=function(){a=null;b()},f=function(b){f.cancel();a=setTimeout(c,b||0);return f};
f.schedule=f;f.call=function(){this.cancel();b();return f};f.cancel=function(){clearTimeout(a);a=null;return f};f.isPending=function(){return a};return f};d.delayedCall=function(b,a){var c=null,f=function(){c=null;b()},d=function(b){null==c&&(c=setTimeout(f,b||a))};d.delay=function(b){c&&clearTimeout(c);c=setTimeout(f,b||a)};d.schedule=d;d.call=function(){this.cancel();b()};d.cancel=function(){c&&clearTimeout(c);c=null};d.isPending=function(){return c};return d}});