/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/dom ./range".split(" "),function(i,l){function j(a){this.session=a;this.session.widgetManager=this;this.session.getRowLength=this.getRowLength;this.session.$getWidgetScreenLength=this.$getWidgetScreenLength;this.updateOnChange=this.updateOnChange.bind(this);this.renderWidgets=this.renderWidgets.bind(this);this.measureWidgets=this.measureWidgets.bind(this);this.session._changedWidgets=[];this.$onChangeEditor=this.$onChangeEditor.bind(this);this.session.on("change",
this.updateOnChange);this.session.on("changeFold",this.updateOnFold);this.session.on("changeEditor",this.$onChangeEditor)}i("./lib/oop");var k=i("./lib/dom");i("./range");(function(){this.getRowLength=function(a){var b;b=this.lineWidgets?this.lineWidgets[a]&&this.lineWidgets[a].rowCount||0:0;return!this.$useWrapMode||!this.$wrapData[a]?1+b:this.$wrapData[a].length+1+b};this.$getWidgetScreenLength=function(){var a=0;this.lineWidgets.forEach(function(b){b&&(b.rowCount&&!b.hidden)&&(a+=b.rowCount)});
return a};this.$onChangeEditor=function(a){this.attach(a.editor)};this.attach=function(a){a&&(a.widgetManager&&a.widgetManager!=this)&&a.widgetManager.detach();if(this.editor!=a&&(this.detach(),this.editor=a))a.widgetManager=this,a.renderer.on("beforeRender",this.measureWidgets),a.renderer.on("afterRender",this.renderWidgets)};this.detach=function(){var a=this.editor;a&&(this.editor=null,a.widgetManager=null,a.renderer.off("beforeRender",this.measureWidgets),a.renderer.off("afterRender",this.renderWidgets),
(a=this.session.lineWidgets)&&a.forEach(function(a){a&&(a.el&&a.el.parentNode)&&(a._inDocument=!1,a.el.parentNode.removeChild(a.el))}))};this.updateOnFold=function(a,b){var d=b.lineWidgets;if(d&&a.action){for(var e=a.data,f=e.start.row,e=e.end.row,h="add"==a.action,c=f+1;c<e;c++)d[c]&&(d[c].hidden=h);d[e]&&(h?d[f]?d[e].hidden=h:d[f]=d[e]:(d[f]==d[e]&&(d[f]=void 0),d[e].hidden=h))}};this.updateOnChange=function(a){var b=this.session.lineWidgets;if(b){var d=a.start.row,e=a.end.row-d;0!==e&&("remove"==
a.action?b.splice(d+1,e).forEach(function(a){a&&this.removeLineWidget(a)},this):(a=Array(e),a.unshift(d,0),b.splice.apply(b,a)),this.$updateRows())}};this.$updateRows=function(){var a=this.session.lineWidgets;if(a){var b=!0;a.forEach(function(a,e){if(a){b=!1;for(a.row=e;a.$oldWidget;)a.$oldWidget.row=e,a=a.$oldWidget}});b&&(this.session.lineWidgets=null)}};this.addLineWidget=function(a){this.session.lineWidgets||(this.session.lineWidgets=Array(this.session.getLength()));var b=this.session.lineWidgets[a.row];
b&&(a.$oldWidget=b,b.el&&b.el.parentNode&&(b.el.parentNode.removeChild(b.el),b._inDocument=!1));this.session.lineWidgets[a.row]=a;a.session=this.session;b=this.editor.renderer;a.html&&!a.el&&(a.el=k.createElement("div"),a.el.innerHTML=a.html);a.el&&(k.addCssClass(a.el,"ace_lineWidgetContainer"),a.el.style.position="absolute",a.el.style.zIndex=5,b.container.appendChild(a.el),a._inDocument=!0);a.coverGutter||(a.el.style.zIndex=3);null==a.pixelHeight&&(a.pixelHeight=a.el.offsetHeight);null==a.rowCount&&
(a.rowCount=a.pixelHeight/b.layerConfig.lineHeight);var d=this.session.getFoldAt(a.row,0);if(a.$fold=d){var e=this.session.lineWidgets;a.row==d.end.row&&!e[d.start.row]?e[d.start.row]=a:a.hidden=!0}this.session._emit("changeFold",{data:{start:{row:a.row}}});this.$updateRows();this.renderWidgets(null,b);this.onWidgetChanged(a);return a};this.removeLineWidget=function(a){a._inDocument=!1;a.session=null;a.el&&a.el.parentNode&&a.el.parentNode.removeChild(a.el);if(a.editor&&a.editor.destroy)try{a.editor.destroy()}catch(b){}if(this.session.lineWidgets){var d=
this.session.lineWidgets[a.row];if(d==a){if(this.session.lineWidgets[a.row]=a.$oldWidget)this.onWidgetChanged(a.$oldWidget)}else for(;d;){if(d.$oldWidget==a){d.$oldWidget=a.$oldWidget;break}d=d.$oldWidget}}this.session._emit("changeFold",{data:{start:{row:a.row}}});this.$updateRows()};this.getWidgetsAtRow=function(a){for(var b=this.session.lineWidgets,a=b&&b[a],b=[];a;)b.push(a),a=a.$oldWidget;return b};this.onWidgetChanged=function(a){this.session._changedWidgets.push(a);this.editor&&this.editor.renderer.updateFull()};
this.measureWidgets=function(a,b){var d=this.session._changedWidgets,e=b.layerConfig;if(d&&d.length){for(var f=Infinity,h=0;h<d.length;h++){var c=d[h];if(c&&c.el&&c.session==this.session){if(!c._inDocument){if(this.session.lineWidgets[c.row]!=c)continue;c._inDocument=!0;b.container.appendChild(c.el)}c.h=c.el.offsetHeight;c.fixedWidth||(c.w=c.el.offsetWidth,c.screenWidth=Math.ceil(c.w/e.characterWidth));var g=c.h/e.lineHeight;c.coverLine&&(g-=this.session.getRowLineCount(c.row),0>g&&(g=0));c.rowCount!=
g&&(c.rowCount=g,c.row<f&&(f=c.row))}}Infinity!=f&&(this.session._emit("changeFold",{data:{start:{row:f}}}),this.session.lineWidgetWidth=null);this.session._changedWidgets=[]}};this.renderWidgets=function(a,b){var d=b.layerConfig,e=this.session.lineWidgets;if(e){for(var f=Math.min(this.firstRow,d.firstRow),h=Math.max(this.lastRow,d.lastRow,e.length);0<f&&!e[f];)f--;this.firstRow=d.firstRow;this.lastRow=d.lastRow;for(b.$cursorLayer.config=d;f<=h;f++){var c=e[f];if(c&&c.el)if(c.hidden)c.el.style.top=
-100-(c.pixelHeight||0)+"px";else{c._inDocument||(c._inDocument=!0,b.container.appendChild(c.el));var g=b.$cursorLayer.getPixelPosition({row:f,column:0},!0).top;c.coverLine||(g+=d.lineHeight*this.session.getRowLineCount(c.row));c.el.style.top=g-d.offset+"px";g=c.coverGutter?0:b.gutterWidth;c.fixedWidth||(g-=b.scrollLeft);c.el.style.left=g+"px";c.fullWidth&&c.screenWidth&&(c.el.style.minWidth=d.width+2*d.padding+"px");c.el.style.right=c.fixedWidth?b.scrollBar.getWidth()+"px":""}}}}}).call(j.prototype);
l.LineWidgets=j});