/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ../behaviour ../../token_iterator ../../lib/lang".split(" "),function(g,j){function f(b,d){return-1<b.type.lastIndexOf(d+".xml")}var k=g("../../lib/oop"),l=g("../behaviour").Behaviour,h=g("../../token_iterator").TokenIterator;g("../../lib/lang");var i=function(){this.add("string_dquotes","insertion",function(b,d,e,a,c){if('"'==c||"'"==c){b=a.doc.getTextRange(e.getSelectionRange());if(""!==b&&"'"!==b&&'"'!=b&&e.getWrapBehavioursEnabled())return{text:c+b+
c,selection:!1};b=e.getCursorPosition();e=a.doc.getLine(b.row).substring(b.column,b.column+1);b=new h(a,b.row,b.column);a=b.getCurrentToken();if(e==c&&(f(a,"attribute-value")||f(a,"string")))return{text:"",selection:[1,1]};a||(a=b.stepBackward());if(a){for(;f(a,"tag-whitespace")||f(a,"whitespace");)a=b.stepBackward();b=!e||e.match(/\s/);if(f(a,"attribute-equals")&&(b||">"==e)||f(a,"decl-attribute-equals")&&(b||"?"==e))return{text:c+c,selection:[1,1]}}}});this.add("string_dquotes","deletion",function(b,
d,e,a,c){b=a.doc.getTextRange(c);if(!c.isMultiLine()&&('"'==b||"'"==b)&&a.doc.getLine(c.start.row).substring(c.start.column+1,c.start.column+2)==b)return c.end.column++,c});this.add("autoclosing","insertion",function(b,d,e,a,c){if(">"==c&&(b=e.getSelectionRange().start,a=new h(a,b.row,b.column),(d=a.getCurrentToken()||a.stepBackward())&&(f(d,"tag-name")||f(d,"tag-whitespace")||f(d,"attribute-name")||f(d,"attribute-equals")||f(d,"attribute-value"))&&!f(d,"reference.attribute-value"))){if(f(d,"attribute-value")&&
(e=d.value.charAt(0),'"'==e||"'"==e)){var c=d.value.charAt(d.value.length-1),g=a.getCurrentTokenColumn()+d.value.length;if(g>b.column||g==b.column&&e!=c)return}for(;!f(d,"tag-name");)if(d=a.stepBackward(),"<"==d.value){d=a.stepForward();break}e=a.getCurrentTokenRow();c=a.getCurrentTokenColumn();if(!f(a.stepBackward(),"end-tag-open")&&(a=d.value,e==b.row&&(a=a.substring(0,b.column-c)),!this.voidElements.hasOwnProperty(a.toLowerCase())))return{text:"></"+a+">",selection:[1,1]}}});this.add("autoindent",
"insertion",function(b,d,e,a,c){if("\n"==c&&(b=e.getCursorPosition(),d=a.getLine(b.row),e=new h(a,b.row,b.column),(c=e.getCurrentToken())&&-1!==c.type.indexOf("tag-close")&&"/>"!=c.value)){for(;c&&-1===c.type.indexOf("tag-name");)c=e.stepBackward();if(c){var f=c.value,d=e.getCurrentTokenRow();if((c=e.stepBackward())&&-1===c.type.indexOf("end-tag")&&this.voidElements&&!this.voidElements[f])return b=a.getTokenAt(b.row,b.column+1),d=a.getLine(d),d=this.$getIndent(d),a=d+a.getTabString(),b&&"</"===b.value?
{text:"\n"+a+"\n"+d,selection:[1,a.length,1,a.length]}:{text:"\n"+a}}}})};k.inherits(i,l);j.XmlBehaviour=i});