/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ../../range ./fold_mode".split(" "),function(j,m){var n=j("../../lib/oop"),k=j("../../range").Range,p=j("./fold_mode").FoldMode,l=m.FoldMode=function(a){a&&(this.foldingStartMarker=RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+a.start)),this.foldingStopMarker=RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+a.end)))};n.inherits(l,p);(function(){this.foldingStartMarker=/(\{|\[)[^\}\]]*$|^\s*(\/\*)/;this.foldingStopMarker=/^[^\[\{]*(\}|\])|^[\s\*]*(\*\/)/;
this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/;this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/;this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/;this._getFoldWidgetBase=this.getFoldWidget;this.getFoldWidget=function(a,d,b){var f=a.getLine(b);if(this.singleLineBlockCommentRe.test(f)&&!this.startRegionRe.test(f)&&!this.tripleStarBlockCommentRe.test(f))return"";a=this._getFoldWidgetBase(a,d,b);return!a&&this.startRegionRe.test(f)?"start":a};this.getFoldWidgetRange=function(a,d,b,f){var e=
a.getLine(b);if(this.startRegionRe.test(e))return this.getCommentRegionBlock(a,e,b);var c=e.match(this.foldingStartMarker);if(c){e=c.index;if(c[1])return this.openingBracketBlock(a,c[1],b,e);(c=a.getCommentFoldRange(b,e+c[0].length,1))&&!c.isMultiLine()&&(f?c=this.getSectionRange(a,b):"all"!=d&&(c=null));return c}if("markbegin"!==d&&(c=e.match(this.foldingStopMarker)))return e=c.index+c[0].length,c[1]?this.closingBracketBlock(a,c[1],b,e):a.getCommentFoldRange(b,e,-1)};this.getSectionRange=function(a,
d){for(var b=a.getLine(d),f=b.search(/\S/),e=d,c=b.length,h=d+=1,i=a.getLength();++d<i;)if(b=a.getLine(d),b=b.search(/\S/),-1!==b){if(f>b)break;var g=this.getFoldWidgetRange(a,"all",d);if(g)if(g.start.row<=e)break;else if(g.isMultiLine())d=g.end.row;else if(f==b)break;h=d}return new k(e,c,h,a.getLine(h).length)};this.getCommentRegionBlock=function(a,d,b){for(var f=d.search(/\s*$/),e=a.getLength(),c=b,h=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,i=1;++b<e;){var d=a.getLine(b),g=h.exec(d);if(g&&(g[1]?i--:
i++,!i))break}a=b;if(a>c)return new k(c,f,a,d.length)}}).call(l.prototype)});