/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ./text ./javascript_highlight_rules ./matching_brace_outdent ../range ../worker/worker_client ./behaviour/cstyle ./folding/cstyle".split(" "),function(a,g){var h=a("../lib/oop"),i=a("./text").Mode,j=a("./javascript_highlight_rules").JavaScriptHighlightRules,k=a("./matching_brace_outdent").MatchingBraceOutdent;a("../range");var l=a("../worker/worker_client").WorkerClient,m=a("./behaviour/cstyle").CstyleBehaviour,n=a("./folding/cstyle").FoldMode,e=function(){this.HighlightRules=
j;this.$outdent=new k;this.$behaviour=new m;this.foldingRules=new n};h.inherits(e,i);(function(){this.lineCommentStart="//";this.blockComment={start:"/*",end:"*/"};this.getNextLineIndent=function(c,b,a){var d=this.$getIndent(b),f=this.getTokenizer().getLineTokens(b,c),e=f.tokens,f=f.state;if(e.length&&"comment"==e[e.length-1].type)return d;if("start"==c||"no_regex"==c)(c=b.match(/^.*(?:\bcase\b.*:|[\{\(\[])\s*$/))&&(d+=a);else if("doc-start"==c){if("start"==f||"no_regex"==f)return"";if(c=b.match(/^\s*(\/?)\*/))c[1]&&
(d+=" "),d+="* "}return d};this.checkOutdent=function(c,b,a){return this.$outdent.checkOutdent(b,a)};this.autoOutdent=function(c,b,a){this.$outdent.autoOutdent(b,a)};this.createWorker=function(a){var b=new l(["ace"],"ace/mode/javascript_worker","JavaScriptWorker");b.attachToDocument(a.getDocument());b.on("annotate",function(b){a.setAnnotations(b.data)});b.on("terminate",function(){a.clearAnnotations()});return b};this.$id="ace/mode/javascript"}).call(e.prototype);g.Mode=e});