/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../worker/mirror ./javascript/jshint".split(" "),function(f,l){function d(a){return RegExp("^("+a.join("|")+")")}var h=f("../lib/oop"),i=f("../worker/mirror").Mirror,j=f("./javascript/jshint").JSHINT,m=d(["Bad for in variable '(.+)'.",'Missing "use strict"']),n=d("Unexpected;Expected ;Confusing (plus|minus);\\{a\\} unterminated regular expression;Unclosed ;Unmatched ;Unbegun comment;Bad invocation;Missing space after;Missing operator at".split(";")),p=d("Expected an assignment;Bad escapement of EOL;Unexpected comma;Unexpected space;Missing radix parameter.;A leading decimal point can;\\['{a}'\\] is better written in dot notation.;'{a}' used out of scope".split(";")),
k=l.JavaScriptWorker=function(a){i.call(this,a);this.setTimeout(500);this.setOptions()};h.inherits(k,i);(function(){this.setOptions=function(a){this.options=a||{esnext:!0,moz:!0,devel:!0,browser:!0,node:!0,laxcomma:!0,laxbreak:!0,lastsemic:!0,onevar:!1,passfail:!1,maxerr:100,expr:!0,multistr:!0,globalstrict:!0};this.doc.getValue()&&this.deferredUpdate.schedule(100)};this.changeOptions=function(a){h.mixin(this.options,a);this.doc.getValue()&&this.deferredUpdate.schedule(100)};this.isValidJS=function(a){try{eval("throw 0;"+
a)}catch(g){if(0===g)return!0}return!1};this.onUpdate=function(){var a=this.doc.getValue(),a=a.replace(/^#!.*\n/,"\n");if(!a)return this.sender.emit("annotate",[]);var g=[],f=this.isValidJS(a)?"warning":"error";j(a,this.options,this.options.globals);for(var a=j.errors,d=0;d<a.length;d++){var c=a[d];if(c){var e=c.raw,b="warning";if("Missing semicolon."==e)b=c.evidence.substr(c.character),b=b.charAt(b.search(/\S/)),"error"==f&&b&&/[\w\d{(['"]/.test(b)?(c.reason='Missing ";" before statement',b="error"):
b="info";else if(m.test(e))continue;else p.test(e)?b="info":n.test(e)?b=f:"'{a}' is not defined."==e?b="warning":"'{a}' is defined but never used."==e&&(b="info");g.push({row:c.line-1,column:c.character-1,text:c.reason,type:b,raw:e})}}this.sender.emit("annotate",g)}}).call(k.prototype)});