/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define(["require","exports","module","../test/assertions","./json_worker"],function(d,f,e){var b=d("../test/assertions"),c=d("./json_worker").JsonWorker;e.exports={setUp:function(){this.sender={on:function(){},callback:function(a){this.data=a},events:[],emit:function(a,b){this.events.push([a,b])}}},"test check valid json":function(){var a=new c(this.sender);a.setValue("{}");a.deferredUpdate.call();b.equal(this.sender.events[0][1].length,0)},"test check for syntax error":function(){var a=new c(this.sender);
a.setValue("{\njuhu: 12\n}");a.deferredUpdate.call();a=this.sender.events[0];b.equal(a[0],"annotate");b.equal(a[1].length,1);b.equal(a[1][0].type,"error");b.equal(a[1][0].text,"Bad string");b.equal(a[1][0].row,1);b.equal(a[1][0].column,0)},"test check for syntax error at first char":function(){var a=new c(this.sender);a.setValue("x");a.deferredUpdate.call();a=this.sender.events[0];b.equal(a[0],"annotate");b.equal(a[1][0].type,"error");b.equal(a[1][0].text,"Unexpected 'x'");b.equal(a[1][0].row,0);
b.equal(a[1][0].column,0)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();