/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/dom ../lib/event ../lib/useragent".split(" "),function(f,E){function n(b){var z,A;function B(){var a=e,b=e=c.renderer.screenToTextCoordinates(p,q),t=Date.now(),g=!a||b.row!=a.row,d=!a||b.column!=a.column;!r||g||d?(c.$blockScrolling+=1,c.moveCursorToPosition(b),c.$blockScrolling-=1,r=t,z=p,A=q):Math.sqrt(Math.pow(p-z,2)+Math.pow(q-A,2))>F?r=null:t-r>=G&&(c.renderer.scrollCursorIntoView(),r=null);var b=e,t=Date.now(),d=c.renderer.layerConfig.lineHeight,h=c.renderer.layerConfig.characterWidth,
g=c.renderer.scroller.getBoundingClientRect(),i=p-g.left,j=g.right-p,k=q-g.top,f=g.bottom-q,l=Math.min(i,j),m=Math.min(k,f),g={row:b.row,column:b.column};2>=l/h&&(g.column+=i<j?-3:2);1>=m/d&&(g.row+=k<f?-1:1);d=b.column!=g.column;a=!a||b.row!=a.row;b.row!=g.row||d&&!a?u?t-u>=H&&c.renderer.scrollCursorIntoView(g):u=t:u=null}function f(){h=c.selection.toOrientedRange();j=c.session.addMarker(h,"ace_selection",c.getSelectionStyle());c.clearSelection();c.isFocused()&&c.renderer.$cursorLayer.setBlinking(!1);
clearInterval(x);B();x=setInterval(B,20);l=0;d.addListener(document,"mousemove",n)}function y(){clearInterval(x);c.session.removeMarker(j);j=null;c.$blockScrolling+=1;c.selection.fromOrientedRange(h);c.$blockScrolling-=1;c.isFocused()&&!w&&c.renderer.$cursorLayer.setBlinking(!c.getReadOnly());e=h=null;l=0;r=u=null;d.removeListener(document,"mousemove",n)}function n(){null==v&&(v=setTimeout(function(){null!=v&&j&&y()},20))}function C(a){a=a.types;return!a||Array.prototype.some.call(a,function(a){return"text/plain"==
a||"Text"==a})}function D(a){var c=["copy","copymove","all","uninitialized"],b=["move","copymove","linkmove","all","uninitialized"],d=k.isMac?a.altKey:a.ctrlKey,e="uninitialized";try{e=a.dataTransfer.effectAllowed.toLowerCase()}catch(h){}a="none";d&&0<=c.indexOf(e)?a="copy":0<=b.indexOf(e)?a="move":0<=c.indexOf(e)&&(a="copy");return a}var c=b.editor,m=I.createElement("img");m.src="data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==";k.isOpera&&(m.style.cssText="width:1px;height:1px;position:fixed;top:0;left:0;z-index:2147483647;opacity:0;");
["dragWait","dragWaitEnd","startDrag","dragReadyEnd","onMouseDrag"].forEach(function(a){b[a]=this[a]},this);c.addEventListener("mousedown",this.onMouseDown.bind(b));var i=c.container,j,p,q,x,h,e,l=0,s,w,u,r;this.onDragStart=function(a){if(this.cancelDrag||!i.draggable){var b=this;setTimeout(function(){b.startSelect();b.captureMouse(a)},0);return a.preventDefault()}h=c.getSelectionRange();var d=a.dataTransfer;d.effectAllowed=c.getReadOnly()?"copy":"copyMove";k.isOpera&&(c.container.appendChild(m),
m.scrollTop=0);d.setDragImage&&d.setDragImage(m,0,0);k.isOpera&&c.container.removeChild(m);d.clearData();d.setData("Text",c.session.getTextRange());w=!0;this.setState("drag")};this.onDragEnd=function(a){w=i.draggable=!1;this.setState(null);c.getReadOnly()||(a=a.dataTransfer.dropEffect,!s&&"move"==a&&c.session.remove(c.getSelectionRange()),c.renderer.$cursorLayer.setBlinking(!0));this.editor.unsetStyle("ace_dragging");this.editor.renderer.setCursorStyle("")};this.onDragEnter=function(a){if(!c.getReadOnly()&&
C(a.dataTransfer))return p=a.clientX,q=a.clientY,j||f(),l++,a.dataTransfer.dropEffect=s=D(a),d.preventDefault(a)};this.onDragOver=function(a){if(!c.getReadOnly()&&C(a.dataTransfer))return p=a.clientX,q=a.clientY,j||(f(),l++),null!==v&&(v=null),a.dataTransfer.dropEffect=s=D(a),d.preventDefault(a)};this.onDragLeave=function(a){l--;if(0>=l&&j)return y(),s=null,d.preventDefault(a)};this.onDrop=function(a){if(e){var b=a.dataTransfer;if(w)switch(s){case "move":h=h.contains(e.row,e.column)?{start:e,end:e}:
c.moveText(h,e);break;case "copy":h=c.moveText(h,e,!0)}else b=b.getData("Text"),h={start:e,end:c.session.insert(e,b)},c.focus(),s=null;y();return d.preventDefault(a)}};d.addListener(i,"dragstart",this.onDragStart.bind(b));d.addListener(i,"dragend",this.onDragEnd.bind(b));d.addListener(i,"dragenter",this.onDragEnter.bind(b));d.addListener(i,"dragover",this.onDragOver.bind(b));d.addListener(i,"dragleave",this.onDragLeave.bind(b));d.addListener(i,"drop",this.onDrop.bind(b));var v=null}var I=f("../lib/dom"),
d=f("../lib/event"),k=f("../lib/useragent"),H=200,G=200,F=5;(function(){this.dragWait=function(){Date.now()-this.mousedownEvent.time>this.editor.getDragDelay()&&this.startDrag()};this.dragWaitEnd=function(){this.editor.container.draggable=!1;this.startSelect(this.mousedownEvent.getDocumentPosition());this.selectEnd()};this.dragReadyEnd=function(){this.editor.renderer.$cursorLayer.setBlinking(!this.editor.getReadOnly());this.editor.unsetStyle("ace_dragging");this.editor.renderer.setCursorStyle("");
this.dragWaitEnd()};this.startDrag=function(){this.cancelDrag=!1;var b=this.editor;b.container.draggable=!0;b.renderer.$cursorLayer.setBlinking(!1);b.setStyle("ace_dragging");b.renderer.setCursorStyle(k.isWin?"default":"move");this.setState("dragReady")};this.onMouseDrag=function(){var b=this.editor.container;if(k.isIE&&"dragReady"==this.state){var d=Math.sqrt(Math.pow(this.x-this.mousedownEvent.x,2)+Math.pow(this.y-this.mousedownEvent.y,2));3<d&&b.dragDrop()}"dragWait"===this.state&&(d=Math.sqrt(Math.pow(this.x-
this.mousedownEvent.x,2)+Math.pow(this.y-this.mousedownEvent.y,2)),0<d&&(b.draggable=!1,this.startSelect(this.mousedownEvent.getDocumentPosition())))};this.onMouseDown=function(b){if(this.$dragEnabled){this.mousedownEvent=b;var d=this.editor,f=b.inSelection(),n=b.getButton();if(1===(b.domEvent.detail||1)&&0===n&&f)if(!b.editor.inMultiSelectMode||!b.getAccelKey()&&!b.getShiftKey())this.mousedownEvent.time=Date.now(),f=b.domEvent.target||b.domEvent.srcElement,"unselectable"in f&&(f.unselectable="on"),
d.getDragDelay()?(k.isWebKit&&(this.cancelDrag=!0,d.container.draggable=!0),this.setState("dragWait")):this.startDrag(),this.captureMouse(b,this.onMouseDrag.bind(this)),b.defaultPrevented=!0}}}).call(n.prototype);E.DragdropHandler=n});