/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./range ./search ./edit_session ./search_highlight ./lib/dom".split(" "),function(d,i){function f(){}var g=d("./lib/oop");d("./range");var h=d("./search").Search,j=d("./edit_session").EditSession,k=d("./search_highlight").SearchHighlight;g.inherits(f,h);(function(){this.enter=function(a,c){if(!c.needle)return!1;var b=a.getCursorPosition();this.displayOccurContent(a,c);b=this.originalToOccurPosition(a.session,b);a.moveCursorToPosition(b);return!0};this.exit=
function(a,c){var b=c.translatePosition&&a.getCursorPosition(),b=b&&this.occurToOriginalPosition(a.session,b);this.displayOriginalContent(a);b&&a.moveCursorToPosition(b);return!0};this.highlight=function(a,c){(a.$occurHighlight=a.$occurHighlight||a.addDynamicMarker(new k(null,"ace_occur-highlight","text"))).setRegexp(c);a._emit("changeBackMarker")};this.displayOccurContent=function(a,c){this.$originalSession=a.session;var b=this.matchingLines(a.session,c),e=b.map(function(a){return a.content}),e=
new j(e.join("\n"));e.$occur=this;e.$occurMatchingLines=b;a.setSession(e);this.$useEmacsStyleLineStart=this.$originalSession.$useEmacsStyleLineStart;e.$useEmacsStyleLineStart=this.$useEmacsStyleLineStart;this.highlight(e,c.re);e._emit("changeBackMarker")};this.displayOriginalContent=function(a){a.setSession(this.$originalSession);this.$originalSession.$useEmacsStyleLineStart=this.$useEmacsStyleLineStart};this.originalToOccurPosition=function(a,c){var b=a.$occurMatchingLines,e={row:0,column:0};if(!b)return e;
for(var d=0;d<b.length;d++)if(b[d].row===c.row)return{row:d,column:c.column};return e};this.occurToOriginalPosition=function(a,c){var b=a.$occurMatchingLines;return!b||!b[c.row]?c:{row:b[c.row].row,column:c.column}};this.matchingLines=function(a,c){c=g.mixin({},c);if(!a||!c.needle)return[];var b=new h;b.set(c);return b.findAll(a).reduce(function(b,c){var d=c.start.row,f=b[b.length-1];return f&&f.row===d?b:b.concat({row:d,content:a.getLine(d)})},[])}}).call(f.prototype);d("./lib/dom").importCssString(".ace_occur-highlight {\n    border-radius: 4px;\n    background-color: rgba(87, 255, 8, 0.25);\n    position: absolute;\n    z-index: 4;\n    -moz-box-sizing: border-box;\n    -webkit-box-sizing: border-box;\n    box-sizing: border-box;\n    box-shadow: 0 0 4px rgb(91, 255, 50);\n}\n.ace_dark .ace_occur-highlight {\n    background-color: rgb(80, 140, 85);\n    box-shadow: 0 0 4px rgb(60, 120, 70);\n}\n",
"incremental-occur-highlighting");i.Occur=f});