/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./edit_session ./editor ./test/mockrenderer ./test/assertions ./mode/javascript ./placeholder ./undomanager ./multi_select".split(" "),function(d,m,k){var f=d("./edit_session").EditSession,g=d("./editor").Editor,h=d("./test/mockrenderer").MockRenderer,e=d("./test/assertions"),i=d("./mode/javascript").Mode,j=d("./placeholder").PlaceHolder,l=d("./undomanager").UndoManager;d("./multi_select");k.exports={"test: simple at the end appending of text":function(){var b=new f("var a = 10;\nconsole.log(a, a);",
new i),a=new g(new h,b);new j(b,1,{row:0,column:4},[{row:1,column:12},{row:1,column:15}]);a.moveCursorTo(0,5);a.insert("b");e.equal(b.doc.getValue(),"var ab = 10;\nconsole.log(ab, ab);");a.insert("cd");e.equal(b.doc.getValue(),"var abcd = 10;\nconsole.log(abcd, abcd);");a.remove("left");a.remove("left");a.remove("left");e.equal(b.doc.getValue(),"var a = 10;\nconsole.log(a, a);")},"test: inserting text outside placeholder":function(){var b=new f("var a = 10;\nconsole.log(a, a);\n",new i),a=new g(new h,
b);new j(b,1,{row:0,column:4},[{row:1,column:12},{row:1,column:15}]);a.moveCursorTo(2,0);a.insert("b");e.equal(b.doc.getValue(),"var a = 10;\nconsole.log(a, a);\nb")},"test: insertion at the beginning":function(b){var a=new f("var a = 10;\nconsole.log(a, a);",new i),c=new g(new h,a);new j(a,1,{row:0,column:4},[{row:1,column:12},{row:1,column:15}]);c.moveCursorTo(0,4);c.insert("$");e.equal(a.doc.getValue(),"var $a = 10;\nconsole.log($a, $a);");c.moveCursorTo(0,4);setTimeout(function(){c.insert("v");
e.equal(a.doc.getValue(),"var v$a = 10;\nconsole.log(v$a, v$a);");b()},20)},"test: detaching placeholder":function(){var b=new f("var a = 10;\nconsole.log(a, a);",new i),a=new g(new h,b),c=new j(b,1,{row:0,column:4},[{row:1,column:12},{row:1,column:15}]);a.moveCursorTo(0,5);a.insert("b");e.equal(b.doc.getValue(),"var ab = 10;\nconsole.log(ab, ab);");c.detach();a.insert("cd");e.equal(b.doc.getValue(),"var abcd = 10;\nconsole.log(ab, ab);")},"test: events":function(){var b=new f("var a = 10;\nconsole.log(a, a);",
new i),a=new g(new h,b),b=new j(b,1,{row:0,column:4},[{row:1,column:12},{row:1,column:15}]),c=!1,d=!1;b.on("cursorEnter",function(){c=!0});b.on("cursorLeave",function(){d=!0});a.moveCursorTo(0,0);a.moveCursorTo(0,4);b.onCursorChange();e.ok(c);a.moveCursorTo(1,0);b.onCursorChange();e.ok(d)},"test: cancel":function(b){var a=new f("var a = 10;\nconsole.log(a, a);",new i);a.setUndoManager(new l);var c=new g(new h,a),d=new j(a,1,{row:0,column:4},[{row:1,column:12},{row:1,column:15}]);c.moveCursorTo(0,
5);c.insert("b");c.insert("cd");c.remove("left");e.equal(a.doc.getValue(),"var abc = 10;\nconsole.log(abc, abc);");setTimeout(function(){d.cancel();e.equal(a.doc.getValue(),"var a = 10;\nconsole.log(a, a);");b()},80)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();