/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/dom ./lib/event ./lib/event_emitter".split(" "),function(e,b){var g=e("./lib/oop"),h=e("./lib/dom"),i=e("./lib/event"),j=e("./lib/event_emitter").EventEmitter,c=function(a){this.element=h.createElement("div");this.element.className="ace_scrollbar ace_scrollbar"+this.classSuffix;this.inner=h.createElement("div");this.inner.className="ace_scrollbar-inner";this.element.appendChild(this.inner);a.appendChild(this.element);this.setVisible(!1);this.skipEvent=
!1;i.addListener(this.element,"scroll",this.onScroll.bind(this));i.addListener(this.element,"mousedown",i.preventDefault)};(function(){g.implement(this,j);this.setVisible=function(a){this.element.style.display=a?"":"none";this.isVisible=a;this.coeff=1}}).call(c.prototype);var d=function(a,b){c.call(this,a);this.scrollHeight=this.scrollTop=0;b.$scrollbarWidth=this.width=h.scrollbarWidth(a.ownerDocument);this.inner.style.width=this.element.style.width=(this.width||15)+5+"px"};g.inherits(d,c);(function(){this.classSuffix=
"-v";this.onScroll=function(){if(!this.skipEvent){this.scrollTop=this.element.scrollTop;if(1!=this.coeff){var a=this.element.clientHeight/this.scrollHeight;this.scrollTop=this.scrollTop*(1-a)/(this.coeff-a)}this._emit("scroll",{data:this.scrollTop})}this.skipEvent=!1};this.getWidth=function(){return this.isVisible?this.width:0};this.setHeight=function(a){this.element.style.height=a+"px"};this.setInnerHeight=this.setScrollHeight=function(a){this.scrollHeight=a;32768<a?(this.coeff=32768/a,a=32768):
1!=this.coeff&&(this.coeff=1);this.inner.style.height=a+"px"};this.setScrollTop=function(a){this.scrollTop!=a&&(this.skipEvent=!0,this.scrollTop=a,this.element.scrollTop=a*this.coeff)}}).call(d.prototype);var f=function(a,b){c.call(this,a);this.scrollLeft=0;this.height=b.$scrollbarWidth;this.inner.style.height=this.element.style.height=(this.height||15)+5+"px"};g.inherits(f,c);(function(){this.classSuffix="-h";this.onScroll=function(){this.skipEvent||(this.scrollLeft=this.element.scrollLeft,this._emit("scroll",
{data:this.scrollLeft}));this.skipEvent=!1};this.getHeight=function(){return this.isVisible?this.height:0};this.setWidth=function(a){this.element.style.width=a+"px"};this.setInnerWidth=function(a){this.inner.style.width=a+"px"};this.setScrollWidth=function(a){this.inner.style.width=a+"px"};this.setScrollLeft=function(a){this.scrollLeft!=a&&(this.skipEvent=!0,this.scrollLeft=this.element.scrollLeft=a)}}).call(f.prototype);b.ScrollBar=d;b.ScrollBarV=d;b.ScrollBarH=f;b.VScrollBar=d;b.HScrollBar=f});