/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(f,e){var a=e.MockRenderer=function(a){this.container=document.createElement("div");this.scroller=document.createElement("div");this.visibleRowCount=a||20;this.layerConfig={firstVisibleRow:0,lastVisibleRow:this.visibleRowCount};this.isMockRenderer=!0;this.$gutter={}};a.prototype.getFirstVisibleRow=function(){return this.layerConfig.firstVisibleRow};a.prototype.getLastVisibleRow=function(){return this.layerConfig.lastVisibleRow};a.prototype.getFirstFullyVisibleRow=
function(){return this.layerConfig.firstVisibleRow};a.prototype.getLastFullyVisibleRow=function(){return this.layerConfig.lastVisibleRow};a.prototype.getContainerElement=function(){return this.container};a.prototype.getMouseEventTarget=function(){return this.container};a.prototype.getTextAreaContainer=function(){return this.container};a.prototype.addGutterDecoration=function(){};a.prototype.removeGutterDecoration=function(){};a.prototype.moveTextAreaToCursor=function(){};a.prototype.setSession=function(a){this.session=
a};a.prototype.getSession=function(){return this.session};a.prototype.setTokenizer=function(){};a.prototype.on=function(){};a.prototype.updateCursor=function(){};a.prototype.animateScrolling=function(a,c){c&&c()};a.prototype.scrollToX=function(){};a.prototype.scrollToY=function(){};a.prototype.scrollToLine=function(a,c){for(var b=0,d=1;d<a;d++)b+=this.session.getRowLength(d-1);c&&(b-=this.visibleRowCount/2);this.scrollToRow(b)};a.prototype.scrollSelectionIntoView=function(){};a.prototype.scrollCursorIntoView=
function(){var a=this.session.getSelection().getCursor();a.row<this.layerConfig.firstVisibleRow?this.scrollToRow(a.row):a.row>this.layerConfig.lastVisibleRow&&this.scrollToRow(a.row)};a.prototype.scrollToRow=function(a){a=Math.min(this.session.getLength()-this.visibleRowCount,Math.max(0,a));this.layerConfig.firstVisibleRow=a;this.layerConfig.lastVisibleRow=a+this.visibleRowCount};a.prototype.getScrollTopRow=function(){return this.layerConfig.firstVisibleRow};a.prototype.draw=function(){};a.prototype.onChangeTabSize=
function(){};a.prototype.updateLines=function(){};a.prototype.updateBackMarkers=function(){};a.prototype.updateFrontMarkers=function(){};a.prototype.updateBreakpoints=function(){};a.prototype.onResize=function(){};a.prototype.updateFull=function(){};a.prototype.updateText=function(){};a.prototype.showCursor=function(){};a.prototype.visualizeFocus=function(){};a.prototype.setAnnotations=function(){};a.prototype.setStyle=function(){};a.prototype.unsetStyle=function(){};a.prototype.textToScreenCoordinates=
function(){return{pageX:0,pageY:0}};a.prototype.screenToTextCoordinates=function(){return{row:0,column:0}};a.prototype.adjustWrapLimit=function(){}});