/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define(["require","exports","module","./tokenizer","./test/assertions"],function(f,h,g){var d=f("./tokenizer").Tokenizer,c=f("./test/assertions");g.exports={"test: createSplitterRegexp":function(){var b=new d({}),a=b.createSplitterRegexp("(a)(b)(?=[x)(])");c.equal(a.source,"^(a)(b)$");a=b.createSplitterRegexp("xc(?=([x)(]))");c.equal(a.source,"^xc$");a=b.createSplitterRegexp("(xc(?=([x)(])))");c.equal(a.source,"^(xc)$");a=b.createSplitterRegexp("(?=r)[(?=)](?=([x)(]))");c.equal(a.source,"^(?=r)[(?=)]$");
a=b.createSplitterRegexp("(?=r)[(?=)](\\?=t)");c.equal(a.source,"^(?=r)[(?=)](\\?=t)$");a=b.createSplitterRegexp("[(?=)](\\?=t)");c.equal(a.source,"^[(?=)](\\?=t)$")},"test: removeCapturingGroups":function(){var b=(new d({})).removeCapturingGroups("(ax(by))[()]");c.equal(b,"(?:ax(?:by))[()]")},"test: broken highlight rules":function(){var b=new d({start:[{token:"s",regex:"&&&|^^^"},{defaultToken:"def"}],state1:[{token:"x",regex:/\b([\w]*)(\s*)((?::)?)/}]}),a=0;b.reportError=function(){a++};var e=
b.getLineTokens("x|","start");c.deepEqual(e,{tokens:[{value:"x|",type:"overflow"}],state:"start"});e=b.getLineTokens("x|","state1");c.deepEqual(e,{tokens:[{value:"x",type:"x"},{value:"|",type:"overflow"}],state:"start"});c.equal(a,2)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();