/**
	 * Copyright (c) 2014-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 */

/**
	 * Copyright (c) 2014-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 *
	 * @providesModule Dispatcher
	 * 
	 * @preventMunge
	 */

/**
	 * Copyright 2013-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 *
	 * @providesModule invariant
	 */

(function(f,a){"object"===typeof exports&&"object"===typeof module?module.exports=a():"function"===typeof define&&define.amd?define(a):"object"===typeof exports?exports.Flux=a():f.Flux=a()})(this,function(){var f=[function(e,b,a){e.exports.Dispatcher=a(1)},function(a,b,i){b.__esModule=!0;var h=i(2),c=function(){if(!(this instanceof c))throw new TypeError("Cannot call a class as a function");this._callbacks={};this._isDispatching=!1;this._isHandled={};this._isPending={};this._lastID=1};c.prototype.register=
function(d){var a="ID_"+this._lastID++;this._callbacks[a]=d;return a};c.prototype.unregister=function(d){!this._callbacks[d]?h(!1,"Dispatcher.unregister(...): `%s` does not map to a registered callback.",d):void 0;delete this._callbacks[d]};c.prototype.waitFor=function(d){!this._isDispatching?h(!1,"Dispatcher.waitFor(...): Must be invoked while dispatching."):void 0;for(var a=0;a<d.length;a++){var b=d[a];this._isPending[b]?!this._isHandled[b]?h(!1,"Dispatcher.waitFor(...): Circular dependency detected while waiting for `%s`.",
b):void 0:(!this._callbacks[b]?h(!1,"Dispatcher.waitFor(...): `%s` does not map to a registered callback.",b):void 0,this._invokeCallback(b))}};c.prototype.dispatch=function(a){this._isDispatching?h(!1,"Dispatch.dispatch(...): Cannot dispatch in the middle of a dispatch."):void 0;this._startDispatching(a);try{for(var b in this._callbacks)this._isPending[b]||this._invokeCallback(b)}finally{this._stopDispatching()}};c.prototype.isDispatching=function(){return this._isDispatching};c.prototype._invokeCallback=
function(b){this._isPending[b]=!0;this._callbacks[b](this._pendingPayload);this._isHandled[b]=!0};c.prototype._startDispatching=function(b){for(var a in this._callbacks)this._isPending[a]=!1,this._isHandled[a]=!1;this._pendingPayload=b;this._isDispatching=!0};c.prototype._stopDispatching=function(){delete this._pendingPayload;this._isDispatching=!1};a.exports=c},function(a){a.exports=function(b,a,e,c,d,f,g,j){if(void 0===a)throw Error("invariant requires an error message argument");if(!b){if(void 0===
a)b=Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else var k=[e,c,d,f,g,j],l=0,b=Error("Invariant Violation: "+a.replace(/%s/g,function(){return k[l++]}));b.framesToPop=1;throw b;}}}],a=function(e){if(g[e])return g[e].exports;var b=g[e]={exports:{},id:e,loaded:!1};f[e].call(b.exports,b,b.exports,a);b.loaded=!0;return b.exports},g={};a.m=f;a.c=g;a.p="";return a(0)});