/**
	 * Copyright (c) 2014-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 */

/**
	 * Copyright (c) 2014-2015, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 *
	 * @providesModule Dispatcher
	 * 
	 * @preventMunge
	 */

/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 * All rights reserved.
	 *
	 * This source code is licensed under the BSD-style license found in the
	 * LICENSE file in the root directory of this source tree. An additional grant
	 * of patent rights can be found in the PATENTS file in the same directory.
	 *
	 */

(function(e,c){"object"===typeof exports&&"object"===typeof module?module.exports=c():"function"===typeof define&&define.amd?define([],c):"object"===typeof exports?exports.Flux=c():e.Flux=c()})(this,function(){var e=[function(d,a,c){d.exports.Dispatcher=c(1)},function(c,a,h){a.__esModule=!0;var g=h(2),b=function(){if(!(this instanceof b))throw new TypeError("Cannot call a class as a function");this._callbacks={};this._isDispatching=!1;this._isHandled={};this._isPending={};this._lastID=1};b.prototype.register=
function(i){var a="ID_"+this._lastID++;this._callbacks[a]=i;return a};b.prototype.unregister=function(a){!this._callbacks[a]?g(!1,"Dispatcher.unregister(...): `%s` does not map to a registered callback.",a):void 0;delete this._callbacks[a]};b.prototype.waitFor=function(a){!this._isDispatching?g(!1,"Dispatcher.waitFor(...): Must be invoked while dispatching."):void 0;for(var c=0;c<a.length;c++){var b=a[c];this._isPending[b]?!this._isHandled[b]?g(!1,"Dispatcher.waitFor(...): Circular dependency detected while waiting for `%s`.",
b):void 0:(!this._callbacks[b]?g(!1,"Dispatcher.waitFor(...): `%s` does not map to a registered callback.",b):void 0,this._invokeCallback(b))}};b.prototype.dispatch=function(a){this._isDispatching?g(!1,"Dispatch.dispatch(...): Cannot dispatch in the middle of a dispatch."):void 0;this._startDispatching(a);try{for(var b in this._callbacks)this._isPending[b]||this._invokeCallback(b)}finally{this._stopDispatching()}};b.prototype.isDispatching=function(){return this._isDispatching};b.prototype._invokeCallback=
function(a){this._isPending[a]=!0;this._callbacks[a](this._pendingPayload);this._isHandled[a]=!0};b.prototype._startDispatching=function(a){for(var b in this._callbacks)this._isPending[b]=!1,this._isHandled[b]=!1;this._pendingPayload=a;this._isDispatching=!0};b.prototype._stopDispatching=function(){delete this._pendingPayload;this._isDispatching=!1};c.exports=b},function(c){c.exports=function(a,c,d,b,e,f,j,k){if(void 0===c)throw Error("invariant requires an error message argument");if(!a){if(void 0===
c)a=Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var l=[d,b,e,f,j,k],m=0,a=Error(c.replace(/%s/g,function(){return l[m++]}));a.name="Invariant Violation"}a.framesToPop=1;throw a;}}}],c=function(d){if(f[d])return f[d].exports;var a=f[d]={exports:{},id:d,loaded:!1};e[d].call(a.exports,a,a.exports,c);a.loaded=!0;return a.exports},f={};c.m=e;c.c=f;c.p="";return c(0)});