/******************************************************************************
 * jquery.i18n.properties
 *
 * Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and
 * MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses.
 *
 * @version     1.2.2
 * @url         https://github.com/jquery-i18n-properties/jquery-i18n-properties
 * @inspiration Localisation assistance for jQuery (http://keith-wood.name/localisation.html)
 *              by Keith Wood (kbwood{at}iinet.com.au) June 2007
 *
 *****************************************************************************/

/* Cross-Browser Split 1.0.1
   (c) Steven Levithan <stevenlevithan.com>; MIT License
   An ECMA-compliant, uniform cross-browser split method */

(function(k){function r(b){b.async&&(b.filesLoaded+=1,b.filesLoaded===b.totalFiles&&b.callback&&b.callback())}function n(b,a){k.ajax({url:b,async:a.async,cache:a.cache,dataType:"text",success:function(b){s(b,a.mode);r(a)},error:function(){console.log("Failed to download or parse "+b);r(a)}})}function s(b,a){for(var d="",c=b.split(/\n/),e=/(\{\d+})/g,f=/\{(\d+)}/g,i=/(\\u.{4})/ig,g=0;g<c.length;g++)if(c[g]=c[g].replace(/^\s\s*/,"").replace(/\s\s*$/,""),0<c[g].length&&"#"!=c[g].match("^#")){var j=c[g].split("=");
if(0<j.length){for(var p=decodeURI(j[0]).replace(/^\s\s*/,"").replace(/\s\s*$/,""),h=1==j.length?"":j[1];"\\"==h.match(/\\$/);)h=h.substring(0,h.length-1),h+=c[++g].replace(/\s\s*$/,"");for(var m=2;m<j.length;m++)h+="="+j[m];h=h.replace(/^\s\s*/,"").replace(/\s\s*$/,"");if("map"==a||"both"==a){if(j=h.match(i))for(m=0;m<j.length;m++)h=h.replace(j[m],t(j[m]));k.i18n.map[p]=h}if("vars"==a||"both"==a)if(h=h.replace(/"/g,'\\"'),u(p),e.test(h)){for(var j=h.split(e),m=!0,l="",n=[],q=0;q<j.length;q++)if(e.test(j[q])&&
(0==n.length||-1==n.indexOf(j[q])))m||(l+=","),l+=j[q].replace(f,"v$1"),n.push(j[q]),m=!1;d+=p+"=function("+l+"){";p='"'+h.replace(f,'"+v$1+"')+'"';d+="return "+p+";};"}else d+=p+'="'+h+'";'}}eval(d)}function u(b){if(/\./.test(b))for(var a="",b=b.split(/\./),d=0;d<b.length;d++)0<d&&(a+="."),a+=b[d],eval("typeof "+a+' == "undefined"')&&eval(a+"={};")}function t(b){var a=[],b=parseInt(b.substr(2),16);0<=b&&b<Math.pow(2,16)&&a.push(b);for(var b="",d=0;d<a.length;++d)b+=String.fromCharCode(a[d]);return b}
k.i18n={};k.i18n.map={};k.i18n.properties=function(b){b=k.extend({name:"Messages",language:"",path:"",mode:"vars",cache:!1,encoding:"UTF-8",async:!1,checkAvailableLanguages:!1,callback:null},b);b.language=this.normaliseLanguageCode(b.language);var a=function(a){b.totalFiles=0;b.filesLoaded=0;var c=b.name&&b.name.constructor==Array?b.name:[b.name];if(b.async)for(var e=0,f=c.length;e<f;e++){b.totalFiles+=1;var i=b.language.substring(0,2);if(0==a.length||-1!=k.inArray(i,a))b.totalFiles+=1;if(5<=b.language.length&&
(i=b.language.substring(0,5),0==a.length||-1!=k.inArray(i,a)))b.totalFiles+=1}e=0;for(f=c.length;e<f;e++)n(b.path+c[e]+".properties",b),i=b.language.substring(0,2),(0==a.length||-1!=k.inArray(i,a))&&n(b.path+c[e]+"_"+i+".properties",b),5<=b.language.length&&(i=b.language.substring(0,5),(0==a.length||-1!=k.inArray(i,a))&&n(b.path+c[e]+"_"+i+".properties",b));b.callback&&!b.async&&b.callback()};b.checkAvailableLanguages?k.ajax({url:b.path+"languages.json",async:b.async,cache:!1,success:function(b){a(b.languages||
[])}}):a([])};k.i18n.prop=function(b){var a=k.i18n.map[b];if(null==a)return"["+b+"]";var d;2==arguments.length&&k.isArray(arguments[1])&&(d=arguments[1]);var c;if("string"==typeof a){for(c=0;-1!=(c=a.indexOf("\\",c));)a="t"==a.charAt(c+1)?a.substring(0,c)+"\t"+a.substring(c++ +2):"r"==a.charAt(c+1)?a.substring(0,c)+"\r"+a.substring(c++ +2):"n"==a.charAt(c+1)?a.substring(0,c)+"\n"+a.substring(c++ +2):"f"==a.charAt(c+1)?a.substring(0,c)+"\f"+a.substring(c++ +2):"\\"==a.charAt(c+1)?a.substring(0,c)+
"\\"+a.substring(c++ +2):a.substring(0,c)+a.substring(c+1);var e=[],f,i;for(c=0;c<a.length;)if("'"==a.charAt(c))if(c==a.length-1)a=a.substring(0,c);else if("'"==a.charAt(c+1))a=a.substring(0,c)+a.substring(++c);else{for(f=c+2;-1!=(f=a.indexOf("'",f));)if(f==a.length-1||"'"!=a.charAt(f+1)){a=a.substring(0,c)+a.substring(c+1,f)+a.substring(f+1);c=f-1;break}else a=a.substring(0,f)+a.substring(++f);-1==f&&(a=a.substring(0,c)+a.substring(c+1))}else"{"==a.charAt(c)?(f=a.indexOf("}",c+1),-1==f?c++:(i=parseInt(a.substring(c+
1,f)),!isNaN(i)&&0<=i?(c=a.substring(0,c),""!=c&&e.push(c),e.push(i),c=0,a=a.substring(f+1)):c=f+1)):c++;""!=a&&e.push(a);a=e;k.i18n.map[b]=e}if(0==a.length)return"";if(1==a.length&&"string"==typeof a[0])return a[0];e="";for(c=0;c<a.length;c++)e="string"==typeof a[c]?e+a[c]:d&&a[c]<d.length?e+d[a[c]]:!d&&a[c]+1<arguments.length?e+arguments[a[c]+1]:e+("{"+a[c]+"}");return e};k.i18n.normaliseLanguageCode=function(b){if(!b||2>b.length)b=navigator.languages?navigator.languages[0]:navigator.language||
navigator.userLanguage||"en";b=b.toLowerCase();b=b.replace(/-/,"_");3<b.length&&(b=b.substring(0,3)+b.substring(3).toUpperCase());return b};var l;l||(l=function(b,a,d){if("[object RegExp]"!==Object.prototype.toString.call(a))return"undefined"==typeof l._nativeSplit?b.split(a,d):l._nativeSplit.call(b,a,d);var c=[],e=0,f=(a.ignoreCase?"i":"")+(a.multiline?"m":"")+(a.sticky?"y":""),a=RegExp(a.source,f+"g"),i,g,j,b=b+"";l._compliantExecNpcg||(i=RegExp("^"+a.source+"$(?!\\s)",f));if(void 0===d||0>+d)d=
Infinity;else if(d=Math.floor(+d),!d)return[];for(;g=a.exec(b);){f=g.index+g[0].length;if(f>e&&(c.push(b.slice(e,g.index)),!l._compliantExecNpcg&&1<g.length&&g[0].replace(i,function(){for(var a=1;a<arguments.length-2;a++)void 0===arguments[a]&&(g[a]=void 0)}),1<g.length&&g.index<b.length&&Array.prototype.push.apply(c,g.slice(1)),j=g[0].length,e=f,c.length>=d))break;a.lastIndex===g.index&&a.lastIndex++}e===b.length?(j||!a.test(""))&&c.push(""):c.push(b.slice(e));return c.length>d?c.slice(0,d):c},l._compliantExecNpcg=
void 0===/()??/.exec("")[1],l._nativeSplit=String.prototype.split);String.prototype.split=function(b,a){return l(this,b,a)}})(jQuery);