/******************************************************************************
 * jquery.i18n.properties
 *
 * Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and
 * MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses.
 *
 * @version     1.2.7
 * @url         https://github.com/jquery-i18n-properties/jquery-i18n-properties
 * @inspiration Localisation assistance for jQuery (http://keith-wood.name/localisation.html)
 *              by Keith Wood (kbwood{at}iinet.com.au) June 2007
 *
 *****************************************************************************/

(function(i){function l(c,a){a.debug&&h("loadAndParseFiles");if(null!==c&&0<c.length){var f=c[0];a.debug&&(h("loadAndParseFile('"+f+"')"),h("totalFiles: "+a.totalFiles),h("filesLoaded: "+a.filesLoaded));null!==f&&"undefined"!==typeof f&&i.ajax({url:f,async:a.async,cache:a.cache,dataType:"text",success:function(b){a.debug&&(h("Succeeded in downloading "+f+"."),h(b));r(b,a);c.shift();l(c,a)},error:function(b,e,d){a.debug&&h("Failed to download or parse "+f+". errorThrown: "+d);404===b.status&&(a.totalFiles-=
1);c.shift();l(c,a)}})}else a.debug&&(h("callbackIfComplete()"),h("totalFiles: "+a.totalFiles),h("filesLoaded: "+a.filesLoaded)),a.async&&a.filesLoaded===a.totalFiles&&a.callback&&a.callback()}function r(c,a){var f="",b=c.split(/\n/),e=/(\{\d+})/g,d=/\{(\d+)}/g,h=/(\\u.{4})/ig;b.forEach(function(c,l){c=c.trim();if(0<c.length&&"#"!=c.match("^#")){var j=c.split("=");if(0<j.length){for(var k=decodeURI(j[0]).trim(),g=1==j.length?"":j[1];"\\"===g.match(/\\$/);)g=g.substring(0,g.length-1),g+=b[++l].trimRight();
for(var n=2;n<j.length;n++)g+="="+j[n];g=g.trim();if("map"==a.mode||"both"==a.mode)(j=g.match(h))&&j.forEach(function(a){g=g.replace(a,s(a))}),i.i18n.map[k]=g;if("vars"==a.mode||"both"==a.mode)if(g=g.replace(/"/g,'\\"'),t(k),e.test(g)){var q=!0,m="",p=[];g.split(e).forEach(function(a){if(e.test(a)&&(0===p.length||-1==p.indexOf(a)))q||(m+=","),m+=a.replace(d,"v$1"),p.push(a),q=!1});f+=k+"=function("+m+"){";k='"'+g.replace(d,'"+v$1+"')+'"';f+="return "+k+";};"}else f+=k+'="'+g+'";'}}});eval(f);a.filesLoaded+=
1}function t(c){if(/\./.test(c)){var a="";c.split(/\./).forEach(function(c,b){0<b&&(a+=".");a+=c;eval("typeof "+a+' == "undefined"')&&eval(a+"={};")})}}function s(c){var a=[],c=parseInt(c.substr(2),16);0<=c&&c<Math.pow(2,16)&&a.push(c);return a.reduce(function(a,b){return a+String.fromCharCode(b)},"")}i.i18n={};i.i18n.map={};var h=function(c){window.console&&console.log("i18n::"+c)};i.i18n.properties=function(c){c=i.extend({name:"Messages",language:"",path:"",mode:"vars",cache:!1,debug:!1,encoding:"UTF-8",
async:!1,callback:null},c);c.path.match(/\/$/)||(c.path+="/");c.language=this.normaliseLanguageCode(c.language);var a=c.name&&c.name.constructor===Array?c.name:[c.name];c.totalFiles=2*a.length+(5<=c.language.length?a.length:0);c.debug&&h("totalFiles: "+c.totalFiles);c.filesLoaded=0;a.forEach(function(a){var b,e;b=c.path+a+".properties";e=c.language.substring(0,2);e=c.path+a+"_"+e+".properties";if(5<=c.language.length){var d=c.language.substring(0,5),a=c.path+a+"_"+d+".properties";b=[b,e,a]}else b=
[b,e];l(b,c)});c.callback&&!c.async&&c.callback()};i.i18n.prop=function(c){var a=i.i18n.map[c];if(null==a)return"["+c+"]";var f;2==arguments.length&&i.isArray(arguments[1])&&(f=arguments[1]);var b;if("string"==typeof a){for(b=0;-1!=(b=a.indexOf("\\",b));)a="t"==a.charAt(b+1)?a.substring(0,b)+"\t"+a.substring(b++ +2):"r"==a.charAt(b+1)?a.substring(0,b)+"\r"+a.substring(b++ +2):"n"==a.charAt(b+1)?a.substring(0,b)+"\n"+a.substring(b++ +2):"f"==a.charAt(b+1)?a.substring(0,b)+"\f"+a.substring(b++ +2):
"\\"==a.charAt(b+1)?a.substring(0,b)+"\\"+a.substring(b++ +2):a.substring(0,b)+a.substring(b+1);var e=[],d,h;for(b=0;b<a.length;)if("'"==a.charAt(b))if(b==a.length-1)a=a.substring(0,b);else if("'"==a.charAt(b+1))a=a.substring(0,b)+a.substring(++b);else{for(d=b+2;-1!=(d=a.indexOf("'",d));)if(d==a.length-1||"'"!=a.charAt(d+1)){a=a.substring(0,b)+a.substring(b+1,d)+a.substring(d+1);b=d-1;break}else a=a.substring(0,d)+a.substring(++d);-1==d&&(a=a.substring(0,b)+a.substring(b+1))}else"{"==a.charAt(b)?
(d=a.indexOf("}",b+1),-1==d?b++:(h=parseInt(a.substring(b+1,d)),!isNaN(h)&&0<=h?(b=a.substring(0,b),""!==b&&e.push(b),e.push(h),b=0,a=a.substring(d+1)):b=d+1)):b++;""!==a&&e.push(a);a=e;i.i18n.map[c]=e}if(0===a.length)return"";if(1==a.length&&"string"==typeof a[0])return a[0];e="";b=0;for(d=a.length;b<d;b++)e="string"==typeof a[b]?e+a[b]:f&&a[b]<f.length?e+f[a[b]]:!f&&a[b]+1<arguments.length?e+arguments[a[b]+1]:e+("{"+a[b]+"}");return e};i.i18n.normaliseLanguageCode=function(c){if(!c||2>c.length)c=
navigator.languages&&0<navigator.languages.length?navigator.languages[0]:navigator.language||navigator.userLanguage||"en";c=c.toLowerCase();c=c.replace(/-/,"_");3<c.length&&(c=c.substring(0,3)+c.substring(3).toUpperCase());return c}})(jQuery);