/**
 * @author SVN & DOGO
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/VertexShaderQuad","WV3Dmod/shaders/ShaderUtils"],function(a,b,c){return{uniforms:{canvas_size:{type:"v2",value:null},backdrop:{type:"t",value:null},backdrop_enabled:{type:"i",value:0},backdrop_scale:{type:"v2",value:new a.Vector2(1,1)},backdrop_offset:{type:"v2",value:new a.Vector2(0,0)},reflection:{type:"t",value:null},reflection_enabled:{type:"i",value:0},reflection_opacity:{type:"f",value:0},reflection_fade:{type:"i",value:0},reflection_fade_size:{type:"f",
value:0},reflection_fade_position:{type:"f",value:0},default_bg_color:{type:"v4",value:new a.Vector4(0.37,0.37,0.37,1)}},vertexShader:b.vertexShader,fragmentShader:["uniform vec2 canvas_size;\nuniform sampler2D backdrop;\nuniform bool backdrop_enabled;\nuniform vec2 backdrop_scale;\nuniform vec2 backdrop_offset;\nuniform sampler2D reflection;\nuniform bool reflection_enabled;\nuniform float reflection_opacity;\nuniform bool reflection_fade;\nuniform float reflection_fade_size;\nuniform float reflection_fade_position;\nuniform vec4 default_bg_color;\nvoid main()\n{\nvec2 loc = vec2(gl_FragCoord.x/canvas_size.x, gl_FragCoord.y/canvas_size.y);\nvec3 tex_reflect_color = texture2D(reflection, loc).rgb;\nvec3 reflect_color = (reflection_enabled) ? tex_reflect_color : vec3(0.);\nfloat refopacity = reflection_opacity;",
c.get("ReflectionFadeChunck"),"vec3 tex_bg_color = texture2D(backdrop, loc * backdrop_scale + backdrop_offset ).rgb;\nvec3 bgcol = (backdrop_enabled)? tex_bg_color : default_bg_color.rgb * default_bg_color.a;\ngl_FragColor.rgb = (reflect_color == vec3(0.))? bgcol : (bgcol * (1. - refopacity) + reflect_color * refopacity);\ngl_FragColor.a = (reflect_color == vec3(0.))? default_bg_color.a : refopacity + default_bg_color.a - refopacity * default_bg_color.a;\n}"].join("\n")}});