/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/ShaderUtils"],function(a,b){return{uniforms:{offset:{type:"f",value:1},color:{type:"v3",value:new a.Vector3(0,0,0)},D0RT:{type:"t",value:null},canvas_size:{type:"v2",value:new a.Vector2(0,0)}},vertexShader:"uniform float offset;\nvoid main()\n{\nvec4 pos = modelViewMatrix * vec4( position + normal * offset, 1.0 );\ngl_Position = projectionMatrix * pos;\n}",fragmentShader:["#ifdef USE_DEPTH_TEXTURE",b.get("DeclareDepthSamplerChunck"),b.get("DecodeDepthChunck"),
"#endif\nuniform vec3 color;\nvoid main()\n{\n#ifdef USE_DEPTH_TEXTURE\nvec2 loc = vec2(gl_FragCoord.x/canvas_size.x, gl_FragCoord.y/canvas_size.y);\nfloat scenez = DecodeFloatRGBA(texture2D(D0RT, loc));\nfloat z = 1.0 - gl_FragCoord.z;\nif (z < scenez )\ndiscard;\n#endif\ngl_FragColor = vec4( color, 1.0 );\n}"].join("\n")}});