/**
 * Build configuration
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

 const WV3DPath = "./";
 const WV3D_require = requirejs.config({
    baseUrl: "js",
    shim: {
        'three': {
            exports: 'THREE'
        },

        'underscore': {
            exports: '_'
        }
    },
    paths: {
        'backbone':               "./libs/backbone",
        'detect' :                "./libs/detect",
        'cbor':                   "./libs/cbor",
        'hammerjs' :              "./libs/hammer",
        'jquery':                 "./libs/jquery-2.1.0",
        'jquery.mousewheel' :     "./libs/jquery.mousewheel",
        'stacktrace':             "./libs/stacktrace",
        'three' :                 "./libs/three",
        'underscore':             "./libs/underscore",

        'WV3Dmod':                WV3DPath+"modules",
        'WV3Dlib':                WV3DPath+"libs",//Remove after replacing 'detect' library in SystemChecker
        'WV3D':                   WV3DPath
    }
});
