/**
 * @author SVN & DOGO (Original by RAVO)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["three","@esko/3d-web-viewer/modules/shaders/VertexShaderPM","@esko/3d-web-viewer/modules/shaders/ShaderUtils"],function(b,c,a){return{uniforms:b.UniformsUtils.merge([c.uniforms,{diffuseColor:{type:"c",value:new b.Color(16777215)},opacity:{type:"f",value:null},diffuseTexture:{type:"t",value:null},canvas_size:{type:"v2",value:new b.Vector2(1,1)},DX1RT:{type:"t",value:null},DX2RT:{type:"t",value:null},NBRTSRC:{type:"i",value:0},stripSize:{type:"f",value:250},gapSize:{type:"f",value:35}}]),vertexShader:c.vertexShader,
fragmentShader:["varying vec4 vPosition;\nvarying vec2 texcoordVarying;\nvarying vec2 texcoordVaryingScaled;\nuniform vec3 diffuseColor;\nuniform float opacity;\nuniform sampler2D diffuseTexture;",a.get("DeclareDepthSamplersChunck"),a.get("EncodeDepthChunck"),a.get("DecodeDepthChunck"),a.get("Noise"),a.get("Distort"),"void main()\n{",a.get("SelectPeelChunck"),"vec4 diffColour;\n#ifdef USE_MAP\ndiffColour = texture2D(diffuseTexture, texcoordVaryingScaled);\n#ifdef REMAPPED_DIFFUSE_ALPHA_CHANNEL\ndiffColour.a = clamp((diffColour.a - 127./255.) * 255. / 127., 0.,1.);\n#endif\n#else \ndiffColour = vec4(diffuseColor,opacity);\n#endif",
a.get("WrapDistortFilterColor"),"gl_FragColor = diffColour;\ngl_FragColor.a = 1.0;\n}"].join("\n")}});