/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2017 Esko Software BVBA. All rights reserved.
 */

define(["three","@esko/3d-web-viewer/modules/shaders/VertexShaderQuad","@esko/3d-web-viewer/modules/shaders/ShaderUtils"],function(a){return{uniforms:a.UniformsUtils.merge([a.UniformsLib.common,a.UniformsLib.specularmap,a.UniformsLib.envmap,a.UniformsLib.aomap,a.UniformsLib.lightmap,a.UniformsLib.fog]),vertexShader:["attribute vec3 inst_translation;\nattribute vec4 inst_rotation;\nattribute vec3 inst_scale;",a.ShaderChunk.common,a.ShaderChunk.uv_pars_vertex,a.ShaderChunk.uv2_pars_vertex,a.ShaderChunk.envmap_pars_vertex,
a.ShaderChunk.color_pars_vertex,a.ShaderChunk.fog_pars_vertex,a.ShaderChunk.morphtarget_pars_vertex,a.ShaderChunk.skinning_pars_vertex,a.ShaderChunk.logdepthbuf_pars_vertex,a.ShaderChunk.clipping_planes_pars_vertex,"void main() {",a.ShaderChunk.uv_vertex,a.ShaderChunk.uv2_vertex,a.ShaderChunk.color_vertex,a.ShaderChunk.skinbase_vertex,"#ifdef USE_ENVMAP",a.ShaderChunk.beginnormal_vertex,a.ShaderChunk.morphnormal_vertex,a.ShaderChunk.skinnormal_vertex,a.ShaderChunk.defaultnormal_vertex,"#endif",a.ShaderChunk.begin_vertex,
a.ShaderChunk.morphtarget_vertex,a.ShaderChunk.skinning_vertex,"vec3 worldposition = transformed.xyz * inst_scale;\nvec3 vcV = cross(inst_rotation.xyz, worldposition);\nvec3 vPosition = vcV * (2.0 * inst_rotation.w) + (cross(inst_rotation.xyz, vcV) * 2.0 + worldposition);\nvec4 mvPosition = modelViewMatrix * vec4( vPosition + inst_translation, 1.0 );\ngl_Position = projectionMatrix * mvPosition;",a.ShaderChunk.logdepthbuf_vertex,a.ShaderChunk.worldpos_vertex,a.ShaderChunk.clipping_planes_vertex,a.ShaderChunk.envmap_vertex,
a.ShaderChunk.fog_vertex,"}"].join("\n"),fragmentShader:["uniform vec3 diffuse;\nuniform float opacity;\n#ifndef FLAT_SHADED\n\tvarying vec3 vNormal;\n#endif",a.ShaderChunk.common,a.ShaderChunk.color_pars_fragment,a.ShaderChunk.uv_pars_fragment,a.ShaderChunk.uv2_pars_fragment,a.ShaderChunk.map_pars_fragment,a.ShaderChunk.alphamap_pars_fragment,a.ShaderChunk.aomap_pars_fragment,a.ShaderChunk.lightmap_pars_fragment,a.ShaderChunk.envmap_pars_fragment,a.ShaderChunk.fog_pars_fragment,a.ShaderChunk.specularmap_pars_fragment,
a.ShaderChunk.logdepthbuf_pars_fragment,a.ShaderChunk.clipping_planes_pars_fragment,"void main() {",a.ShaderChunk.clipping_planes_fragment,"\tvec4 diffuseColor = vec4( diffuse, opacity );",a.ShaderChunk.logdepthbuf_fragment,a.ShaderChunk.map_fragment,a.ShaderChunk.color_fragment,a.ShaderChunk.alphamap_fragment,a.ShaderChunk.alphatest_fragment,a.ShaderChunk.specularmap_fragment,"\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\t#ifdef USE_LIGHTMAP\n\t\treflectedLight.indirectDiffuse += texture2D( lightMap, vUv2 ).xyz * lightMapIntensity;\n\t#else\n\t\treflectedLight.indirectDiffuse += vec3( 1.0 );\n\t#endif",
a.ShaderChunk.aomap_fragment,"\treflectedLight.indirectDiffuse *= diffuseColor.rgb;\n\tvec3 outgoingLight = reflectedLight.indirectDiffuse;",a.ShaderChunk.envmap_fragment,"\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );",a.ShaderChunk.premultiplied_alpha_fragment,a.ShaderChunk.tonemapping_fragment,a.ShaderChunk.encodings_fragment,a.ShaderChunk.fog_fragment,"}"].join("\n")}});