/**
 * @author SVN & DOGO (Original by RAVO)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["three"],function(a){return{uniforms:{surfaceSide:{type:"i",value:0},offsetRepeat:{type:"v4",value:new a.Vector4(0,0,1,1)},backTexture:{type:"i",value:0},ambientLightColor:{type:"fv",value:[]},directionalLightDirection:{type:"fv",value:[]},directionalLightColor:{type:"fv",value:[]},hemisphereLightDirection:{type:"fv",value:[]},hemisphereLightSkyColor:{type:"fv",value:[]},hemisphereLightGroundColor:{type:"fv",value:[]},pointLightColor:{type:"fv",value:[]},pointLightPosition:{type:"fv",value:[]},
pointLightDistance:{type:"fv1",value:[]},pointLightDecay:{type:"fv1",value:[]},spotLightColor:{type:"fv",value:[]},spotLightPosition:{type:"fv",value:[]},spotLightDirection:{type:"fv",value:[]},spotLightDistance:{type:"fv1",value:[]},spotLightAngleCos:{type:"fv1",value:[]},spotLightExponent:{type:"fv1",value:[]},spotLightDecay:{type:"fv1",value:[]}},vertexShader:"attribute vec3 inst_translation;\nattribute vec4 inst_rotation;\nattribute vec3 inst_scale;\nvarying vec3 vNormal;\nvarying vec4 vPosition;\nvarying vec4 vWorldPosition;\nvarying vec2 texcoordVaryingScaled;\nuniform vec4 offsetRepeat;\nuniform int backTexture;\nvoid main()\n{\nvec3 temp = cross(inst_rotation.xyz, normal.xyz / inst_scale);\nvec3 rotNormal = temp * (2.0 * inst_rotation.w) + (cross(inst_rotation.xyz, temp) * 2.0 + normal.xyz);\nvNormal = mat3(modelMatrix) * rotNormal;\nvec4 newPosition = vec4(position,1.0);\nvPosition = newPosition;\nvec4 worldPosition = newPosition * vec4(inst_scale,1.0);\ntemp = cross(inst_rotation.xyz, worldPosition.xyz);\nvec3 rotPosition = temp * (2.0 * inst_rotation.w) + (cross(inst_rotation.xyz, temp) * 2.0 + worldPosition.xyz);\nworldPosition = modelMatrix * vec4(rotPosition + inst_translation,1.0);\nvWorldPosition = worldPosition;\nvec2 texcoord = (backTexture == 1) ? vec2(1. - uv.x, uv.y) : uv;\ntexcoordVaryingScaled = texcoord * offsetRepeat.zw + offsetRepeat.xy;\ngl_Position = projectionMatrix * viewMatrix * worldPosition;\n}"}});