import React from "react";
import createIcon from "../utils/createIcon";

const WcrMeasureBraille = props => (
	<svg viewBox="0 0 32 32" width="1em" height="1em" {...props}>
		<circle cx={2} cy={6} r={2} />
		<circle cx={2} cy={26} r={2} />
		<circle cx={30} cy={26} r={2} />
		<circle cx={22} cy={26} r={2} />
		<circle cx={30} cy={16} r={2} />
		<circle cx={22} cy={16} r={2} />
		<circle cx={2} cy={16} r={2} />
		<circle cx={10} cy={6} r={2} />
		<circle cx={10} cy={26} r={2} />
		<circle cx={10} cy={16} r={2} />
	</svg>
);

export default createIcon(WcrMeasureBraille);
