import React from "react";
import createIcon from "../utils/createIcon";

const WcrPriorityFocus = props => (
	<svg viewBox="0 0 32 32" width="1em" height="1em" {...props}>
		<circle cx={16} cy={16} r={2} />
		<path d="M21 6h-3V0h-4v6h-3l5 6zM11 26h3v6h4v-6h3l-5-6zM12 16l-6-5v3H0v4h6v3zM26 14v-3l-6 5 6 5v-3h6v-4z" />
	</svg>
);

export default createIcon(WcrPriorityFocus);
