import React from "react";
import createIcon from "../utils/createIcon";

const WcrVisibilityOn = props => (
	<svg viewBox="0 0 32 32" width="1em" height="1em" {...props}>
		<path d="M16 6C7.164 6 0 16 0 16s7.164 10 16 10 16-10 16-10S24.836 6 16 6zm0 18a8 8 0 1 1 0-16 8 8 0 0 1 0 16z" />
		<circle cx={16} cy={16} r={6} />
	</svg>
);

export default createIcon(WcrVisibilityOn);
