import React from "react";
import createIcon from "../utils/createIcon";

const WcrWeatherSnow = props => (
	<svg viewBox="0 0 32 32" width="1em" height="1em" {...props}>
		<path d="M29.539 12.307A6 6 0 0 0 24 4c-.986 0-1.915.242-2.736.664A7.994 7.994 0 0 0 6 8a6 6 0 1 0 0 12h22v-.01h.005a3.995 3.995 0 0 0 1.534-7.683z" />
		<circle cx={4} cy={24} r={2} />
		<circle cx={8} cy={30} r={2} />
		<circle cx={16} cy={30} r={2} />
		<circle cx={24} cy={30} r={2} />
		<circle cx={12} cy={24} r={2} />
		<circle cx={20} cy={24} r={2} />
		<circle cx={28} cy={24} r={2} />
	</svg>
);

export default createIcon(WcrWeatherSnow);
