const getProps = require("@svgr/core/lib/templates/util").getProps;

const reactDomTemplate = (code, config, state) => {
	const props = getProps(config);

	let result = `import React from 'react';\n`;
	result += `import createIcon from '../utils/createIcon';\n\n`;
	result += `const ${state.componentName} = ${props} => ${code}\n\n`;
	result += `export default createIcon(${state.componentName})`;

	return result;
};

module.exports = reactDomTemplate;
