export default {
	PREFERENCES_UNIT_SIZE: 1,
	PREFERENCES_UNIT_RESOLUTION: 2,
	PREFERENCES_VIEW_ZOOM_MODE: 3,
	PREFERENCES_ANNOTATION_NEXT_MODE: 4,
	PREFERENCES_CHANNELS_SINGESEPBLACK: 5,
	PREFERENCES_FILEOPEN_RECENTPATH: 6,
	PREFERENCES_FILEOPEN_FILTER: 7,
	PREFERENCES_IMAGE_BACKGROUNDCOLOR: 8,
	PREFERENCES_WINDOW_BACKGROUNDCOLOR: 9,
	PREFERENCES_UNIT_SCREEN: 10,
	PREFERENCES_UNIT_ANGLE: 11,
	PREFERENCES_DISPLAY_MARGINS: 12,
	PREFERENCES_MERGEFILES: 13,
	PREFERENCES_HELPBLOCKERWARNING: 14,
	PREFERENCES_DIFFMODE: 15,
	PREFERENCES_RULER_DISPLAY_MODE: 16,
	PREFERENCES_RULER_DISPLAY_COLOR: 17,
	PREFERENCES_UPDATE_PALETTE: 18,
	PREFERENCES_ENABLE_BACKGROUNDCOLOR: 19,
	PREFERENCES_SCREEN_ORIENTATION: 20,
	PREFERENCES_DIFFMODE_COMPARE: 21,
	PREFERENCES_DOCUMENTHISTORYDIALOG_DETAILSMODE: 22,
	PREFERENCES_DOCUMENTHISTORYDIALOG_DOCKED: 23,
	PREFERENCES_DOCUMENTSELECTDIALOG_DOCKED: 24,
	PREFERENCES_RULER_ANGLE_MODE: 25,
	PREFERENCES_RECTOVERSO_MODE: 26,
	PREFERENCES_CHANNELNAME_MODE: 27,
	PREFERENCES_COLORMATCHING: 28,
	PREFERENCES_COLORMATCHING_PROMPT: 29,
	PREFERENCES_DOCUMENTHISTORYDIALOG_REOPEN: 30,
	PREFERENCES_DOCUMENTSELECTDIALOG_REOPEN: 31,
	PREFERENCES_PAGELISTDIALOG_REOPEN: 32,
	PREFERENCES_PAGELISTDIALOG_DOCKED: 33,
	PREFERENCES_PAGELIST_ICON_SIZE: 34,
	PREFERENCES_READOUTDIALOG_SCREEN_VISIBLE: 35,
	PREFERENCES_READOUTDIALOG_DOT_VISIBLE: 36,
	PREFERENCES_SHOWBRIDGES_MODE: 37,
	PREFERENCES_ANNOTATION_NOTE_COLOR: 38,
	PREFERENCES_ANNOTATION_RECTANGLE_COLOR: 39,
	PREFERENCES_DOCUMENTANNOTATIONDIALOG_REOPEN: 40,
	PREFERENCES_DOCUMENTANNOTATIONDIALOG_DOCKED: 41,
	PREFERENCES_ANNOTATION_FITVIEW: 42,
	PREFERENCES_ANNOTATION_SHOWSELECTEDONLY: 43,
	PREFERENCES_ZOOMTOOLS_VISIBLE: 44,
	PREFERENCES_TOOLSPANEL_VISIBLE: 45,
	PREFERENCES_MARGIN_CLIP_MODE: 46,
	PREFERENCES_MARGIN_DISPLAY_MODE: 47,
	PREFERENCES_PANELMAINTOOLS_SKOWMASK: 48,
	PREFERENCES_TOOLSPANELTOP_VISIBLE: 49,
	PREFERENCES_ANNOTATION_SHOWCOUNT: 50,
	PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY: 51,
	PREFERENCES_ANNOTATIONTOOLS_VISIBLE: 52,
	PREFERENCES_ANNOTATION_TOOLMODE: 53,
	PREFERENCES_ANNOTATION_DATESORT_MODE: 54,
	PREFERENCES_READOUTDIALOG_BARCODE_VISIBLE: 55,
	PREFERENCES_DIFF_SPLITMODE: 56,
	PREFERENCES_INKBOOKPATH: 57,
	PREFERENCES_READOUTDIALOG_BRAILLE_VISIBLE: 58,
	PREFERENCES_VIEWX_PARAMETERS: 59,
	PREFERENCES_VIEWXTOOLS_VISIBLE: 60,
	PREFERENCES_BRAILLE_LANGUAGE: 61,
	PREFERENCES_MERGE_SIMILAR_INKS: 62,
	PREFERENCES_VIEWXTOOLS_ENABLE1BIT: 63,
	PREFERENCES_ANTIALIASING: 64,
	PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE: 65,
	PREFERENCES_PILOT_SELECTSERVER: 66,
	PREFERENCES_PILOT_SERVERNAME: 67,

	// In the Java Viewer, the 3 settings below are the custom annotation filter
	PREFERENCES_RULER_DISPLAY_MODE_DA: 68,
	PREFERENCES_RULER_DISPLAY_MODE_XY: 69,
	PREFERENCES_RULER_DISPLAY_MODE_WH: 70,

	PREFERENCES_CALIPER_DISPLAY_MODE: 71, // boolean; true=Fixed size caliper
	PREFERENCE_MONITOR_RES: 72, // double; def 72/25.4 dpmm
	PREFERENCES_ZOOM_REALSIZE: 73, // boolean; def false=do not force OneToOne to be real size always

	// Print preferences 70 to 89
	PREFERENCES_PRINT_SPLITVIEW: 78,
	PREFERENCES_PRINT_MAGNIFICATION: 79,
	PREFERENCES_PRINT_MARG_TOP: 80,
	PREFERENCES_PRINT_MARG_LEFT: 81,
	PREFERENCES_PRINT_MARG_BOTTOM: 82,
	PREFERENCES_PRINT_MARG_RIGHT: 83,
	PREFERENCES_PRINT_ORIENTATION: 84,
	PREFERENCES_PRINT_TYPE: 85,
	PREFERENCES_PRINT_AREA: 86,
	PREFERENCES_PRINT_CHANNELS: 87,
	PREFERENCES_PRINT_RESOLUTION: 88,
	PREFERENCES_PRINT_SCALETOFIT: 89,
	// Highlight color preferences 90 to 99 (90 : overprint, 91 : diff add, 92 : diff sub, 93 : seamless guide lines, 94 : margins, 95 : margins diff)
	PREFERENCES_HIGHLIGHTCOLORS: 90,
	PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD: 91,
	PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB: 92,
	PREFERENCES_HIGHLIGHTCOLORS_SEAMLESS_GUIDELINES: 93,
	PREFERENCES_HIGHLIGHTCOLORS_MARGINS: 94,
	PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF: 95,

	// Layout in standard mode 100 to 199
	LAYOUT_EXPAND_PAGETOOLS_STATE: 100,
	LAYOUT_EXPAND_CHANNELS_STATE: 101,
	LAYOUT_EXPAND_NAVIGATOR_STATE: 102,
	LAYOUT_WINDOW_SIZE_X: 103,
	LAYOUT_WINDOW_SIZE_Y: 104,
	LAYOUT_MODE: 105,
	LAYOUT_MAIN_PANEL_RIGHT_SPLITTER: 106,
	LAYOUT_EXPAND_ANNOTATIONS_STATE: 107,
	LAYOUT_EXPAND_APPROVAL_STATE: 108,
	LAYOUT_NAVIGATOR_SIZE_X: 109,
	LAYOUT_NAVIGATOR_SIZE_Y: 110,
	LAYOUT_EXPAND_CAD_STATE: 111,
	LAYOUT_LAYERSTABLE_SIZE: 112,
	LAYOUT_CLASSESTABLE_SIZE: 113,
	LAYOUT_FRAME_SIZE_X: 114,
	LAYOUT_FRAME_SIZE_Y: 115,
	LAYOUT_FRAME_MAXIMIZED: 116,
	LAYOUT_EXPAND_PAGEVIEW_STATE: 117,
	LAYOUT_EXPAND_INFO_STATE: 118,
	LAYOUT_LOOK_AND_FEEL: 119,
	LAYOUT_CHANNELEDITDIALOG_WIDTH: 120,
	LAYOUT_DOCUMENTSELECTDIALOG_WIDTH: 121,
	LAYOUT_DOCUMENTSELECTDIALOG_HEIGHT: 122,
	LAYOUT_DOCUMENTHISTORYDIALOG_WIDTH: 123,
	LAYOUT_DOCUMENTHISTORYDIALOG_HEIGHT: 124,
	LAYOUT_MAIN_PANEL_LEFT_SPLITTER: 125,
	LAYOUT_EXPAND_DIFFADJUST: 126,
	LAYOUT_PAGELISTDIALOG_WIDTH: 127,
	LAYOUT_PAGELISTDIALOG_HEIGHT: 128,
	LAYOUT_DOCUMENTANNOTATIONDIALOG_WIDTH: 129,
	LAYOUT_DOCUMENTANNOTATIONDIALOG_HEIGHT: 130,

	// MRU list reserves IDs from 200 to 299
	MRU_COUNT: 200,
	MRU_ENTRY1: 201,
	// Path map list (automatic location of diff files) reserves IDs from 300 to 399
	PML_ENTRY1: 301,
	PML_MAXENTRY: 399,

	// Application configuration settings 400 to 499 (only read)
	CONFIG_ISGRAPHOLAS: 400,
	CONFIG_GRAPHOLASHOME: 401,
	CONFIG_SHOWDIFFADJUST: 402,
	CONFIG_COLORMATCHING: 403,
	CONFIG_TOOLTIP_INITIAL: 404,
	CONFIG_TOOLTIP_RESHOW: 405,
	CONFIG_TOOLTIP_DISMISS: 406,
	CONFIG_DIFF_PERCENTAGE: 407,
	CONFIG_DIFF_COMPAREMODE: 408,
	CONFIG_GRAPHOLAS_CENTERLINE: 409,
	CONFIG_GRAPHOLAS_MICROCROSS: 410,

	//  500: caliper tool count
	//  501: caliper tool first entry

	/**
	 * HTML5 Viewer settings 1000 and more
	 */
	// Layout state
	LAYOUT_STATE: 1000,
	LAYOUT_PREFERENCE: 1010,

	// Caliper presets
	CALIPER_PRESETS: 1100,

	// Eye dropper units
	PREFERENCES_UNIT_EYEDROPPER: 1200, // not persisted
	// Screen ruling unit (lpmm, lpcm, lpi)
	PREFERENCES_UNIT_SCREENRULING: 1201, // persisted

	ANNOTATION_FILTER: 1300,
	PREFERENCES_DIFFMODE_THRESHOLD: 1400,
	PREFERENCES_DYNCONTENTTOOLS_VISIBLE: 1500,
	PREFERENCES_SHOW_ALL_ANNOTATION_POPUPS: 1600,
	PREFERENCES_VIDEO_AUTO_PLAY: 1700,
	PREFERENCES_VIDEO_LOOP: 1800,
	PREFERENCES_VIDEO_VOLUME: 1900,
	PREFERENCES_VIDEO_TRANSCODING: 2000,
	PREFERENCES_VIEW3D_CAMERA_LOCK_LIVE: 2100
};
