/**
 * @namespace Data
 */
/**
 * @namespace Data
 */
var AbstractPrintDataAdapter = function(f) {
	/**
	 * @protected
	 */
	this.f = f;
};

/**
 * Print the annotations overview
 * @private
 */
AbstractPrintDataAdapter.prototype.printAnnotations = function(printModel) {
	//to be implemented
	throw "Not Implemented: printAnnotations";
};

/**
 * Print the image area
 * @private
 */
AbstractPrintDataAdapter.prototype.printImageArea = function(printModel) {
	//to be implemented
	throw "Not Implemented: printImageArea";
};

/**
 * @returns {Boolean} whether or not the annotation overview options should be avaiulable
 */
AbstractPrintDataAdapter.prototype.showPrintAnnotationOverview = function() {
	return false;
};

export default AbstractPrintDataAdapter;
