import Renderer from "@esko/xdrop/renderers/Renderer";
import $ from "jquery";
/**
 * @class SeparatorRenderer
 *
 * @class
 * @augments Renderer
 * @param {JQueryObj}   div
 * @param {ResultEntry} resultEntry
 * @param {Object}      api        -  render API
 */
var SeparatorRenderer = function(div, resultEntry, api) {
	Renderer.call(this, div, resultEntry, api);

	this._element.addClass("XDropSeparatorEntry");
};

SeparatorRenderer.prototype = Object.create(Renderer.prototype);
SeparatorRenderer.prototype.constructor = SeparatorRenderer;

export default {
	make: function(div, resultEntry, api) {
		return new SeparatorRenderer(div, resultEntry, api);
	}
};
